module.exports = function () {
    var surveyService = require('../../services/admin/surveyService')
    // require('../utils/error.js')()
    var surveyServiceObject = new surveyService()

    const STRINGS = require('../../strings.json')


    this.addOneSurveyController = async (req, callback) => {
        var response = {}
        try {
            var addOneSurveyService = await surveyServiceObject.addOneSurveyService(req)
            if (addOneSurveyService.error) {
                response.error = true
                response.statusCode = addOneSurveyService.statusCode
                response.message = addOneSurveyService.message
            } else {
                response.error = addOneSurveyService.error
                response.statusCode = addOneSurveyService.statusCode
                response.message = addOneSurveyService.message
                response.data = addOneSurveyService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.getSurveyListController = async (req, callback) => {
        var response = {}
        try {
            var getSurveyListService = await surveyServiceObject.getSurveyListService(req)
            if (getSurveyListService.error) {
                response.error = true
                response.statusCode = getSurveyListService.statusCode
                response.message = getSurveyListService.message
            } else {
                response.error = getSurveyListService.error
                response.statusCode = getSurveyListService.statusCode
                response.totalPages = getSurveyListService.totalPages
                response.message = getSurveyListService.message
                response.data = getSurveyListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.viewOneSurveyController = async (req, callback) => {
        var response = {}
        try {
            var viewOneSurveyService = await surveyServiceObject.viewOneSurveyService(req)
            if (viewOneSurveyService.error) {
                response.error = true
                response.statusCode = viewOneSurveyService.statusCode
                response.message = viewOneSurveyService.message
            } else {
                response.error = viewOneSurveyService.error
                response.statusCode = viewOneSurveyService.statusCode
                response.message = viewOneSurveyService.message
                response.data = viewOneSurveyService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.editOneSurveyController = async (req, callback) => {
        var response = {}
        try {
            var editOneSurveyService = await surveyServiceObject.editOneSurveyService(req)
            if (editOneSurveyService.error) {
                response.error = true
                response.statusCode = editOneSurveyService.statusCode
                response.message = editOneSurveyService.message
            } else {
                response.error = editOneSurveyService.error
                response.statusCode = editOneSurveyService.statusCode
                response.message = editOneSurveyService.message
                response.data = editOneSurveyService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.deleteOneSurveyController = async (req, callback) => {
        var response = {}
        try {
            var deleteOneSurveyService = await surveyServiceObject.deleteOneSurveyService(req)
            if (deleteOneSurveyService.error) {
                response.error = true
                response.statusCode = deleteOneSurveyService.statusCode
                response.message = deleteOneSurveyService.message
            } else {
                response.error = deleteOneSurveyService.error
                response.statusCode = deleteOneSurveyService.statusCode
                response.message = deleteOneSurveyService.message
                response.data = deleteOneSurveyService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


}