const Chat = require('../../modal/web/conversationModel');
const User = require('../../modal/web/MyProfileModal');
var ObjectId = require('mongodb').ObjectId;

const common = require('../../utils/common')
var commonObject = new common()
const fetchChat = async (req, res, next) => {
    try {
      var getBlockedUsers = await commonObject.getBlockedUsers(req.body)
    const conversation = await Chat.Conversation.aggregate([
      { $match : 
        { users: {$in : [req.body.uid],$nin: [...getBlockedUsers[0],...getBlockedUsers[1]]}}
      },
      {
        "$lookup": {
            "from": "userprofiles",
            "localField": "users",
            "foreignField": "uid",
            "as": "userProfile"
        },
      
    },
    {
      $lookup: {
        from: 'messages',
        let: { chatId: '$_id' },
        pipeline: [
          {
            $match: {
              $expr: {
                $and: [
                  { $eq: ['$chatId', '$$chatId'] },
                  { $eq: ['$read', false] },
                  { $ne: ["$sender", req.body.uid] },
                ],
              },
            },
          },
          { $count: 'unread' },
        ],
        as: 'unreadCount',
      },
    },
    {$sort:{
      latestMessageTime:-1
    }},
     {
          "$project": {
            "userProfile": {
              "uid": 1,
              "full_name": 1,
              "profile_photo":1,
            },
            "latestMessage" : 1,
            "latestMessageTime":1,
            "lastMessageMediatype":1,
            "lastMessageMediaUrl":1,
            "createdAt" : 1,
            "unreadCount": { $arrayElemAt: ['$unreadCount.unread', 0] },

          }
        }  
      ])
      // console.log(conversation)

    if(conversation.length >= 1){
      const data =  conversation.map((item) => {
        if(item.userProfile[0].uid == req.body.uid){
          item.userProfile.shift()
          return item
        }
        if(item.userProfile[1].uid == req.body.uid){
          item.userProfile.pop()
          return item
        }
      })
      res.status(200).send({"error" :false,conversation : data});
    }else{
      res.status(200).send({"error" :false,conversation : []});
    }
  } catch (err) {
    res.status(400).json(err);
  }
}

const accessChat = async (req, res, next) => {
  const {uid, receiverId} = req.body;
  if (!receiverId) {
    return res.status(400).send('userId not found');
  }
  let isChat = await Chat.Conversation.aggregate([
    { $match : 
      {$and: [
            {users: {$elemMatch: {$eq: uid}}},
            {users: {$elemMatch: {$eq: receiverId}}},
      ]}
    },
    {
      "$lookup": {
          "from": "userprofiles",
          "localField": "users",
          "foreignField": "uid",
          "as": "userProfile"
      },
    
  },
   {
        "$project": {
          "userProfile": {
            "uid": 1,
            "full_name": 1,
            "profile_photo":1,
            "province" : 1
          },
        }
      }  
    ])
  
  
  // find({
  //   isGroupChat: false,
  //   $and: [
  //     {users: {$elemMatch: {$eq: uid}}},
  //     {users: {$elemMatch: {$eq: receiverId}}},
  //   ],
  // }).select('-updatedAt')
    // .populate('users','full_name profile_photo')
    // .populate('latestMessage');

  // isChat = await User.populate(isChat, {
  //   path: 'latestMessage.sender',
  //   select: 'full_name profile_photo',
  // });
  if (isChat.length > 0) {
    res.status(200).send({error:false, message:'conversation already created', conversations : isChat[0]});
  } else {
    let conversation = await new Chat.Conversation({
    users:[req.body.uid, req.body.receiverId],
  });
   let newConversation = await conversation.save()
   newConversation = await Chat.Conversation.aggregate([
      { $match : 
        { _id:  newConversation._id}
      },
      {
        "$lookup": {
            "from": "userprofiles",
            "localField": "users",
            "foreignField": "uid",
            "as": "userProfile"
        },
      
    },
     {
          "$project": {
            "userProfile": {
              "uid": 1,
              "full_name": 1,
              "profile_photo":1,
            },
          }
        }  
      ])
    if (!newConversation) return res.status(400).send('the user cannot be created!');
    res.send({
      error:false,
      message:'new conversation created',
      conversations : newConversation[0],
    });
  }
};



module.exports = {
  accessChat,
  fetchChat,
};
