const Chat = require('../../modal/web/conversationModel');
const User = require('../../modal/web/MyProfileModal');
const Message = require('../../modal/web/messageModal');
//

const GroupChatDao = require('../../dao/web/GroupChatDao')
const MyProfileDao = require('../../dao/web/MyProfileDao')

const GroupChatDaoObject = new GroupChatDao()
const MyprofileObject = new MyProfileDao()

var ObjectId = require('mongodb').ObjectId;
var common = require('../../utils/common')
const commonFunction=new common()


// var notificationController = require('../../controller/web/notificationController')



const allMessages = async (req, res) => {
  const { chatId, page_number } = req.body

  try {
    // let message = await Message.Message.find({chatId:chatId}).populate("chatId","users")
    // res.send({messages:message})

    let messageCount = await Message.Message.find({ chatId: chatId }).count();
    let totalPages = messageCount / 10;

    let messages = await Message.Message.aggregate([
      // {"$match":{"chatId":{"$in":[1,"default"]}}},
      {
        "$match": {
          chatId: ObjectId(chatId)
        },
      },
      {
        "$lookup": {
          "from": "userprofiles",
          "localField": "sender",
          "foreignField": "uid",
          "as": "sender"
        },
      },
      {
        "$lookup": {
          "from": "conversations",
          "localField": "chatId",
          "foreignField": "_id",
          "as": "chat"
        },
      },
      {
        "$sort": {
          "createdAt": -1,
        },
      },
      {
        "$skip": req.body.page_number > 0 ? (req.body.page_number - 1) * 10 : 0,
      },
      {
        "$limit": 10,
      },
      {
        "$project": {
          "sender": {
            "uid": 1,
            "full_name": 1,
            "profile_photo": 1,
          },
          "chat": {
            "users": 1,
          },
          "message": 1,
          "media_type": 1,
          "media_url": 1,
          "chatId": 1,
          "createdAt": 1
        }
      }
    ])
    //   console.log(messages)
    // messages = await messages.find({chatId : chatId})
    var readTrue=await Message.Message.updateMany(
      { chatId: ObjectId(chatId),read:false },
      { $set: { read:true} }
      )
      if (readTrue.error) {
        // console.log("allMessagesRead", readTrue)
        res.status(400).send({ messgae: 'error in readMessage' });
      } else {
        // res.send({ messages: 'success'});
      }
   
    res.send({ totalPages: Math.ceil(totalPages), messages: messages });
  } catch (error) {
    res.status(400);
    // throw new Error(error.message);
  }
};

const allMessagesRead = async (chatId) => {
  // console.log("allMessagesRead", chatId)

  try {
   
      var readTrue=await Message.Message.updateMany(
        { chatId: ObjectId(chatId),read:false },
        { $set: { read:true} }
        )
        // console.log("allMessagesRead", readTrue)
        if (readTrue.error) {
          // console.log("allMessagesRead", readTrue)
          // res.status(400).send({ messgae: 'error in response' });
        } else {
          // res.send({ messages: 'success'});
        }
      }
      catch (e) {
        console.log("error", e)
      }
  
};

const sendMessage = async (req, res, next) => {
  console.log("conversationsReqBody",req.body)
  const { message, chatId, uid, media_type, media_url } = req.body;
  if ((!message && !media_url) || !chatId) {
    res.sendStatus(400).send({ message: 'invalid data' });
  }
  let payload = {
    sender: uid,
    message: message,
    chatId: chatId,
    media_type: media_type,
    media_url: media_url
  };
  try {
    let newMessage = await Message.Message(payload);
    newMessage = await newMessage.save();
    console.log(">>>>>>>>>>>>", newMessage)
    newMessage = await Message.Message.aggregate([
      {
        $match:
          { _id: newMessage._id }
      },
      {
        "$lookup": {
          "from": "userprofiles",
          "localField": "sender",
          "foreignField": "uid",
          "as": "sender"
        },

      },
      {
        "$lookup": {
          "from": "conversations",
          "localField": "chatId",
          "foreignField": "_id",
          "as": "chat"
        },
      },
      {
        "$project": {
          "sender": {
            "uid": 1,
            "full_name": 1,
            "profile_photo": 1,
          },
          "chat": {
            "users": 1,
          },
          "user": {
            "full_name": 1
          },
          "message": 1,
          "media_type": 1,
          "media_url": 1,
          "createdAt": 1,
          "chatId": 1
        }
      }
    ])

    await Chat.Conversation.findByIdAndUpdate(req.body.chatId, {
      latestMessage: message,
      latestMessageTime:new Date(),
      lastMessageMediatype:req.body.media_type,
      lastMessageMediaUrl:req.body.media_url
    })
    // console.log('printMessage', newMessage, newMessage[0].chat[0].users[0])
    var objRes = {}
    objRes.conversationId = req.body.chatId,
      objRes.uid = newMessage[0].chat[0].users[0],
      objRes.sender = uid
    objRes.user_name = newMessage[0].sender[0].full_name
    objRes.notification_message = message,
      objRes.post_module = 'chat',
      objRes.media_type = media_type,
      objRes.media_url = media_url
      const recipientUsers = newMessage[0].chat[0].users.filter(user => user !== uid);
      // const message=   your_custom_data_key: data.id,
      // title: data.title,
      // body: data.body,
      // userId: data.userId,
      // bookingId: data.bookingId,
      // type: data.type
      
      // deviceToken get method
      var getOneProfile = await MyprofileObject.getOneProfileDao({user_id:objRes.uid})
      objRes.device_token=getOneProfile.data.device_token

      // fcm notification
      var tokendata = await commonFunction.sendNotification(objRes)
      console.log("tokendata",tokendata,"getOneProfile",getOneProfile)

      recipientUsers.forEach(user => {
        // global.io.to(user.socketId).emit('newMessage', objRes);
    console.log('printMessage', user)
        global.io.emit(user, JSON.stringify(objRes))
      });
      

      res.json({ messages: newMessage });
   
  } catch (e) {
    console.log(e)
    res.status(400).send({ messgae: 'message cannot be sent' });
  }
};

module.exports = {
  sendMessage,
  allMessages,
  allMessagesRead
};
