module.exports = function () {
    var homeController = require('../../services/web/WhatsUpService')
    // require('../utils/error.js')()
    var homeControllerObject = new homeController()

    const STRINGS = require('../../strings.json')


    this.WhatsUpCanadaHomeController = async (req, callback) => {
        var response = {}
        try {
            var WhatsUpCanadaHomeService = await homeControllerObject.WhatsUpCanadaHomeService(req)
            if (WhatsUpCanadaHomeService.error) {
                response.error = true
                response.statusCode = WhatsUpCanadaHomeService.status
                response.message = WhatsUpCanadaHomeService.message
            } else {
                response.error = WhatsUpCanadaHomeService.error
                response.statusCode = WhatsUpCanadaHomeService.statusCode
                response.message = WhatsUpCanadaHomeService.message
                response.totalArticlePages = WhatsUpCanadaHomeService.totalArticlePages
                response.data = WhatsUpCanadaHomeService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.viewOneArticleController = async (req, callback) => {
        var response = {}
        try {
            var viewOneArticleService = await homeControllerObject.viewOneArticleService(req)
            if (viewOneArticleService.error) {
                response.error = true
                response.statusCode = viewOneArticleService.status
                response.message = viewOneArticleService.message
            } else {
                response.error = viewOneArticleService.error
                response.statusCode = viewOneArticleService.statusCode
                response.message = viewOneArticleService.message
                response.data = viewOneArticleService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.viewPodcastController = async (req, callback) => {
        var response = {}
        try {
            var viewPodcastService = await homeControllerObject.viewPodcastService(req)
            if (viewPodcastService.error) {
                response.error = true
                response.statusCode = viewPodcastService.status
                response.message = viewPodcastService.message
            } else {
                response.error = viewPodcastService.error
                response.statusCode = viewPodcastService.statusCode
                response.message = viewPodcastService.message
                response.data = viewPodcastService.data
                response.podcastEpisodesList = viewPodcastService.podcastEpisodesList
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.relatedPodcastListController = async (req, callback) => {
        var response = {}
        try {
            var relatedPodcastListService = await homeControllerObject.relatedPodcastListService(req)
            if (relatedPodcastListService.error) {
                response.error = true
                response.statusCode = relatedPodcastListService.status
                response.message = relatedPodcastListService.message
            } else {
                response.error = relatedPodcastListService.error
                response.statusCode = relatedPodcastListService.statusCode
                response.message = relatedPodcastListService.message
                response.data = relatedPodcastListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.relatedArticleListController = async (req, callback) => {
        var response = {}
        try {
            var relatedArticleListService = await homeControllerObject.relatedArticleListService(req)
            if (relatedArticleListService.error) {
                response.error = true
                response.statusCode = relatedArticleListService.status
                response.message = relatedArticleListService.message
            } else {
                response.error = relatedArticleListService.error
                response.statusCode = relatedArticleListService.statusCode
                response.message = relatedArticleListService.message
                response.data = relatedArticleListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.getArticleListController = async (req, callback) => {
        var response = {}
        try {
            var ArticleListService = await homeControllerObject.getArticleListService(req)
            if (ArticleListService.error) {
                response.error = true
                response.statusCode = ArticleListService.status
                response.message = ArticleListService.message
            } else {
                response.error = ArticleListService.error
                response.statusCode = ArticleListService.statusCode
                response.message = ArticleListService.message
                response.totalArticlePages = ArticleListService.totalArticlePages

                response.data = ArticleListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.getProudlyPinoyListController = async (req, callback) => {
        var response = {}
        try {
            var ProudlyPinoyListService = await homeControllerObject.getProudlyPinoyListService(req)
            if (ProudlyPinoyListService.error) {
                response.error = true
                response.statusCode = ProudlyPinoyListService.status
                response.message = ProudlyPinoyListService.message
            } else {
                response.error = ProudlyPinoyListService.error
                response.statusCode = ProudlyPinoyListService.statusCode
                response.message = ProudlyPinoyListService.message
                response.totalProudlyPinoyPages = ProudlyPinoyListService.totalProudlyPinoyPages

                response.data = ProudlyPinoyListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.getPodcastListController = async (req, callback) => {
        var response = {}
        try {
            var PodcastListService = await homeControllerObject.getPodcastListService(req)
            if (PodcastListService.error) {
                response.error = true
                response.statusCode = PodcastListService.status
                response.message = PodcastListService.message
            } else {
                response.error = PodcastListService.error
                response.statusCode = PodcastListService.statusCode
                response.message = PodcastListService.message
                response.totalPodcastPages = PodcastListService.totalPodcastPages

                response.data = PodcastListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.getVideosFeedListController = async (req, callback) => {
        var response = {}
        try {
            var VideosFeedListService = await homeControllerObject.getVideosFeedListService(req)
            if (VideosFeedListService.error) {
                response.error = true
                response.statusCode = VideosFeedListService.status
                response.message = VideosFeedListService.message
            } else {
                response.error = VideosFeedListService.error
                response.statusCode = VideosFeedListService.statusCode
                response.message = VideosFeedListService.message
                response.totalVideosFeedPages = VideosFeedListService.totalVideosFeedPages

                response.data = VideosFeedListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }
}