module.exports = function () {
    var bazaarCityService = require('../../services/web/bazaarCityService')
    // require('../utils/error.js')()
    var bazaarCityServiceObject = new bazaarCityService()

    const STRINGS = require('../../strings.json')


    this.addBazaarCityItemController = async (req, callback) => {
        var response = {}
        try {
            var addBazaarCityItemService = await bazaarCityServiceObject.addBazaarCityItemService(req)
            if (addBazaarCityItemService.error) {
                response.error = true
                response.statusCode = addBazaarCityItemService.statusCode
                response.message = addBazaarCityItemService.message
            } else {
                response.error = addBazaarCityItemService.error
                response.statusCode = addBazaarCityItemService.statusCode
                response.message = addBazaarCityItemService.message
                response.data = addBazaarCityItemService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.GetBazaarCityListController = async (req, callback) => {
        var response = {}
        try {
            var GetBazaarCityListService = await bazaarCityServiceObject.GetBazaarCityListService(req)
            if (GetBazaarCityListService.error) {
                response.error = true
                response.statusCode = GetBazaarCityListService.statusCode
                response.message = GetBazaarCityListService.message
            } else {
                response.error = GetBazaarCityListService.error
                response.statusCode = GetBazaarCityListService.statusCode
                response.message = GetBazaarCityListService.message
                response.totalPages = GetBazaarCityListService.totalPages
                response.data = GetBazaarCityListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.GetOneBazaarCityPostController = async (req, callback) => {
        var response = {}
        try {
            var GetOneBazaarCityPostService = await bazaarCityServiceObject.GetOneBazaarCityPostService(req)
            if (GetOneBazaarCityPostService.error) {
                response.error = true
                response.statusCode = GetOneBazaarCityPostService.statusCode
                response.message = GetOneBazaarCityPostService.message
            } else {
                response.error = GetOneBazaarCityPostService.error
                response.statusCode = GetOneBazaarCityPostService.statusCode
                response.message = GetOneBazaarCityPostService.message
                response.data = GetOneBazaarCityPostService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.PostSchduleLiveController = async (req, callback) => {
        var response = {}
        try {
            var PostSchduleLiveService = await bazaarCityServiceObject.PostSchduleLiveService(req)
            if (PostSchduleLiveService.error) {
                response.error = true
                response.statusCode = PostSchduleLiveService.statusCode
                response.message = PostSchduleLiveService.message
            } else {
                response.error = PostSchduleLiveService.error
                response.statusCode = PostSchduleLiveService.statusCode
                response.message = PostSchduleLiveService.message
                response.data = PostSchduleLiveService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }



    this.GetAllScheduleLiveListController = async (req, callback) => {
        var response = {}
        try {
            var GetAllScheduleLiveListService = await bazaarCityServiceObject.GetAllScheduleLiveListService(req)
            if (GetAllScheduleLiveListService.error) {
                response.error = true
                response.statusCode = GetAllScheduleLiveListService.statusCode
                response.message = GetAllScheduleLiveListService.message
            } else {
                response.error = GetAllScheduleLiveListService.error
                response.statusCode = GetAllScheduleLiveListService.statusCode
                response.message = GetAllScheduleLiveListService.message
                response.totalPages = GetAllScheduleLiveListService.totalPages
                response.data = GetAllScheduleLiveListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }





    this.slotTimeListController = async (req, callback) => {
        var response = {}
        try {
            var slotTimeListService = await bazaarCityServiceObject.slotTimeListService(req)
            if (slotTimeListService.error) {
                response.error = true
                response.statusCode = slotTimeListService.statusCode
                response.message = slotTimeListService.message
            } else {
                response.error = slotTimeListService.error
                response.statusCode = slotTimeListService.statusCode
                response.message = slotTimeListService.message
                response.data = slotTimeListService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }

    this.postSlotController = async (req, callback) => {
        var response = {}
        try {
            var postSlotService = await bazaarCityServiceObject.postSlotService(req)
            if (postSlotService.error) {
                response.error = true
                response.statusCode = postSlotService.statusCode
                response.message = postSlotService.message
            } else {
                response.error = false
                response.statusCode = postSlotService.statusCode
                response.message = postSlotService.message
                response.data = postSlotService.data
            }
            callback(response)
        } catch (e) {
            console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }


    this.GetOneScheduleLiveController = async (req, callback) => {
        var response = {}
        try {
            var GetOneScheduleLiveService = await bazaarCityServiceObject.GetOneScheduleLiveService(req)
            if (GetOneScheduleLiveService.error) {
                response.error = true
                response.statusCode = GetOneScheduleLiveService.statusCode
                response.message = GetOneScheduleLiveService.message
            } else {
                response.error = GetOneScheduleLiveService.error
                response.statusCode = GetOneScheduleLiveService.statusCode
                response.message = GetOneScheduleLiveService.message
                response.data = GetOneScheduleLiveService.data
            }
            callback(response)
        } catch (e) {
            // console.log(e)
            response.error = true
            response.statusCode = STRINGS.errorStatusCode
            response.message = STRINGS.oopsErrorMessage
            callback(response)
        }
    }











}