module.exports = function () {
    var AdModel = require('../../modal/admin/adModel')
    var adsAssignedModel = require('../../modal/admin/adsAssignedModel')
    var MyProfileModal = require('../../modal/web/MyProfileModal')
    var AdViewersModel = require('../../modal/admin/adViewersModel')



    // var UserAdModel = require('../../modal/web/UserAdModel')
    var ObjectId = require('mongodb').ObjectId;
  
  
    this.listAdDaoCount = async (data) => {
        var response = {}
      
      return new Promise(function (resolve, reject) {
        AdModel.find({isActive:1}).count()
          // .sort({ createdAt: 'desc' })
          // .skip(data.page_number * data.limit)
          // .limit(data.limit).lean()
          .then((result) => {
            response.error = false
            response.data = result
            resolve(response)
  
          })
          .catch((error) => {
            response.error = true
            resolve(response)
  
            console.log(error);
          });
      })
    }
    
    this.listAllUsersDaoCount = async (data) => {
      var response = {}
    
    return new Promise(function (resolve, reject) {
      MyProfileModal.find({}).count()
        // .sort({ createdAt: 'desc' })
        // .skip(data.page_number * data.limit)
        // .limit(data.limit).lean()
        .then((result) => {
          response.error = false
          response.data = result
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.listAllUsersDao = async (data) => {
    var response = {}
  
  return new Promise(function (resolve, reject) {
    MyProfileModal.find({})
      .sort({ createdAt: 'desc' })
      .skip(data.page_number * data.limit)
      .limit(data.limit).lean()
      .then((result) => {
        response.error = false
        response.data = result
        resolve(response)

      })
      .catch((error) => {
        response.error = true
        resolve(response)

        console.log(error);
      });
  })
}

this.viewAdDaoCount = async (data) => {
  var response = {}

return new Promise(function (resolve, reject) {
  adsAssignedModel.find({adId:ObjectId(data.adId)}).count()
    // .sort({ createdAt: 'desc' })
    // .skip(data.page_number * data.limit)
    // .limit(data.limit).lean()
    .then((result) => {
      response.error = false
      response.data = result
      resolve(response)

    })
    .catch((error) => {
      response.error = true
      resolve(response)

      console.log(error);
    });
})
}
this.viewAdDao = async (data) => {
var response = {}

return new Promise(function (resolve, reject) {
  adsAssignedModel.find({adId:ObjectId(data.adId)})
  .sort({ createdAt: 'desc' })
  .skip(data.page_number * data.limit)
  .limit(data.limit).lean()
  .then((result) => {
    response.error = false
    response.data = result
    resolve(response)

  })
  .catch((error) => {
    response.error = true
    resolve(response)

    console.log(error);
  });
})
}
    this.listAdDao = async (data) => {
        var response = {}
  
      return new Promise(function (resolve, reject) {
        AdModel.find({isActive:1})
          .sort({ createdAt: 'desc' })
          .skip(data.page_number * data.limit)
          .limit(data.limit).lean()
          .then((result) => {
            response.error = false
            response.data = result
            resolve(response)
            // console.log('listAdDaooutput', result);
  
          })
          .catch((error) => {
            response.error = true
            resolve(response)
  
            console.log(error);
          });
      })
    }
  
  
  
    this.deleteAdDao = async (data) => {
      var response = {}
  
      return new Promise(function (resolve, reject) {
        AdModel.updateOne(
          {
            _id: ObjectId(data.adId),
            },
          {
            $set:{
              isActive:0
            }
          }
          ).
          then((result) => {
            response.error = false
            response.data = result
            // console.log("viewAdDaoresponse",result);
            resolve(response)
          }).catch((error) => {
            response.error = true
            resolve(response)
            console.log(error);
          })
      })
    }
  
    
    this.editAdDao = async (data) => {
      var response = {}
  
      return new Promise(function (resolve, reject) {
        AdModel.updateOne(
            {
              _id: ObjectId(data.adId),
              },
            {
              $set:{
                "adUrl":data.adUrl,
                "mediaType":data.mediaType,
                "link":data.link,
                "location":data.location,
                "title":data.title,
                type:data.type
              }
            }
          ).
          then((result) => {
            response.error = false
            response.data = result
            // console.log("viewAdDaoresponse",result);
            resolve(response)
          }).catch((error) => {
            response.error = true
            resolve(response)
            console.log(error);
          })
      })
    }
  
    
    this.postAddDao = async (data) => {
      // console.log('userInput', data)
      var response = {}
      return new Promise(function (resolve, reject) {
          const AdModelObject = new AdModel(data)
          AdModelObject.save(function (error, result) {
              if (error) {
                  console.log(error)
                  response.error = true
              } else {
                  response.error = false
                  response.data = result
              }
              resolve(response)
          })
      })
  }
  
  this.assignAdDao = async (data) => {
    // console.log('userInput', data)
    var response = {}
    return new Promise(function (resolve, reject) {
        const AdModelObject = new adsAssignedModel(data)
        AdModelObject.save(function (error, result) {
            if (error) {
                console.log(error)
                response.error = true
            } else {
                response.error = false
                response.data = result
            }
            resolve(response)
        })
    })
}

function getYearMonths(year) {
  const months = [];
  for (let i = 1; i <= 12; i++) {
    const month = i.toString().padStart(2, '0'); // zero-padding month number
    const date = `${year}-${month}`;
    months.push(date);
  }
  return months;
}
// adAnalytics
this.adAnalyticsViewDao = async (data) => {
  const yearMonths = getYearMonths(data.year);
// console.log(yearMonths,"yearMonths");
  // console.log('input', data)
  var response = {}

  try {
      const result = await AdViewersModel.aggregate(
        [
          {
            $match: {
              adId: ObjectId(data.adId),
              type:"view",
              isActive:1,
            },
          },
          {
            $group: {
              _id: {
                $dateToString: {
                  format: "%Y-%m",
                  date: "$viewedAt",
                },
              },
              count: { $sum: 1 },
            },
          },
          {
            $sort: { _id: 1 },
          },
          {
            $group: {
              _id: null,
              counts: {
                $push: {
                  month: "$_id",
                  count: "$count",
                },
              },
              totalCount: { $sum: "$count" },
            },
          },
          {
            $project: {
              _id: 0,
              counts: {
                $map: {
                  input: yearMonths,
                  as: "month",
                  in: {
                    $let: {
                      vars: {
                        matchIndex: {
                          $indexOfArray: [
                            "$counts.month",
                            "$$month",
                          ],
                        },
                      },
                      in: {
                        month: "$$month",
                        count: {
                          $cond: {
                            if: {
                              $eq: ["$$matchIndex", -1],
                            },
                            then: 0,
                            else: {
                              $arrayElemAt: [
                                "$counts.count",
                                "$$matchIndex",
                              ],
                            },
                          },
                        },
                      },
                    },
                  },
                },
              },
              // totalCount: 1,
              totalViewCount: {
                $reduce: {
                  input: "$counts",
                  initialValue: 0,
                  in: { $add: ["$$value", "$$this.count"] },
                },
              },
            },
          },
        ])
      response.error = false;
      console.log(result,"resuklt")
      response.result = result;
      return response;
  } catch (error) {
      console.log(error)
      response.error = true;
      return response;
  }
}


this.adAnalyticsClickDao = async (data) => {
  const yearMonths = getYearMonths(data.year);
// console.log(yearMonths,"yearMonths");
  // console.log('input', data)
  var response = {}

  try {
      const result = await AdViewersModel.aggregate(
        [
          {
            $match: {
              adId: ObjectId(data.adId),
              type:"click",
              isActive:1,
            },
          },
          {
            $group: {
              _id: {
                $dateToString: {
                  format: "%Y-%m",
                  date: "$viewedAt",
                },
              },
              count: { $sum: 1 },
            },
          },
          {
            $sort: { _id: 1 },
          },
          {
            $group: {
              _id: null,
              counts: {
                $push: {
                  month: "$_id",
                  count: "$count",
                },
              },
            },
          },
          {
            $project: {
              _id: 0,
              counts: {
                $map: {
                  input: yearMonths,
                  as: "month",
                  in: {
                    $let: {
                      vars: {
                        matchIndex: {
                          $indexOfArray: [
                            "$counts.month",
                            "$$month",
                          ],
                        },
                      },
                      in: {
                        month: "$$month",
                        count: {
                          $cond: {
                            if: {
                              $eq: ["$$matchIndex", -1],
                            },
                            then: 0,
                            else: {
                              $arrayElemAt: [
                                "$counts.count",
                                "$$matchIndex",
                              ],
                            },
                          },
                        },
                      },
                    },
                  },
                },
              },
              totalClickCount: {
                $reduce: {
                  input: "$counts",
                  initialValue: 0,
                  in: { $add: ["$$value", "$$this.count"] },
                },
              },
            },
          },
        ])
      response.error = false;
      console.log(result,"resuklt")
      response.result = result;
      return response;
  } catch (error) {
      console.log(error)
      response.error = true;
      return response;
  }
}



  }

  