module.exports = function () {
  var CouponModel = require('../../modal/web/CouponModel')
  var UserCouponModel = require('../../modal/web/UserCouponModel')


  //returns the prev date

  // this.listCouponDaoCount = async (data) => {
  //   var response = {}

  //   return new Promise(function (resolve, reject) {
  //     CouponModel.find({}).then((result) => {
  //       response.error = false
  //       response.data = result
  //       resolve(response)

  //     })
  //       .catch((error) => {
  //         response.error = true
  //         resolve(response)

  //         console.log(error);
  //       });
  //   })
  // }

  this.listCouponDaoCount = async (data) => {
    const today = new Date()

    // to return the date number(1-31) for the specified date
    var a = today.toISOString().substring(0, 10);
    var b = new Date(a)
    // console.log("today => ", b)

    var tomorrow = new Date(a)

    tomorrow.setDate(b.getDate() - 1)

    var response = {}
    if (data.filter_type == 'all') {
      var filter = [{
        '$lookup': {
          'from': 'userprofiles',
          'localField': 'uid',
          'foreignField': 'uid',
          'as': 'profileDetails'
        }
      },
      ]
    } else if (data.filter_type == 'active') {
      var filter = [

        {
          '$match': {
            'coupon_validity_to': { $gt: tomorrow }
          }
        },

      ]
    } else if (data.filter_type == 'expired') {
      var filter = [

        {
          '$match': {
            'coupon_validity_to': { $lte: tomorrow }
          }
        },

      ]
    }


    return new Promise(function (resolve, reject) {
      CouponModel.aggregate(filter)
        // .sort({ createdAt: 'desc' })
        // .skip(data.page_number * data.limit)
        // .limit(data.limit).lean()
        .then((result) => {
          response.error = false
          response.data = result
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.dateValidations = async (data) => {
    var response = {}
    // console.log(new Date().toJSON().split("T")[0],"datenfjerf")
    return new Promise(function (resolve, reject) {
      CouponModel.find({
        $and: [{
          coupon_id: data.coupon_id
        }, {
          coupon_validity_to: { $gte: new Date().toJSON().split("T")[0] }
          // coupon_validity_to: { $gt: tomorrow }
        }, {
          claimed_coupons: { $lt: data.total_Number_of_coupons }
        }]
      }).lean().then((result) => {
        response.error = false
        response.data = result
        resolve(response)

      })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  // this.downloadCount = async (data) => {
  //   var response = {}
  //   return new Promise(function (resolve, reject) {
  //     UserCouponModel.find({
  //         coupon_id: data.coupon_id
  //     }).lean().then((result) => {
  //         response.error = false
  //         response.data = result
  //         resolve(response)

  //       })
  //       .catch((error) => {
  //         response.error = true
  //         resolve(response)

  //         console.log(error);
  //       });
  //   })
  // }

  this.listCouponDao = async (data) => {
    // console.log('listCouponDaoinput', data);
    const today = new Date()

    // to return the date number(1-31) for the specified date
    var a = today.toISOString().substring(0, 10);
    var b = new Date(a)
    // console.log("today => ", b)

    var tomorrow = new Date(a)

    tomorrow.setDate(b.getDate() - 1)
    var response = {}
    if (data.filter_type == 'all') {
      var filter = [

        {
          '$lookup': {
            'from': 'userprofiles',
            'localField': 'uid',
            'foreignField': 'uid',
            'as': 'profileDetails'
          }
        }, {
          '$unwind': {
            'path': '$profileDetails'
          }
        },
        { '$sort': { createdAt: -1 } },
        { '$skip': data.page_number * data.limit },
        { '$limit': data.limit },
        {
          '$project': {
            '_id': 1,
            'uid': 1,
            "coupon_image": 1,
            'coupon_name': 1,
            'coupon_id': 1,
            'coupon_description': 1,
            'offer_type': 1,
            'offer_value': 1,
            'total_Number_of_coupons': 1,
            'usage_limit_per_user': 1,
            'coupon_validity_from': 1,
            'coupon_validity_to': 1,
            'province': 1,
            'terms_and_condition': 1,
            'claimed_coupons': 1,
            'createdAt': 1,
            'profileDetails.full_name': 1,
            'profileDetails.eMail_id': 1,
            'downloaded_coupons': 1
          }
        }
      ]
    } else if (data.filter_type == 'active') {
      var filter = [
        {
          '$match': {
            'coupon_validity_to': { $gt: tomorrow }
          }
        },
        {
          '$lookup': {
            'from': 'userprofiles',
            'localField': 'uid',
            'foreignField': 'uid',
            'as': 'profileDetails'
          }
        }, {
          '$unwind': {
            'path': '$profileDetails'
          }
        },
        { '$sort': { createdAt: -1 } },
        { '$skip': data.page_number * data.limit },
        { '$limit': data.limit },
        {
          '$project': {
            '_id': 1,
            'uid': 1,
            "coupon_image": 1,
            'coupon_name': 1,
            'coupon_id': 1,
            'coupon_description': 1,
            'offer_type': 1,
            'offer_value': 1,
            'total_Number_of_coupons': 1,
            'usage_limit_per_user': 1,
            'coupon_validity_from': 1,
            'coupon_validity_to': 1,
            'province': 1,
            'terms_and_condition': 1,
            'claimed_coupons': 1,
            'createdAt': 1,
            'profileDetails.full_name': 1,
            'profileDetails.eMail_id': 1,
            'downloaded_coupons': 1
          }
        }
      ]
    } else if (data.filter_type == 'expired') {
      var filter = [
        {
          '$match': {
            'coupon_validity_to': { $lte: tomorrow }
          }
        },
        {
          '$lookup': {
            'from': 'userprofiles',
            'localField': 'uid',
            'foreignField': 'uid',
            'as': 'profileDetails'
          }
        }, {
          '$unwind': {
            'path': '$profileDetails'
          }
        },
        { '$sort': { createdAt: -1 } },
        { '$skip': data.page_number * data.limit },
        { '$limit': data.limit },
        {
          '$project': {
            '_id': 1,
            'uid': 1,
            "coupon_image": 1,
            'coupon_name': 1,
            'coupon_id': 1,
            'coupon_description': 1,
            'offer_type': 1,
            'offer_value': 1,
            'total_Number_of_coupons': 1,
            'usage_limit_per_user': 1,
            'coupon_validity_from': 1,
            'coupon_validity_to': 1,
            'province': 1,
            'terms_and_condition': 1,
            'claimed_coupons': 1,
            'createdAt': 1,
            'profileDetails.full_name': 1,
            'profileDetails.eMail_id': 1,
            'downloaded_coupons': 1
          }
        }
      ]
    }


    return new Promise(function (resolve, reject) {
      CouponModel.
        aggregate(
          filter
        )
        // .sort({ createdAt: 'desc' })
        // .skip(data.page_number * data.limit)
        // .limit(data.limit).lean()
        .then((result) => {
          response.error = false
          response.data = result
          resolve(response)
          // console.log('listCouponDaooutput', result);

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.viewCouponDao = async (data) => {
    var response = {}

    return new Promise(function (resolve, reject) {
      CouponModel
        .aggregate(
          [
            {
              '$match': {
                'coupon_id': data.coupon_id,
              }
            },
            {
              '$lookup': {
                'from': 'userprofiles',
                'localField': 'uid',
                'foreignField': 'uid',
                'as': 'profileDetails'
              }
            }, {
              '$unwind': {
                'path': '$profileDetails'
              }
            },
            {
              '$project': {
                '_id': 1,
                'uid': 1,
                "coupon_image": 1,
                'is_active': 1,
                'coupon_name': 1,
                'coupon_id': 1,
                'coupon_description': 1,
                'offer_type': 1,
                'offer_value': 1,
                'total_Number_of_coupons': 1,
                'usage_limit_per_user': 1,
                'coupon_validity_from': 1,
                'coupon_validity_to': 1,
                'province': 1,
                'terms_and_condition': 1,
                'claimed_coupons': 1,
                'profileDetails.full_name': 1,
                'profileDetails.eMail_id': 1
              }
            }
          ]
        ).


        // .find({ coupon_id: data.coupon_id }).lean().

        then((result) => {
          response.error = false
          response.data = result
          // console.log("viewCouponDaoresponse",result);
          resolve(response)
        }).catch((error) => {
          response.error = true
          resolve(response)
          console.log(error);
        })
    })
  }


  this.userLogsAdminCouponDao = async (data) => {
    var response = {}

    return new Promise(function (resolve, reject) {
      UserCouponModel.
        aggregate(
          [
            {
              '$match': {
                'coupon_id': data.coupon_id,
                'claim_count': { $lt: data.total_count }
              }
            }
            , {
              '$lookup': {
                'from': 'userprofiles',
                'localField': 'uid',
                'foreignField': 'uid',
                'as': 'profileDetails'
              }
            }, {
              '$unwind': {
                'path': '$profileDetails'
              }
            },
            { '$sort': { createdAt: -1 } },
            { '$skip': data.page_number * data.limit },
            { '$limit': data.limit },
            {
              '$project': {
                '_id': 1,
                'uid': 1,
                'coupon_id': 1,
                'user_coupon_id': 1,
                'claim_count': 1,
                'profileDetails.full_name': 1,
                'profileDetails.eMail_id': 1
              }
            }
          ]
        ).
        //     find({
        //     $and: [{ coupon_id: data.coupon_id },
        //          {claim_count: { $lt: data.total_count}}]
        //  }).lean().

        then((result) => {
          response.error = false
          response.data = result
          // console.log("viewCouponDaoresponse", result);
          resolve(response)
        }).catch((error) => {
          response.error = true
          resolve(response)
          console.log(error);
        })
    })
  }



  this.countUserLogsAdminCouponDao = async (data) => {
    var response = {}

    return new Promise(function (resolve, reject) {
      UserCouponModel.
        find({
          $and: [{ coupon_id: data.coupon_id },
          { claim_count: { $lt: data.total_count } }]
        }).lean().

        then((result) => {
          response.error = false
          response.data = result
          // console.log("viewCouponDaoresponse", result);
          resolve(response)
        }).catch((error) => {
          response.error = true
          resolve(response)
          console.log(error);
        })
    })
  }



  this.downloadUserLogsAdminCouponDao = async (data) => {
    var response = {}

    return new Promise(function (resolve, reject) {
      UserCouponModel
        .aggregate(
          [
            {
              '$match': {
                'coupon_id': data.coupon_id,
              }
            }
            , {
              '$lookup': {
                'from': 'userprofiles',
                'localField': 'uid',
                'foreignField': 'uid',
                'as': 'profileDetails'
              }
            }, {
              '$unwind': {
                'path': '$profileDetails'
              }
            },
            { '$sort': { createdAt: -1 } },
            { '$skip': data.page_number * data.limit },
            { '$limit': data.limit },
            {
              '$project': {
                '_id': 1,
                'uid': 1,
                'coupon_id': 1,
                'user_coupon_id': 1,
                'claim_count': 1,
                'downloaded_count': 1,
                'profileDetails.full_name': 1,
                'profileDetails.eMail_id': 1
              }
            }
          ]
        ).
        //     .find({
        //    coupon_id: data.coupon_id 
        //  }).lean().

        then((result) => {
          response.error = false
          response.data = result
          // console.log("viewCouponDaoresponse",result);
          resolve(response)
        }).catch((error) => {
          response.error = true
          resolve(response)
          console.log(error);
        })
    })
  }

  this.CountdownloadUserLogsAdminCouponDao = async (data) => {
    var response = {}

    return new Promise(function (resolve, reject) {
      UserCouponModel
        .find({
          coupon_id: data.coupon_id
        }).lean().

        then((result) => {
          response.error = false
          response.data = result
          // console.log("viewCouponDaoresponse",result);
          resolve(response)
        }).catch((error) => {
          response.error = true
          resolve(response)
          console.log(error);
        })
    })
  }


}