module.exports = function () {
  var foodTripModal = require("../../modal/web/FoodTripModal");

  var ObjectId = require('mongodb').ObjectId;


  this.getTotalFoodTripListCountDao = async (data) => {
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal
        .aggregate([{
          $match:
          {
            $or: [{
              post_description: {
                $regex: `${data.search}`,
                $options: "i",
              },
            },
            {
              hashtags: {
                $regex: `${data.search}`,
                $options: "i",
              },
            },
            {
              location: {
                $regex: `${data.search}`,
                $options: "i",
              },
            },
            {
              full_name: {
                $regex: `${data.search}`,
                $options: "i",
              },
            },

            ],
          },

        },
        ])
        .then((result) => {
          response.error = false;
          response.data = result;
          // console.log(result.length);
          resolve(response);
        })
        .catch((error) => {
          response.error = true;
          resolve(response);

          console.log(error);
        });
    });
  };

  this.listFoodTripDao = async (data) => {
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal
        .aggregate([{
          $match: {


            $or: [{
              post_description: {
                $regex: `${data.search}`,
                $options: "i",
              },
            },
            {
              hashtags: {
                $regex: `${data.search}`,
                $options: "i",
              },
            },
            {
              location: {
                $regex: `${data.search}`,
                $options: "i",
              },
            },
            {
              full_name: {
                $regex: `${data.search}`,
                $options: "i",
              },
            },

            ],



          },
        },
        {
          $sort: {
            createdAt: -1,
          },
        },
        {
          $skip: data.page_number * data.limit,
        },
        {
          $limit: data.limit,
        },

        ])
        .then((result) => {
          response.error = false;
          response.data = result;
          // console.log(result);
          resolve(response);
        })
        .catch((error) => {
          response.error = true;
          resolve(response);

          console.log(error);
        });
    });
  };

  this.getOneFoodTripDao = async (data) => {
    // console.log("=======>", data)
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal.find({
          _id: data.id
      })
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.deleteOneFoodTripDao = async (data) => {
    // console.log("=======>", data)
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal.updateMany({
        _id: data.id
      }, {
        $set: {
          is_active:0
        }
      })
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.editFoodTripDao = async (data) => {
    // console.log("=======>", data)
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal.updateMany({
        _id: data.id
      }, {
        $set: {
          post_description:data.post_description,
          post_images:data.post_images,
          post_type:data.post_type,
          hashtags:data.hashtags,
          location:data.location,
          youtube_link:data.youtube_link
        }
      })
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.unhideFoodTripDao = async (data) => {
    // console.log("=======>", data)
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal.updateMany({
        _id: data.id
      }, {
        $set: {
          hidden:1
        }
      })
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.hideFoodTripDao = async (data) => {
    // console.log("=======>", data)
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal.updateMany({
        _id: data.id
      }, {
        $set: {
          hidden:0
        }
      })
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
}