module.exports = function () {
  var PinoyPreneursModal = require('../../modal/web/PinoyPreneursModel')
  var PinoyPreneursProductModel = require('../../modal/web/PinoyPreneursProductModel')
  var MyProfileModal = require('../../modal/web/MyProfileModal')

  this.getPinoyPreneursDao = async (data) => {

    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursModal.find({
        }).sort({
          "updatedAt": -1
        })
        .skip(data.pageNumber > 0 ? ((data.pageNumber - 1) * RowsPerpage) : 0)
        .limit(RowsPerpage)
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.getTotalPinoyPreneursCountDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursModal.find({
        })
        .count()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }



  this.getOnePinoyPreneursDao = async (data) => {

    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursModal.find({
        is_active: 1,
        _id: data.PinoyPreneur_id

      }, {


      }, function (error, result) {

        if (error) {
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  this.GetOnePinoyPreneurProductsDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursProductModel.find({
          is_active: 1,
          PinoyPreneur_id: data.PinoyPreneur_id
        })
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.addPinoyPreneursDao = async (data) => {
    // console.log("addPinoyPreneursDao", data)

    var response = {}
    return new Promise(function (resolve, reject) {
      const PinoyPreneursModals = new PinoyPreneursModal(data)
      PinoyPreneursModals.save(function (error, result) {
        console.log(error, result)
        if (error) {
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }

  // this.getOneUserDao = async (data) => {
  //   // console.log("getOneUserDao",data)
  //   var response = {}
  //   return new Promise(function (resolve, reject) {
  //     MyProfileModal.findOne({
  //       eMail_id: data.user_emailId
  //     }, {
  //       uid: 1,
  //       _id: 0
  //     }, function (error, result) {
  //       if (error) {
  //         console.log(error)
  //         response.error = true
  //       } else {
  //         response.error = false
  //         response.data = result
  //       }
  //       resolve(response)
  //     })
  //   })
  // }

  this.getOneUserDao = async (data) => {
  
    var response = {}
    return new Promise(function (resolve, reject) {
      MyProfileModal.findOne({
        eMail_id: data.user_emailId
        }, {
          uid: 1,
          _id: 0
        }).lean()
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }











  this.getOnePinoyPreneurIdDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursModal.find({
        uid: data.uid
      }, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          // console.log("getOnePinoyPreneurIdDaos", result)

          response.data = result
        }
        resolve(response)
      })
    })
  }

  this.addPinoyPreneurProductsDao = async (data) => {
    // console.log("addPinoyPreneurProductsDao", data)
    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursProductModel.insertMany(data, function (error, result) {
        console.log(error, result)
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = data
        }
        resolve(response)
      })
    })
  }

  this.updateUserStatusDao = async (data) => {
    // console.log("update", data)
    var response = {}
    return new Promise(function (resolve, reject) {
      MyProfileModal.updateOne({
          is_active: 1,
          uid: data.uid
        }, {
          $set: {
            user_status: data.position,
            pinoy_preneur: 1
          }
        })
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.getOneUserIdDao = async (data) => {
    // console.log("getOneUserIdDao", data)
    var response = {}
    return new Promise(function (resolve, reject) {
      MyProfileModal.findOne({
        uid: data.userId
      }, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }
  this.checkMyProfileDao = async (data) => {
    // console.log("checkMyProfileDao", data)
    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursModal.findOne({
        uid: data.uid

      }, function (error, result) {
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        resolve(response)
      })
    })
  }


  this.updatePinoyPreneurDao = async (data, object) => {
    console.log("updatePinoyPreneurDao", data, object)
    // console.log("updatePinoyPreneurDaoerror",error,result)

    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursModal.updateOne({
          is_active: 1,
          _id: data.PinoyPreneur_id
        }, {
          $set: object
        })
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.PinoyPreneurProductDao = async (data) => {
    // console.log("PinoyPreneurProductDao", data)
    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursProductModel.findOne({
          is_active: 1,
          _id: data._id
        })
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.updatePinoyPreneurProductDao = async (data, object) => {
    // console.log("updatePinoyPreneurProductDao", data, object)

    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursProductModel.updateOne({
          is_active: 1,
          _id: data._id
        }, {
          $set: object
        })
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)
          console.log(error);
        });
    })
  }

  this.savePinoyPreneurProductDao = async (data, object) => {
    // console.log("savePinoyPreneurProductDao", data, object)

    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursProductModel.updateOne({
          is_active: 1,
          _id: data.PinoyPreneur_id
        }, {
          $set: object
        })
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)
          console.log(error);
        });
    })
  }

  this.deletePinoyPreneurProductDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      PinoyPreneursProductModel.deleteOne({
          _id: data.product_id
        },
        (err, result) => {
          if (err) {
            response.error = true
          } else {
            response.error = false
            response.result = result
          }
          resolve(response)
        });
    })
  }
  
  
   this.hidePinoyPreneurDao = async (data) => {
    // console.log("=======>", data)
    var response = {};
    return new Promise(function (resolve, reject) {
      PinoyPreneursModal.updateMany({
        _id: data.id
      }, {
        $set: {
          status:'inactive'
        }
      })
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.unhidePinoyPreneurDao = async (data) => {
    // console.log("=======>", data)
    var response = {};
    return new Promise(function (resolve, reject) {
      PinoyPreneursModal.updateMany({
        _id: data.id
      }, {
        $set: {
          status:'active'
        }
      })
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

}