module.exports = function () {
  var ReferralModel = require('../../modal/web/ReferralModel')
  var ReferredUserDetails = require('../../modal/web/ReferredUserDetails')



  this.listReferralCountDao = async (data) => {
    var response = {}


    return new Promise(function (resolve, reject) {
      ReferralModel.aggregate([
        {
          '$lookup': {
            'from': 'userprofiles',
            'localField': 'uid',
            'foreignField': 'uid',
            'as': 'profileDetails'
          }
        }, {
          '$unwind': {
            'path': '$profileDetails'
          }
        },
    
        {
          $match: {
            $or: [
  
              {
                "profileDetails.eMail_id": {
                  $regex: `${data.search}`,
                  '$options': "i",
                },
              },
              {
                "profileDetails.full_name": {
                  $regex: `${data.search}`,
                  '$options': "i",
                },
              },
              {
                "referral_code": {
                  $regex: `${data.search}`,
                  '$options': "i",
                },
              },
            ],
          },
        },
  
        {
          '$project': {
            '_id': 1,
            'uid': 1,
            'createdAt': 1,
            'reffered_count': 1,
            'referral_code': 1,
            'profileDetails.full_name': 1,
            'profileDetails.eMail_id': 1
          }
        }
      ])
        .then((result) => {
          response.error = false
          response.data = result
          resolve(response)
          // console.log('listCouponDaooutput', result);

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.listReferralDao = async (data) => {
    // console.log('listCouponDaoinput', data);
    const today = new Date()

    // to return the date number(1-31) for the specified date
    var a = today.toISOString().substring(0, 10);
    var b = new Date(a)
    // console.log("today => ", b)

    var tomorrow = new Date(a)

    tomorrow.setDate(b.getDate() - 1)
    var response = {}
    var filter = [

      {
        '$lookup': {
          'from': 'userprofiles',
          'localField': 'uid',
          'foreignField': 'uid',
          'as': 'profileDetails'
        }
      }, {
        '$unwind': {
          'path': '$profileDetails'
        }
      },
      { '$sort': { createdAt: -1 } },
      { '$skip': data.page_number * data.limit },
      { '$limit': data.limit },
      {
        $match: {
          $or: [

            {
              "profileDetails.eMail_id": {
                $regex: `${data.search}`,
                '$options': "i",
              },
            },
            {
              "profileDetails.full_name": {
                $regex: `${data.search}`,
                '$options': "i",
              },
            },
            {
              "referral_code": {
                $regex: `${data.search}`,
                '$options': "i",
              },
            },
          ],
        },
      },

      {
        '$project': {
          '_id': 1,
          'uid': 1,
          'createdAt': 1,
          'reffered_count': 1,
          'referral_code': 1,
          'profileDetails.full_name': 1,
          'profileDetails.eMail_id': 1
        }
      }
    ]


    return new Promise(function (resolve, reject) {
      ReferralModel.
        aggregate(
          filter
        )
        // .sort({ createdAt: 'desc' })
        // .skip(data.page_number * data.limit)
        // .limit(data.limit).lean()
        .then((result) => {
          response.error = false
          response.data = result
          resolve(response)
          // console.log('listCouponDaooutput', result);

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.viewReferralDao = async (data) => {
    var response = {}

    return new Promise(function (resolve, reject) {
      ReferredUserDetails.find({ referral_code: data.referral_code }).count().


        // .find({ coupon_id: data.coupon_id }).lean().

        then((result) => {
          response.error = false
          response.data = result
          // console.log("viewCouponDaoresponse",result);
          resolve(response)
        }).catch((error) => {
          response.error = true
          resolve(response)
          console.log(error);
        })
    })
  }


  this.viewUserDetailsDao = async (data) => {
    var response = {}

    return new Promise(function (resolve, reject) {
      ReferredUserDetails
        .aggregate([
          {
            '$match': {
              'referral_code': data.referral_code
            }
          },

          {
            '$lookup': {
              'from': 'userprofiles',
              'localField': 'uid',
              'foreignField': 'uid',
              'as': 'profileDetails'
            }
          },
          {
            '$unwind': {
              'path': '$profileDetails',
              'preserveNullAndEmptyArrays': true
            }
          },
          { '$sort': { createdAt: -1 } },
          { '$skip': data.page_number * data.limit },
          { '$limit': data.limit },
          {
            '$project': {
              '_id': 1,
              'uid': 1,
              'referral_code': 1,
              'reffered_count': 1,
              // 'referredusers': 1,
              'profileDetails.uid': 1,
              'profileDetails.full_name': 1,
              'profileDetails.eMail_id': 1

            }
          }

        ]).


        // .find({ coupon_id: data.coupon_id }).lean().

        then((result) => {
          response.error = false
          response.data = result
          // console.log("viewCouponDaoresponse",result);
          resolve(response)
        }).catch((error) => {
          response.error = true
          resolve(response)
          console.log(error);
        })
    })
  }



}