module.exports = function () {
    var SurveyModel = require('../../modal/web/SurveyModel')


    this.addOneSurveyDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            const SurveyModelObject = new SurveyModel(data)
            SurveyModelObject.save(function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }





    this.getTotalSurveyListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyModel.find({
                    is_active: 1
                })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.getSurveyListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyModel.find({
                    is_active: 1
                }, {
                    _id: 1,
                    question: 1,
                    is_active: 1
                })
                .skip(data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0)
                .limit(data.RowsPerpage)
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.viewOneSurveyDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyModel.findOne({
                    is_active: 1,
                    _id: data.survey_id
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.editOneSurveyDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyModel.updateOne({
                    is_active: 1,
                    _id: data.survey_id
                }, {
                    $set: {
                        question: data.question,
                        options: data.options
                    }
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }



    this.deleteOneSurveyDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SurveyModel.deleteOne({
                    _id: data.survey_id
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }




}