module.exports = function () {
    var goodVibesModel = require('../../modal/admin/goodVibesModel')


    this.addOneGoodVibeDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            const goodVibesModelObject = new goodVibesModel(data)
            goodVibesModelObject.save(function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }





    this.getTotalGoodVibesListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            goodVibesModel.find({
                    is_active: 1
                })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.getGoodVibesListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            goodVibesModel.find({
                    is_active: 1
                }, {
                    _id: 1,
                    question: 1,
                    is_active: 1
                })
                .skip(data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0)
                .limit(data.RowsPerpage)
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.viewOneGoodVibePostDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            goodVibesModel.findOne({
                    is_active: 1,
                    _id: data.post_id
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.editOneGoodVibePostDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            goodVibesModel.updateOne({
                    is_active: 1,
                    _id: data.post_id
                }, {
                    $set: {
                        question: data.question,
                        thaughts: data.thaughts
                    }
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }



    this.deleteOneGoodVibeDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            goodVibesModel.deleteOne({
                    _id: data.post_id
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }




}