module.exports = function () {
  var donasayonModal = require('../../modal/web/DonasyanModal')
  var reportModal = require('../../modal/web/ReportModal')
  var ObjectId = require('mongodb').ObjectId;

  this.getTotalDonasaynListCountDao = async (data,getBlockedUsers) => {
    var response = {}
    var categories = {
      is_active: 1
    }

    if (data.filterCategory.length > 0) {
      categories = {
        category: {
          $in: data.filterCategory
        }
      }
    }
    return new Promise(function (resolve, reject) {
      donasayonModal.find({
          $and: [{
              is_active: 1
            }, {
              $or: [{
                  item_name: {
                    $regex: `${data.search}`,
                    $options: 'i'
                  }
                },
                {
                  full_name: {
                    $regex: `${data.search}`,
                    $options: 'i'
                  }
                },
                {
                  purpose_to_add: {
                    $regex: `${data.search}`,
                    $options: 'i'
                  }
                }
              ]
            },
            categories,
            { uid: { $nin: getBlockedUsers[0] } }, // Exclude the users that the current user has blocked
            { uid: { $nin: getBlockedUsers[1] } } // Exclude the users that have blocked the current user
          ]
        })
        .count()
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.getDonasaynListDao = async (data,getBlockedUsers) => {
    var response = {}
    return new Promise(function (resolve, reject) {

      var filterCategory = {
        is_active: 1
      }

      if (data.filterCategory.length > 0) {
        filterCategory = {
          category: {
            $in: data.filterCategory
          }
        }
      }

      donasayonModal
        .aggregate([{
            $match: {
              $and: [{
                  $expr: {
                    $eq: ["$is_active", 1]
                  }
                },
                {
                  $or: [{
                      item_name: {
                        $regex: `${data.search}`,
                        $options: 'i'
                      }
                    },
                    {
                      purpose_to_add: {
                        $regex: `${data.search}`,
                        $options: 'i'
                      }
                    },
                    {
                      full_name: {
                        $regex: `${data.search}`,
                        $options: 'i'
                      }
                    }
                  ]
                },
                filterCategory,
                //
                { uid: { $nin: getBlockedUsers[0] } }, // Exclude the users that the current user has blocked
                { uid: { $nin: getBlockedUsers[1] } } // Exclude the users that have blocked the current user
              ]

            }
          },
          {
            $sort: {
              createdAt: -1
            }
          },
          {
            $skip: data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0
          },
          {
            $limit: 10
          },
          {
            $project: {
              _id: 1,
              item_name:1,
              purpose_to_add:1,
              enter_your_price:1,
              is_this_price:1,
              post_images:1,
              post_description:1,
              number_of_likes:1,
              number_of_comments:1,
              category:1,
              full_name:1,
              profile_photo:1,
              location:1,
              is_active: 1,
              createdAt: 1,
              geolocation:1
            }
          }
        ]).then((result) => {
          response.error = false
          response.data = result
          // console.log("getList", result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
  this.DonasaynPostDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {

      const donasayonModalObject = new donasayonModal(data)
      donasayonModalObject.save(function (error, result) {
        //  console.log("res",result)
        if (error) {
          console.log(error)
          response.error = true
        } else {
          response.error = false
          response.data = result
        }
        //console.log("daata",response)
        resolve(response)
      })
    })
  }

  this.getOneByeBuyDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {

      donasayonModal.findOne({
          $and: [{
            _id: data.post_id
          }, {
            is_active: 1
          }]
        }).lean()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
    // var response = {}
    // return new Promise(function (resolve, reject) {

    //   donasayonModal.aggregate([
    //     {
    //       $match:{ 
    //             is_active: 1,
    //             _id: ObjectId(data.post_id)
    //         }
    //     },
    //     // {
    //     //     "$lookup": {
    //     //         "from": "reports",
    //     //         "localField": "_id",
    //     //         "foreignField": "post_id",
    //     //         "as": "report"
    //     //     },
    //     // },
    //     // {
    //     //   $and: [{
    //     //     _id: data.post_id
    //     //   }, {
    //     //     is_active: 1
    //     //   }]
    //     // }
    //   ])
    //     .then((result) => {
    //       // let reported 
    //       // if(result[0].report.length > 0){
    //       //     if(result[0].report[0].userId == data.uid){
    //       //        reported = 1
    //       //     }else{
    //       //         reported = 0
    //       //     }
    //       // }else{
    //       //     reported = 0
    //       // }
    //       console.log("result=====>",result)
    //       response.error = false
    //       response.result = result
    //       // response.reported = reported,
    //       response.myPost = result[0].uid == data.uid  ? 1 : 0
    //       // console.log(response);
    //       resolve(response)

    //     })
    //     .catch((error) => {
    //       response.error = true
    //       resolve(response)

    //       console.log(error);
    //     });
    // })
  }


  this.getDonasyanReportedPost = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {

      reportModal.findOne({
          $and: [{
            post_id: data.post_id
          }, {
            userId: data.uid
          }]
        }).lean()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })  
  }

  

  this.searchByeBuyDao = async (data) => {
    var response = {}
    //console.log("searchh",data);
    return new Promise(function (resolve, reject) {
      donasayonModal
        .find({
            $or: [{
                item_name: {
                  $regex: `${data.search}`,
                  $options: 'm'
                }
              }, {
                purpose_to_add: {
                  $regex: `${data.search}`,
                  $options: 'm'
                }
              },
              {
                category: {
                  $regex: `${data.search}`,
                  $options: 'm'
                }
              },
              {
                $or: [{
                  category: {
                    $in: data.arr
                  }
                }]
              }
            ]
          }

          // .aggregate([
          //   {
          //             "$search" : {
          //                "$or" : [
          //                 {
          //                       "item_name": {
          //                         "$regex": `${data.search}`,
          //                         "$options": 'm'}
          //                     },{"purpose_to_add": {
          //                       "$regex": `${data.search}`,
          //                       "$options": 'm'}},
          //                       {"category": {
          //                         "$regex": `${data.search}`,
          //                         "$options": 'm'}},
          //                ]
          //             }
          //      },
          //   {
          //      "$project" : {
          //          "_id" : 1, "item_name" : 1,"category":1,"createdAt":1,
          //          "category" : {
          //             "$filter" : {
          //                "input" : "$category",
          //                "as" : "category",
          //                "cond" : {
          //                   "$or" : [
          //                      { "$eq" : [ "$category", "cloths" ] },
          //                     //  { "$eq" : [ "$stock.warehouse.code", "02" ] }
          //                   ]
          //                }
          //             }
          //          }
          //      }
          //   }
          //   ]

          //  .aggregate([

          //   {
          //     '$match': {
          //       'category':{ '$in': data.arr },
          //     }
          //   }],{

          //       '$project': {
          //          'item_name': {
          //             '$filter': {
          //                'input': "$item_name",
          //                'as': "item",
          //                'cond': { '$eq': [ "$$item_name", 'sneakers' ] }
          //             }
          //          }
          //       }

          //   }

        ).sort({
          "createdAt": -1
        }).then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }

  this.filterByeBuyDao1 = async (data) => {
    var response = {}
    // console.log("searchh", data);
    //data.arr=["bikes"]
    return new Promise(function (resolve, reject) {
      donasayonModal
        .find({
          $and: [{
              $or: [{
                  item_name: {
                    $regex: `${data.search}`,
                    $options: 'm'
                  }
                }, {
                  purpose_to_add: {
                    $regex: `${data.search}`,
                    $options: 'm'
                  }
                },
                {
                  category: {
                    $regex: `${data.search}`,
                    $options: 'm'
                  }
                },

              ]
            },
            {
              category: {
                $in: data.arr
              }
            },
          ]
        })
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)
        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }


  this.filterByeBuyDao = async (data) => {
    var response = {}
    // console.log("searchh", data);
    return new Promise(function (resolve, reject) {
      donasayonModal.find({
          category: {
            $in: data.arr
          }
        }).sort({
          "createdAt": -1
        })
        .then((result) => {
          response.error = false
          response.data = result
          console.log(result);
          resolve(response)
        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }
}