module.exports = function () {
  var foodTripModal = require("../../modal/web/FoodTripModal");
  var likesModal = require("../../modal/web/Likes");
  var commentsModal = require("../../modal/web/Comments");
  var myProfileModal = require("../../modal/web/MyProfileModal");
  var reportModal = require("../../modal/web/ReportModal");
  var ObjectId = require('mongodb').ObjectId;
  this.addFoodTripDao = async (data) => {
    // console.log("addFoodTripDao", data);
    var response = {};
    return new Promise(function (resolve, reject) {
      const foodTripModalObject = new foodTripModal(data);
      foodTripModalObject.save(function (error, result) {
        if (error) {
          console.log(error);
          response.error = true;
        } else {
          response.error = false;
          //response.data = result
        }
        resolve(response);
      });
    });
  };

  this.getTotalFoodTripListCountDao = async (data,getBlockedUsers) => {
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal
        .find({
          $and: [ {
            is_active: 1
          },{
            hidden:1
          },
          { uid: { $nin: getBlockedUsers[0] } }, // Exclude the users that the current user has blocked
          { uid: { $nin: getBlockedUsers[1] } } // Exclude the users that have blocked the current user
        ]
        })
        .count()
        .then((result) => {
          response.error = false;
          response.result = result;
          // console.log('getTotalFoodTripListCountDao',result);
          resolve(response);
        })
        .catch((error) => {
          response.error = true;
          resolve(response);

          console.log(error);
        });
    });
  };

  this.listFoodTripDao = async (data,getBlockedUsers) => {
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal
        .aggregate([{
            $match: {
              $and: [{
                  $expr: {
                    $eq: ["$is_active", 1],
                  },
                },
                {
                  $expr: {
                    $eq: ["$hidden", 1],
                  },
                },
                {
                  $or: [{
                      full_name: {
                        $regex: `${data.search}`,
                        $options: "i",
                      },
                    },
                    {
                      post_description: {
                        $regex: `${data.search}`,
                        $options: "i",
                      },
                    },
                    {
                      location: {
                        $regex: `${data.search}`,
                        $options: "i",
                      },
                    },
                  ],
                },
                { uid: { $nin: getBlockedUsers[0] } }, // Exclude the users that the current user has blocked
                { uid: { $nin: getBlockedUsers[1] } } // Exclude the users that have blocked the current user
              ],
            },
          },
          {
            $sort: {
              createdAt: -1,
            },
          },
          {
            $skip: data.pageNumber > 0 ? (data.pageNumber - 1) * 10 : 0,
          },
          {
            $limit: 10,
          },
          {
            $project: {
              _id: 1,
            },
          },
        ])
        .then((result) => {
          response.error = false;
          response.result = result;
          // console.log(result);
          resolve(response);
        })
        .catch((error) => {
          response.error = true;
          resolve(response);

          console.log(error);
        });
    });
  };

  this.getOneFoodTripDao = async (data) => {
    console.log("=======>",data)
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal.find({
          $and: [{
            _id: data.post_id
          }, {
            is_active: 1
          },{
            hidden:1
          }]
        })
        .then((result) => {
          response.error = false
          response.data = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
    // var response = {};
    // const report = reportModal.find({userId : data.uid})

    // return new Promise(function (resolve, reject) {
    //   foodTripModal.aggregate([
    //     {
    //       $match:{ 
    //             is_active: 1,
    //             _id: ObjectId(data.post_id)
    //         }
    //     },
    //     {
    //         "$lookup": {
    //             "from": "reports",
    //             "localField": "_id",
    //             "foreignField": "post_id",
    //             "as": "report"
    //         },
    //     },
    //   ])
    //     .then((result) => {
    //       response.error = false
    //       response.data = result
    //       response.reported = report
    //       // console.log(result);
    //       resolve(response)

    //     })
    //     .catch((error) => {
    //       response.error = true
    //       resolve(response)

    //       console.log(error);
    //     });
    // })
  }

  //  }else{
  //  foodTripModal.find({$and:[{uid:data.uid},{_id:data.post_id}]},function (error, result) {
  //      console.log("res",result)
  //    if (error) {
  //      console.log(error)
  //      response.error = true
  //    } else {
  //      response.error = false
  //      response.data = result
  //    }
  //    console.log("daata",response)
  //    resolve(response)
  //  })
  // }

  
  this.getFoodTripReportedPost = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {

      reportModal.findOne({
          $and: [{
            post_id: data.post_id
          }, {
            userId: data.uid
          }]
        }).lean()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })  
  }
  this.getOneReportingPost = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {

      reportModal.findOne({
          $and: [{
            post_id: data.post_id
          }, {
            userId: data.uid
          }]
        }).lean()
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })  
  }


  this.foodTripDao = async (data) => {
    var response = {};
    return new Promise(function (resolve, reject) {
      const foodTripModalObject = new foodTripModal(data);
      // console.log("iew", data);
      //  if(Object.entries(data).length === 0){

      foodTripModal.find({
          $and: [{
            _id: data.post_id
          }, {
            is_active: 1
          },{
            hidden:1
          }]
        },
        function (error, result) {
          // console.log("res", result);
          if (error) {
            console.log(error);
            response.error = true;
          } else {
            response.error = false;
            response.data = result;
          }
          // console.log("daata",response)
          resolve(response);
        }
      );
    });
  };

  this.getOneProfileDao = async (data) => {
    // console.log("data.uid", data.uid);
    var response = {};
    return new Promise(function (resolve, reject) {
      myProfileModal.find({
        uid: data.uid
      }, function (error, result) {
        if (error) {
          console.log(error);
          response.error = true;
        } else {
          response.error = false;
          response.data = result;
        }
        resolve(response);
      });
    });
  };

  this.postCommentsDao = async (data) => {
    var response = {};
    return new Promise(function (resolve, reject) {
      const commentsObject = new commentsModal(data);
      commentsObject.save(function (error, result) {
        if (error) {
          console.log(error);
          response.error = true;
        } else {
          response.error = false;
          response.data = result;
        }
        resolve(response);
      });
    });
  };

  this.putTotalCommentsDao = async (data) => {
    //  console.log("commentscount", data);

    var response = {};
    return new Promise(function (resolve, reject) {
      const LikesModalObject = new foodTripModal(data);
      foodTripModal.updateOne({
          _id: data.post_id,
        }, {
          $set: {
            number_of_comments: data.updatecount,
          },
        },
        function (error, result) {
          if (error) {
            console.log(error);
            response.error = true;
          } else {
            response.error = false;
            response.data = result;
          }
          resolve(response);
        }
      );
    });
  };

  this.removeCommentsDao = async (data) => {
    var response = {};
    return new Promise(function (resolve, reject) {
      commentsModal.deleteOne({
          $and: [{
            uid: data.uid
          }, {
            post_id: data.post_id
          }]
        },
        function (error, result) {
          if (error) {
            console.log(error);
            response.error = true;
          } else {
            response.error = false;
            response.data = result;
          }
          resolve(response);
        }
      );
    });
  };

  this.featurePostDao = async (data) => {
    //  console.log("api1111111111")
    const date = new Date();
    date.setDate(date.getDate() + 7);
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal
        .find({
          $and: [{
              post_type: "food_recipe"
            }, {
              is_active: "1"
            },
            {
              hidden:1
            },
            {
              createdAt: {
                $lte: date
              }
            }

          ]
        }).sort({
          "number_of_likes": -1
        }).limit(2)

        .then((result) => {
          // console.log("searchh", result);
          response.error = false;
          response.data = result;
          // console.log(result);
          resolve(response);
        })
        .catch((error) => {
          response.error = true;
          resolve(response);

          console.log(error);
        });
    });
  };

  this.featurePostPlaceDao = async (data) => {
    //  console.log("api2222")
    const date = new Date();
    date.setDate(date.getDate() + 7);
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal
        .find({
          $and: [{
              post_type: "general_post"
            }, {
              is_active: "1"
            }
            ,{
              hidden:1
            },
            {
              createdAt: {
                $lte: date
              }
            }

          ]
        }).sort({
          "number_of_likes": -1
        }).limit(2)
        .then((result) => {
          // console.log("searchh", result);
          response.error = false;
          response.data = result;
          // console.log(result);
          resolve(response);
        })
        .catch((error) => {
          response.error = true;
          resolve(response);

          console.log(error);
        });
    });
  };


  this.updateShareCountDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      foodTripModal.updateOne({
          _id: data.post_id
        }, {
          $set: {
            share_count: data.share_count
          }
        })
        .then((result) => {
          response.error = false
          response.result = result
          // console.log(result);
          resolve(response)

        })
        .catch((error) => {
          response.error = true
          resolve(response)

          console.log(error);
        });
    })
  }




  this.recipeSharingListDao = async (data) => {
    //  console.log("api1111111111")
    const date = new Date();
    date.setDate(date.getDate() + 7);
    var response = {};
    return new Promise(function (resolve, reject) {
      foodTripModal
        .find({
          $and: [{
              post_type: "food_recipe"
            }, {
              is_active: "1"
            },{
              hidden:1
            },
            {
              createdAt: {
                $lte: date
              }
            }

          ]
        }).sort({
          share_count: -1
        }).limit(2)

        .then((result) => {
          // console.log("searchh", result);
          response.error = false;
          response.data = result;
          // console.log(result);
          resolve(response);
        })
        .catch((error) => {
          response.error = true;
          resolve(response);

          console.log(error);
        });
    });
  };




};