module.exports = function () {
    var GroupChatModel = require('../../modal/web/GroupChatModel')
    var GroupChatMembersModel = require('../../modal/web/GroupChatMembersModel')
    var GroupChatMessageModel = require('../../modal/web/GroupChatMessagesModel')
    var MyProfileModal = require('../../modal/web/MyProfileModal')
    var GroupChatLikeModel = require('../../modal/web/GroupChatLikeModel')
    var MyProfileModal = require('../../modal/web/MyProfileModal')




    var ObjectId = require('mongodb').ObjectId;



    this.createGroupChatDao = async (data) => {
        console.log('userInput', data)
        var response = {}
        return new Promise(function (resolve, reject) {
            const GroupChatModelObject = new GroupChatModel(data)
            GroupChatModelObject.save(function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }

    // this.deleteGroupDao = async (data) => {
    //     var response = {}
    
    //     return new Promise(function (resolve, reject) {
    //         GroupChatModel.updateOne(
    //         {
    //           _id: ObjectId(data.groupId),
    //           },
    //         {
    //           $set:{
    //             is_active:1
    //           }
    //         }
    //         ).
    //         then((result) => {
    //           response.error = false
    //           response.data = result
    //           // console.log("viewAdDaoresponse",result);
    //           resolve(response)
    //         }).catch((error) => {
    //           response.error = true
    //           resolve(response)
    //           console.log(error);
    //         })
    //     })
    //   }

    this.deleteGroupDao = async (data) => {
        var response = {}
    
        return new Promise(async function (resolve) {
            try {
                await GroupChatModel.updateOne(
                    { _id: ObjectId(data.groupId) },
                    { $set: { is_active: 0 } }
                );
    
                const groupChatMembers = await GroupChatMembersModel.find({ chatId: data.groupId });
    
                if (groupChatMembers) {
                    await GroupChatMembersModel.updateMany(
                        { chatId: data.groupId },
                        { $set: { is_active: 0 } }
                    );
                }
    
                const groupChatMessages = await GroupChatMessageModel.find({ chatId: data.groupId });
    
                if (groupChatMessages) {
                    await GroupChatMessageModel.updateMany(
                        { chatId: data.groupId },
                        { $set: { is_active: 0 } }
                    );
                }
    
                response.error = false;
                response.data = "Group deleted successfully";
                resolve(response);
            } catch (error) {
                console.log(error);
                response.error = true;
                response.data = "Error while deleting group";
                resolve(response);
            }
        });
    };
    


    this.listGroupChatsCountDao = async (data) => {
        var response = {}

        try {
            const result = await GroupChatMembersModel.countDocuments({ memberUid: data.uid, is_active: 1 })
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    this.listGroupMessageCountDao = async (data) => {
        var response = {}

        try {
            const result = await GroupChatMessageModel.countDocuments({ chatId: { $eq: data.chatId }, is_active: 1 })
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.listGroupMessageCountHiddenDao = async (data) => {
        var response = {}

        try {
            const result = await GroupChatMessageModel.countDocuments({ chatId: { $eq: data.chatId }, is_active: 1,
                //  hide: false 
                })
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    this.listGroupMembersCountDao = async (data) => {
        var response = {}

        try {
            const result = await GroupChatMembersModel.countDocuments({ chatId: { $eq: data.chatId }, is_active: 1 })
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    this.memberListSearchDao = async (data) => {
        var response = {}

        try {
            const result = await GroupChatMembersModel.find({ chatId: { $eq: data.chatId }, is_active: 1 })
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.listGroupChatsDao = async (data) => {
        var response = {}

        try {
            const result = await GroupChatModel.find({ is_active: 1 }).sort({ lastMessageTime: 'desc' })
                .skip(data.pageNumber * data.limit)
                .limit(data.limit)
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.listGroupChatsDao = async (data) => {
        var response = {}

        try {
            const result = await GroupChatMembersModel.aggregate([{
                $match: {
                    memberUid: data.uid, is_active: 1
                }
            }, {
                $lookup: {
                    from: 'groupchatdetails',
                    localField: 'chatId',
                    foreignField: '_id',
                    as: 'group'
                }
            }, {
                $unwind: '$group'
            },
            {
                $sort: {
                    'group.lastMessageTime': -1
                }
            },
            {
                $skip: data.pageNumber > 0 ? (data.pageNumber * data.limit) : 0
            },
            {
                $limit: 10
            },
            {
                $project: {
                    "_id": "$group._id",
                    "groupName": "$group.groupName",
                    "groupDescription": "$group.groupDescription",
                    "groupImage": "$group.groupImage",
                    "lastMessage": "$group.lastMessage",
                    "is_active": "$group.is_active",
                    "lastMessageTime": "$group.lastMessageTime",
                    "updatedAt": "$group.updatedAt",
                    "createdAt": "$group.createdAt",
                }
            }
            ])
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    this.listGroupChatCountsDao = async (data) => {
        var response = {}

        try {
            const result = await GroupChatMembersModel.aggregate([{
                $match: {
                    memberUid: data.uid, 
                    is_active: 1
                }
            }, {
                $lookup: {
                    from: 'groupchatdetails',
                    localField: 'chatId',
                    foreignField: '_id',
                    as: 'group'
                }
            }, {
                $unwind: '$group'
            },
            

            ])
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
   
    

    this.addGroupMember = async (data) => {
        // console.log("addGroupMemberInputs",data)
        var response = {}
        return new Promise(function (resolve, reject) {
            const GroupChatMembersModelObject = new GroupChatMembersModel(data)
            insertedDocument = GroupChatMembersModelObject.save
                (function (error, result) {
                    if (error) {
                        response.error = true
                    } else {
                        response.error = false
                        response.data = result
                        // responseMsg = "Document inserted";
                    }
                    resolve(response)
                })
        })
    }
    this.hideUnhideDao = async (data, hideBy) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatMessageModel.updateOne(
                {
                    _id: ObjectId(data.messageId), is_active: 1,
                },
                {
                    $set: {
                        hide: data.hide,
                        hideBy: data.hide ? hideBy : {}
                    }
                }
            )
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.editGroupDao = async (data, hideBy) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatModel.updateOne(
                {
                    _id: ObjectId(data.chatId), is_active: 1,
                },
                {
                    $set: {
                        groupName: data.groupName,
                        groupDescription: data.groupDescription,
                        groupImage:data.groupImage 
                    }
                }
            )
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.addMemberIfNotDao = async (data) => {
        console.log("insertDetctiondata", data.memberUid, data.chatId)

        var response = {}
        try {
 
            var result = await GroupChatMembersModel.aggregate([
                {
                    $match: { memberUid: data.memberUid, chatId: ObjectId(data.chatId) }
                },
                {
                    $group: {
                        _id: null,
                        count: { $sum: 1 }
                    }
                }
            ]);
            let responseMsg = "not present";
            let insertedDocument = null;

            console.log("insertDetction", result)
            if (result.length > 0) {
                // MemberUid already exists
                responseMsg = "Document already exists";

            }
            const response = {
                error: false,
                message: responseMsg,
                document: insertedDocument
            };
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    };

    this.addGroupMembersDao = async (data) => {
        var response = {}
        try {
            const GroupChatMembersModelObject = new GroupChatMembersModel(data)
            const result = await GroupChatMembersModelObject.save();
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    // this.validatingUserInGroup= async(data)=>{
    //     var response={}
    //     try{
    //         const result = await GroupChatMembersModel.aggregate([
    //             {
    //                 $match:{
    //                     uid:
    //                 }
    //             }
    //         ]); 
    //         response.error=false;
    //         response.result=result;
    //         return response;
    //     }catch(error){
    //         console.log(error)
    //         response.error=true;
    //         return response;
    //     }
    // }

    this.sendGroupMessageDao = async (data) => {
        console.log('inputs', data)
        var response = {}
        try {
            const GroupChatMessageModelObject = new GroupChatMessageModel(data)
            const result = await GroupChatMessageModelObject.save();
            console.log('GroupChatMessageModelObject', result)

            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.updateLastMessageDao = async (data) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatModel.updateOne(
                {
                    _id: ObjectId(data.chatId), is_active: 1,
                },
                {
                    $set: {
                        lastMessageTime: Date.now(),
                        lastMessage: data.message,
                        lastMessageMediatype:data.mediaType,
                        lastMessageMediaUrl:data.mediaUrl
                    }
                }
            )
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    this.listGroupMessageDao = async (data) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatMessageModel.aggregate([{
                $match: {
                    chatId: ObjectId(data.chatId), is_active: 1
                }
            }, {
                $lookup: {
                    from: 'userprofiles',
                    localField: 'senderUid',
                    foreignField: 'uid',
                    as: 'senderDetails'
                }
            }, { $unwind: '$senderDetails' },
            {
                $sort: {
                    createdAt: -1
                }
            },
            {
                $skip: data.pageNumber > 0 ? (data.pageNumber * data.limit) : 0
            },
            {
                $limit: 10
            }, {
                $project: {
                    "_id": 1,
                    "chatId": 1,
                    "senderUid": 1,
                    "message": 1,
                    "messageId": 1,
                    "messageType": 1,
                    "mediaType": 1,
                    "mediaUrl": 1,
                    "is_active": 1,
                    "createdAt": 1,
                    "updatedAt": 1,
                    "hide": 1,
                    "senderDetails": {
                        "uid": 1,
                        "username": 1,
                        "full_name": 1,
                        "profile_photo": 1,
                    }
                }
            }
            ])
            // console.log("data.pageNumber * data.limit",data.pageNumber * data.limit)
            //     const result = await GroupChatMessageModel.aggregate([
            //         {
            //           $sort: {
            //             createdAt: -1,
            //           },
            //         },
            //         {
            //           $match: {
            //             chatId: ObjectId(
            //               "641aa36d66dd2c29f51e0d5e"
            //             ),
            //             is_active: 1,
            //           },
            //         },

            //         {
            //           $lookup: {
            //             from: "userprofiles",
            //             localField: "senderUid",
            //             foreignField: "uid",
            //             as: "senderDetails",
            //           },
            //         },
            //         {
            //           $unwind: "$senderDetails",
            //         },
            //         {
            //           $lookup: {
            //             from: "groupchatmessages",
            //             localField: "messageId",
            //             foreignField: "_id",
            //             as: "repliedMessage",
            //           },
            //         },
            //         {
            //           $unwind: {
            //             path: "$repliedMessage",
            //             preserveNullAndEmptyArrays: true,
            //           },
            //         },
            //         {
            //           $lookup: {
            //             from: "userprofiles",
            //             localField: "repliedMessage.senderUid",
            //             foreignField: "uid",
            //             as: "repliedMessageSenderDetails",
            //           },
            //         },
            //         {
            //           $unwind: {
            //             path: "$repliedMessageSenderDetails",
            //             preserveNullAndEmptyArrays: true,
            //           },
            //         },

            //         {
            //           $lookup: {
            //             from: "groupchatlikes",
            //             localField: "_id",
            //             foreignField: "messageId",
            //             as: "groupchatlikes",
            //           },
            //         },
            //         {
            //           $unwind: {
            //             path: "$groupchatlikes",
            //             preserveNullAndEmptyArrays: true,
            //           },
            //         },
            //         {
            //           $sort: {
            //             createdAt: -1,
            //           },
            //         },
            //         {
            //           $skip: 0,
            //         },
            //         {
            //           $limit: 100,
            //         },

            //         {
            //           $group: {
            //             _id: "$_id",
            //             chatId: { $first: "$chatId" },
            //             senderUid: { $first: "$senderUid" },
            //             message: { $first: "$message" },
            //             messageId: { $first: "$messageId" },
            //             messageType: { $first: "$messageType" },
            //             mediaType: { $first: "$mediaType" },
            //             mediaUrl: { $first: "$mediaUrl" },
            //             is_active: { $first: "$is_active" },
            //             senderDetails: { $first: "$senderDetails" },
            //             groupchatlikes: {
            //               $first: "$groupchatlikes",
            //             },
            //             repliedMessageSenderDetails: {
            //               $first: "$repliedMessageSenderDetails",
            //             },
            //             repliedMessage: {
            //               $push: {
            //                 _id: "$repliedMessage._id",
            //                 chatId: "$repliedMessage.chatId",
            //                 senderUid: "$repliedMessage.senderUid",
            //                 message: "$repliedMessage.message",
            //                 messageId: "$repliedMessage.messageId",
            //                 messageType:
            //                   "$repliedMessage.messageType",
            //                 mediaType: "$repliedMessage.mediaType",
            //                 mediaUrl: "$repliedMessage.mediaUrl",
            //                 is_active: "$repliedMessage.is_active",
            //                 senderDetails:
            //                   "$repliedMessageSenderDetails",
            //               },
            //             },
            //           },
            //         },

            //         {
            //           $project: {
            //             _id: 1,
            //             chatId: 1,
            //             senderUid: 1,
            //             message: 1,
            //             messageId: 1,
            //             messageType: 1,
            //             mediaType: 1,
            //             mediaUrl: 1,
            //             is_active: 1,
            //             groupchatlikes: 1,
            //             senderDetails: 1,
            //             repliedMessageSenderDetails: 1,
            //             repliedMessage: {
            //               $arrayElemAt: [
            //                 {
            //                   $map: {
            //                     input: "$repliedMessage",
            //                     as: "replied",
            //                     in: {
            //                       _id: "$$replied._id",
            //                       chatId: "$$replied.chatId",
            //                       senderUid: "$$replied.senderUid",
            //                       message: "$$replied.message",
            //                       messageId: "$$replied.messageId",
            //                       messageType:
            //                         "$$replied.messageType",
            //                       mediaType: "$$replied.mediaType",
            //                       mediaUrl: "$$replied.mediaUrl",
            //                       is_active: "$$replied.is_active",
            //                       senderDetails:
            //                         "$repliedMessageSenderDetails",
            //                     },
            //                   },
            //                 },
            //                 0,
            //               ],
            //             },
            //           },
            //         },
            //         {
            //           $sort: {
            //             createdAt: -1,
            //           },
            //         },
            //       ]
            // )
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.listGroupMessageAdminDao = async (data) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatMessageModel.aggregate([{
                $match: {
                    chatId: ObjectId(data.chatId), is_active: 1
                }
            }, {
                $lookup: {
                    from: 'userprofiles',
                    localField: 'senderUid',
                    foreignField: 'uid',
                    as: 'senderDetails'
                }
            }, { $unwind: '$senderDetails' },
            {
                $sort: {
                    createdAt: -1
                }
            },
            {
                $skip: data.pageNumber > 0 ? (data.pageNumber * data.limit) : 0
            },
            {
                $limit: 10
            }, {
                $project: {
                    "_id": 1,
                    "chatId": 1,
                    "senderUid": 1,
                    "message": 1,
                    "messageId": 1,
                    "messageType": 1,
                    "mediaType": 1,
                    "mediaUrl": 1,
                    "is_active": 1,
                    "createdAt": 1,
                    "updatedAt": 1,
                    "hide": 1,
                    "hideBy":1,
                    "senderDetails": {
                        "uid": 1,
                        "username": 1,
                        "full_name": 1,
                        "profile_photo": 1,
                    }
                }
            }
            ])
            // console.log("data.pageNumber * data.limit",data.pageNumber * data.limit)
            //     const result = await GroupChatMessageModel.aggregate([
            //         {
            //           $sort: {
            //             createdAt: -1,
            //           },
            //         },
            //         {
            //           $match: {
            //             chatId: ObjectId(
            //               "641aa36d66dd2c29f51e0d5e"
            //             ),
            //             is_active: 1,
            //           },
            //         },

            //         {
            //           $lookup: {
            //             from: "userprofiles",
            //             localField: "senderUid",
            //             foreignField: "uid",
            //             as: "senderDetails",
            //           },
            //         },
            //         {
            //           $unwind: "$senderDetails",
            //         },
            //         {
            //           $lookup: {
            //             from: "groupchatmessages",
            //             localField: "messageId",
            //             foreignField: "_id",
            //             as: "repliedMessage",
            //           },
            //         },
            //         {
            //           $unwind: {
            //             path: "$repliedMessage",
            //             preserveNullAndEmptyArrays: true,
            //           },
            //         },
            //         {
            //           $lookup: {
            //             from: "userprofiles",
            //             localField: "repliedMessage.senderUid",
            //             foreignField: "uid",
            //             as: "repliedMessageSenderDetails",
            //           },
            //         },
            //         {
            //           $unwind: {
            //             path: "$repliedMessageSenderDetails",
            //             preserveNullAndEmptyArrays: true,
            //           },
            //         },

            //         {
            //           $lookup: {
            //             from: "groupchatlikes",
            //             localField: "_id",
            //             foreignField: "messageId",
            //             as: "groupchatlikes",
            //           },
            //         },
            //         {
            //           $unwind: {
            //             path: "$groupchatlikes",
            //             preserveNullAndEmptyArrays: true,
            //           },
            //         },
            //         {
            //           $sort: {
            //             createdAt: -1,
            //           },
            //         },
            //         {
            //           $skip: 0,
            //         },
            //         {
            //           $limit: 100,
            //         },

            //         {
            //           $group: {
            //             _id: "$_id",
            //             chatId: { $first: "$chatId" },
            //             senderUid: { $first: "$senderUid" },
            //             message: { $first: "$message" },
            //             messageId: { $first: "$messageId" },
            //             messageType: { $first: "$messageType" },
            //             mediaType: { $first: "$mediaType" },
            //             mediaUrl: { $first: "$mediaUrl" },
            //             is_active: { $first: "$is_active" },
            //             senderDetails: { $first: "$senderDetails" },
            //             groupchatlikes: {
            //               $first: "$groupchatlikes",
            //             },
            //             repliedMessageSenderDetails: {
            //               $first: "$repliedMessageSenderDetails",
            //             },
            //             repliedMessage: {
            //               $push: {
            //                 _id: "$repliedMessage._id",
            //                 chatId: "$repliedMessage.chatId",
            //                 senderUid: "$repliedMessage.senderUid",
            //                 message: "$repliedMessage.message",
            //                 messageId: "$repliedMessage.messageId",
            //                 messageType:
            //                   "$repliedMessage.messageType",
            //                 mediaType: "$repliedMessage.mediaType",
            //                 mediaUrl: "$repliedMessage.mediaUrl",
            //                 is_active: "$repliedMessage.is_active",
            //                 senderDetails:
            //                   "$repliedMessageSenderDetails",
            //               },
            //             },
            //           },
            //         },

            //         {
            //           $project: {
            //             _id: 1,
            //             chatId: 1,
            //             senderUid: 1,
            //             message: 1,
            //             messageId: 1,
            //             messageType: 1,
            //             mediaType: 1,
            //             mediaUrl: 1,
            //             is_active: 1,
            //             groupchatlikes: 1,
            //             senderDetails: 1,
            //             repliedMessageSenderDetails: 1,
            //             repliedMessage: {
            //               $arrayElemAt: [
            //                 {
            //                   $map: {
            //                     input: "$repliedMessage",
            //                     as: "replied",
            //                     in: {
            //                       _id: "$$replied._id",
            //                       chatId: "$$replied.chatId",
            //                       senderUid: "$$replied.senderUid",
            //                       message: "$$replied.message",
            //                       messageId: "$$replied.messageId",
            //                       messageType:
            //                         "$$replied.messageType",
            //                       mediaType: "$$replied.mediaType",
            //                       mediaUrl: "$$replied.mediaUrl",
            //                       is_active: "$$replied.is_active",
            //                       senderDetails:
            //                         "$repliedMessageSenderDetails",
            //                     },
            //                   },
            //                 },
            //                 0,
            //               ],
            //             },
            //           },
            //         },
            //         {
            //           $sort: {
            //             createdAt: -1,
            //           },
            //         },
            //       ]
            // )
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }


    //getOneMessage
    this.getOneGroupMessageDao = async (data) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatMessageModel.aggregate([{
                $match: {
                    _id: ObjectId(data.messageId), is_active: 1
                }
            }, {
                $lookup: {
                    from: 'userprofiles',
                    localField: 'senderUid',
                    foreignField: 'uid',
                    as: 'senderDetails'
                }
            }, { $unwind: '$senderDetails' },
             {
                $project: {
                    "_id": 1,
                    "chatId": 1,
                    "senderUid": 1,
                    "message": 1,
                    "messageId": 1,
                    "messageType": 1,
                    "mediaType": 1,
                    "mediaUrl": 1,
                    "is_active": 1,
                    "createdAt": 1,
                    "updatedAt": 1,
                    "hide": 1,
                    "hideBy":1,
                    "senderDetails": {
                        "uid": 1,
                        "username": 1,
                        "full_name": 1,
                        "profile_photo": 1,
                    }
                }
            }
            ])
          
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.listGroupMessagehiddenDao = async (data) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatMessageModel.aggregate([{
                $match: {
                    chatId: ObjectId(data.chatId), is_active: 1, 
                    // hide: false
                }
            }, {
                $lookup: {
                    from: 'userprofiles',
                    localField: 'senderUid',
                    foreignField: 'uid',
                    as: 'senderDetails'
                }
            }, { $unwind: '$senderDetails' },
            {
                $sort: {
                    createdAt: -1
                }
            },
            {
                $skip: data.pageNumber > 0 ? (data.pageNumber * data.limit) : 0
            },
            {
                $limit: 10
            }, {
                $project: {
                    "_id": 1,
                    "chatId": 1,
                    "senderUid": 1,
                    "message": 1,
                    "messageId": 1,
                    "messageType": 1,
                    "mediaType": 1,
                    "mediaUrl": 1,
                    "is_active": 1,
                    "createdAt": 1,
                    "updatedAt": 1,
                    "hide": 1,
                    "senderDetails": {
                        "uid": 1,
                        "username": 1,
                        "full_name": 1,
                        "profile_photo": 1,
                    }
                }
            }
            ])

            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.listGroupReplyDao = async (data) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatMessageModel.aggregate([{
                $match: {
                    _id: ObjectId(data.messageId), is_active: 1, messageType: 'message'
                }
            }, {
                $lookup: {
                    from: 'userprofiles',
                    localField: 'senderUid',
                    foreignField: 'uid',
                    as: 'senderDetails'
                }
            }, { $unwind: '$senderDetails' },
            {
                $project: {
                    "_id": 1,
                    "chatId": 1,
                    "senderUid": 1,
                    "message": 1,
                    "messageId": 1,
                    "messageType": 1,
                    "mediaType": 1,
                    "mediaUrl": 1,
                    "is_active": 1,
                    "createdAt": 1,
                    "updatedAt": 1,
                    "senderDetails": {
                        "uid": 1,
                        "username": 1,
                        "full_name": 1,
                        "profile_photo": 1,
                    }
                }
            }

            ])
            // console.log("data.pageNumber * data.limit",data.pageNumber * data.limit)

            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.listReactionDao = async (data,authUid) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatLikeModel.aggregate(
               
                [
                    {
                      $match: {
                        messageId: data._id,
                        is_active: 1
                      }
                    },
                    {
                      $lookup: {
                        from: "userprofiles",
                        localField: "senderUid",
                        foreignField: "uid",
                        as: "senderDetails"
                      }
                    },
                    { $unwind: "$senderDetails" },
                    { $sort: { createdAt: -1 } },
                    {
                      $group: {
                        _id: {
                          reaction: "$reaction",
                          uid: "$senderDetails.uid"
                        },
                        count: { $sum: 1 },
                        senderDetails: {
                          $first: {
                            uid: "$senderDetails.uid",
                            username: "$senderDetails.username",
                            full_name: "$senderDetails.full_name",
                            profile_photo: "$senderDetails.profile_photo"
                          }
                        }
                      }
                    },
                    {
                      $group: {
                        _id: "$_id.reaction",
                        count: { $sum: "$count" },
                        reactions: {
                          $push: {
                            full_name: {
                              $cond: {
                                if: {
                                  $eq: ["$_id.uid", authUid]
                                },
                                then: "you",
                                else: "$senderDetails.full_name"
                              }
                            },
                            username: "$senderDetails.username",
                            uid: "$senderDetails.uid",
                            profile_photo: "$senderDetails.profile_photo"
                          }
                        }
                      }
                    },
                    {
                      $project: {
                        _id: 0,
                        type: "$_id",
                        count: 1,
                        users: {
                          $map: {
                            input: "$reactions",
                            as: "reaction",
                            in: {
                              full_name: "$$reaction.full_name",
                              username: "$$reaction.username",
                              uid: "$$reaction.uid",
                              profile_photo: "$$reaction.profile_photo",
                              reaction: "$_id",
                            }
                          }
                        }
                      }
                    }
                  ]
                  
            )
            // console.log("data.pageNumber * data.limit",data.pageNumber * data.limit)
            // console.log('resultLike', result)

            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }


    this.checkPermissionDao = async (data) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatMembersModel.aggregate([{
                $match: {
                    chatId: ObjectId(data.chatId), memberUid: data.uid, is_active: 1
                }
            }
            ])
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }


    this.writePermissionDao = async (data) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatMembersModel.updateOne(
                {
                    _id: ObjectId(data.postId), is_active: 1,
                },
                {
                    $set: {
                        role: data.role
                    }
                }
            )
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    
    this.removeGroupUserDao = async (data) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await GroupChatMembersModel.deleteOne(
                {
                    _id: ObjectId(data.postId), is_active: 1,
                }
            )
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    this.deviceTokenUpdateDao = async (data) => {
        // console.log('input', data)
        var response = {}

        try {
            const result = await MyProfileModal.updateOne(
                {
                    uid: data.uid, is_active: 1,
                },
                {
                    $set: {
                        device_token: data.token
                    }
                }
            )
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.reactMessageDao = async (data) => {
        // console.log('input', data)
        var response = {}

        try {
            const likedresult = await GroupChatLikeModel.findOne(
                {
                    messageId: ObjectId(data.messageId), senderUid: data.uid,
                })
            // console.log("likedresult",likedresult)
            if (likedresult) {
                const result = await GroupChatLikeModel.updateOne(
                    {
                        messageId: ObjectId(data.messageId), senderUid: data.uid,
                    },
                    {
                        $set: {
                            reaction: data.reaction
                        }
                    }
                );
                response.error = false;
                response.result = result;
            } else {
                data.senderUid = data.uid
                const GroupChatReactionModelObject = new GroupChatLikeModel(data)
                const result = await GroupChatReactionModelObject.save();
                console.log("likedresult1", result)
                response.error = false;
                response.result = result;

            }
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    // connectionListDao
    this.listGroupMembersDao = async (data) => {
        var response = {}

        try {
            const result = await GroupChatMembersModel.aggregate([{
                $match: {
                    chatId: ObjectId(data.chatId), is_active: 1
                }
            }, {
                $lookup: {
                    from: 'userprofiles',
                    localField: 'memberUid',
                    foreignField: 'uid',
                    as: 'memberDetails'
                }
            }, { $unwind: '$memberDetails' },
            {
                $sort: {
                    createdAt: -1
                }
            },
            {
                $skip: data.pageNumber > 0 ? (data.pageNumber * data.limit) : 0
            },
            {
                $limit: 10
            },

            ])
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    
    this.groupMemberRoleDao = async (data) => {
        var response = {}

        try {
            const result = await GroupChatMembersModel.aggregate([{
                $match: {
                    chatId: ObjectId(data.chatId),memberUid:data.uid,is_active: 1
                }},{
                    $project:{
                        _id:1,
                        role:1,
                    }
                }
            
            ])
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    this.validateReplyingMessageDao = async (data) => {
        var response = {}
// console.log("validateReplyingMessageDaoInput",data)
        try {
            const result = await GroupChatMessageModel.aggregate([{
                $match: {
                    _id: ObjectId(data.messageId), is_active: 1,messageType:"message"
                }
            }, {
                $lookup: {
                    from: 'userprofiles',
                    localField: 'senderUid',
                    foreignField: 'uid',
                    as: 'senderDetails'
                }
            }, { $unwind: '$senderDetails' },
            {
                $project:{
                    
                        "_id": 1,
                        "chatId": 1,
                        "senderUid": 1,
                        "message": 1,
                        "messageId": 1,
                        "messageType": 1,
                        "mediaType": 1,
                        "mediaUrl": 1,
                        "is_active": 1,
                        "createdAt": 1,
                        "updatedAt": 1,
                        "hide": 1,
                        "senderDetails":1
                    }
            },

            ])
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    this.validateReactMessageDao = async (data) => {
        var response = {}
// console.log("validateReplyingMessageDaoInput",data)
        try {
            const result = await GroupChatMessageModel.aggregate([{
                $match: {
                    _id: ObjectId(data.messageId), is_active: 1
                }
            }, {
                $lookup: {
                    from: 'userprofiles',
                    localField: 'senderUid',
                    foreignField: 'uid',
                    as: 'senderDetails'
                }
            }, { $unwind: '$senderDetails' },
            {
                $project:{
                    
                        "_id": 1,
                        "chatId": 1,
                        "senderUid": 1,
                        "message": 1,
                        "messageId": 1,
                        "messageType": 1,
                        "mediaType": 1,
                        "mediaUrl": 1,
                        "is_active": 1,
                        "createdAt": 1,
                        "updatedAt": 1,
                        "hide": 1,
                        "senderDetails":1
                    }
            },

            ])
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    this.getReactionDao = async (data) => {
        var response = {}
// console.log("validateReplyingMessageDaoInput",data)
        try {
            const result = await GroupChatLikeModel.aggregate([{
                $match:
                {
                    messageId: ObjectId(data.messageId), senderUid: data.uid,is_active: 1
                }
            }, {
                $lookup: {
                    from: 'userprofiles',
                    localField: 'senderUid',
                    foreignField: 'uid',
                    as: 'senderDetails'
                }
            }, { $unwind: '$senderDetails' },
            {
                $project:{
                    
                        "_id": 1,
                        "messageId": 1,
                        "senderUid": 1,
                        "reaction": 1,
                        "is_active": 1,
                        "senderDetails":1
                    }
            },

            ])
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }

    this.listconnectionsDao = async (data, skip, limit) => {
        var response = {}

        try {
            const result = await MyProfileModal.aggregate([{
                $match: {
                    is_active: 1
                }
            },
            {
                $sort: {
                    createdAt: -1
                }
            },
            {
                $skip: data.pageNumber && data.pageNumber > 0 ? (skip) : 0
            },
            {
                $limit: limit
            },

            ])
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }
    this.listconnectionsCountDao = async (data) => {
        var response = {}

        try {
            const result = await MyProfileModal.find({
                is_active: 1,
            })
                .count()
            response.error = false;
            response.result = result;
            return response;
        } catch (error) {
            console.log(error)
            response.error = true;
            return response;
        }
    }



    // this.listGroupMembersDao = async (data) => {
    //     var response = {}

    //     try {
    //         const result = await GroupChatMembersModel.aggregate([{
    //             $match: {
    //                 chatId: ObjectId(data.chatId), is_active: 1
    //             }
    //         }, {
    //             $lookup: {
    //                 from: 'userprofiles',
    //                 localField: 'memberUid',
    //                 foreignField: 'uid',
    //                 as: 'memberDetails'
    //             }
    //         }, { $unwind: '$memberDetails' }
    //         ])
    //         response.error = false;
    //         response.result = result;
    //         return response;
    //     } catch (error) {
    //         console.log(error)
    //         response.error = true;
    //         return response;
    //     }
    // }
}
