module.exports = function () {
    var PinoyPreneursModel = require('../../modal/web/PinoyPreneursModel')
    var MyProfileModal = require('../../modal/web/MyProfileModal')
    var PinoyPreneursProductModel = require('../../modal/web/PinoyPreneursProductModel')
    var SubscriptionPlansModel = require('../../modal/admin/SubscriptionPlansModel')
    var SubscriptionModel = require('../../modal/web/SubscriptionModel')
    var myProfileModal = require('../../modal/web/MyProfileModal')







    this.addPinoyPreneurDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            const PinoyPreneursModelObject = new PinoyPreneursModel(data)
            PinoyPreneursModelObject.save(function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }

    this.getOneUserDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            MyProfileModal.findOne({
                uid: data.uid
            }, function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }

    this.getOneProfileDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            myProfileModal.findOne({
                uid: data.uid
            }).lean()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.addPinoyPreneurProductsDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            PinoyPreneursProductModel.insertMany(data, function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }

    this.updateUserStatusDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            MyProfileModal.updateOne({
                uid: data.uid
            }, {
                $set: {
                    user_status: data.position,
                    pinoy_preneur: 1
                }
            })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.checkPinoyPreneurDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            PinoyPreneursModel.findOne({
                uid: data.uid
            }, function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }


    this.getTotaltPinoyPreneursListCountDao = async (data, getBlockedUsers) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            var typesOfIndustry = {
                is_active: 1
            }
            var natureOfBusiness = {
                is_active: 1
            }
            if (data.types_of_industry.length > 0) {
                typesOfIndustry = {
                    category: {
                        $in: data.types_of_industry
                    }
                }
            }
            if (data.nature_of_business.length > 0) {
                natureOfBusiness = {
                    nature_of_business: {
                        $in: data.nature_of_business
                    }
                }
            }
            PinoyPreneursModel.find({
                $and: [{
                    is_active: 1
                },
                {
                    status: 'active'
                }, {
                    $or: [{
                        business_name: {
                            $regex: `${data.search}`,
                            $options: 'i'
                        }
                    },
                    {
                        business_description: {
                            $regex: `${data.search}`,
                            $options: 'i'
                        }
                    },
                    {
                        category: {
                            $regex: `${data.search}`,
                            $options: 'i'
                        }
                    }
                    ]
                }, typesOfIndustry,
                    natureOfBusiness,
                { uid: { $nin: getBlockedUsers[0] } }, // Exclude the users that the current user has blocked
                { uid: { $nin: getBlockedUsers[1] } } // Exclude the users that have blocked the current user
                ]
            })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.GetPinoyPreneursListDao = async (data, getBlockedUsers) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            var typesOfIndustry = {
                is_active: 1
            }
            var natureOfBusiness = {
                is_active: 1
            }
            if (data.types_of_industry.length > 0) {
                typesOfIndustry = {
                    category: {
                        $in: data.types_of_industry
                    }
                }
            }
            if (data.nature_of_business.length > 0) {
                natureOfBusiness = {
                    nature_of_business: {
                        $in: data.nature_of_business
                    }
                }
            }
            PinoyPreneursModel.aggregate([{
                $match: {
                    $and: [{
                        $expr: {
                            $eq: ["$is_active", 1]
                        }
                    },
                    {
                        status: 'active'
                    },
                    {
                        $or: [{
                            business_name: {
                                $regex: `${data.search}`,
                                $options: 'i'
                            }
                        },
                        {
                            business_description: {
                                $regex: `${data.search}`,
                                $options: 'i'
                            }
                        },
                        {
                            category: {
                                $regex: `${data.search}`,
                                $options: 'i'
                            }
                        }
                        ]
                    },
                        typesOfIndustry,
                        natureOfBusiness,
                    { uid: { $nin: getBlockedUsers[0] } }, // Exclude the users that the current user has blocked
                    { uid: { $nin: getBlockedUsers[1] } } // Exclude the users that have blocked the current user
                    ]

                }
            },
            {
                $lookup: {
                    from: "pinoypreneursproducts",
                    let: {
                        pinoy_preneurId: {
                            "$toString": "$_id"
                        },
                        userId: "$uid"
                    },
                    pipeline: [{
                        $match: {
                            $expr: {
                                $and: [{
                                    $eq: ["$PinoyPreneur_id", "$$pinoy_preneurId"],
                                    //   $eq: ["$uid", "$$userId"]
                                }]
                            }
                        }
                    }],
                    as: "pinoyPreneur_products"
                }
            },
            {
                $sort: {
                    createdAt: -1
                }
            },
            {
                $skip: data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0
            },
            {
                $limit: 10
            },
            {
                $project: {
                    _id: 1,
                    business_logo: 1,
                    business_name: 1,
                    business_description: {
                        $substrBytes: ["$business_description", 0, 160]
                    },
                    category: 1,
                    province_name: 1,
                    postal_code: 1,
                    template_id: 1,
                    uid: 1,
                    profile_photo: 1,
                    full_name: 1,
                    position: 1,
                    is_active: 1,
                    createdAt: 1,
                    rating: 1,
                    pinoyPreneur_products: 1,
                    status: 1,
                    location: 1

                }
            },

            ])
                // .skip(data.articlePageNumber > 0 ? ((data.articlePageNumber - 1) * 10) : 0)
                // .limit(10).
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.GetOnePinoyPreneurDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            PinoyPreneursModel.findOne({
                is_active: 1,
                _id: data.PinoyPreneur_id
            }).lean()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.GetOnePinoyPreneurProductsDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            PinoyPreneursProductModel.find({
                is_active: 1,
                PinoyPreneur_id: data.PinoyPreneur_id
            })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.updatePinoyPreneurDao = async (data, object) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            PinoyPreneursModel.updateOne({
                is_active: 1,
                _id: data.PinoyPreneur_id
            }, {
                $set: object
            })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.updatePinoyPreneurProductDao = async (data, object) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            PinoyPreneursProductModel.updateOne({
                is_active: 1,
                _id: data._id
            }, {
                $set: object
            })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)
                    console.log(error);
                });
        })
    }


    this.PinoyPreneurProductDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            PinoyPreneursProductModel.findOne({
                is_active: 1,
                _id: data._id
            })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }



    this.savePinoyPreneurProductDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            const PinoyPreneursProductModelObject = new PinoyPreneursProductModel(data)
            PinoyPreneursProductModelObject.save(function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }



    this.checkUserPinoyPreneurDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            MyProfileModal.findOne({
                uid: data.uid
            }, {
                uid: 1,
                pinoy_preneur: 1,
                is_active: 1
            }, function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }





    this.getSubscriptionDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SubscriptionPlansModel.findOne({
                is_active: 1,
                post_type: 'businessDirectory'
            }).lean()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.addJobPostSubscriptionDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            const SubscriptionModelobject = new SubscriptionModel(data)
            SubscriptionModelobject.save(function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }





    this.deletePinoyPreneurProductsDao = async (data, productIds) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            PinoyPreneursProductModel.deleteMany({
                PinoyPreneur_id: data.PinoyPreneur_id,
                _id: {
                    $nin: productIds
                },
            })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }




    this.getOneSubscriptionDetailDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            SubscriptionPlansModel.findOne({
                is_active: 1,
                post_type: "businessDirectory"
            })
                .lean()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.checkOnePinoyPreneurDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            PinoyPreneursModel.findOne({
                is_active: 1,
                uid: data.uid
            }).lean()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }




}