module.exports = function () {
    var RatingModel = require('../../modal/web/RatingModel')
    var MyProfileModal = require('../../modal/web/MyProfileModal')
    var PinoyPreneursModel = require('../../modal/web/PinoyPreneursModel')






    this.addRatingDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {

            const RatingModelObject = new RatingModel(data)
            RatingModelObject.save(function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.result = result
                }
                resolve(response)
            })
        })
    }




    this.getOneUserDao = async (data) => {
        // console.log('getOneUserDao',data)
        var response = {}
        return new Promise(function (resolve, reject) {
            MyProfileModal.findOne({
                uid: data.uid
            }, function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }

    this.getOnePostDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            RatingModel.findOne({
                uid: data.uid,
                rating_id: data.rating_id
            }, function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }

    this.getRatingListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            RatingModel.find({
                rating_id: data.rating_id
            }, function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }

    this.updateRatingDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            RatingModel.updateOne({
                    uid: data.uid,
                    rating_id: data.rating_id
                }, {
                    $set: {
                        rating: data.rating,
                        updatedAt: Date.now()
                    }
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.updatePinoyPreneurRatingDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            PinoyPreneursModel.updateOne({
                    _id: data.rating_id
                }, {
                    $set: {
                        rating: data.rating,
                    }
                })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    this.totalRatingList = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            RatingModel.find({
                $and: [{
                    is_active: 1
                }, {
                    rating_id: data.rating_id
                }, {
                    uid: data.uid
                }]
            }, function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    response.data = result
                }
                resolve(response)
            })
        })
    }
}