module.exports = function () {
  var tambayanModal = require('../../modal/web/TambayanModal')

  this.getTotaltambayanListCountDao = async (data,getBlockedUsers) => {
    var response = {}
    return new Promise(function (resolve, reject) {
        tambayanModal.find({
                is_active: 1,
                uid: { $nin: [...getBlockedUsers[0], ...getBlockedUsers[1]] },
            })
            .count()
            .then((result) => {
                response.error = false
                response.data = result
                // console.log(result);
                resolve(response)

            })
            .catch((error) => {
                response.error = true
                resolve(response)

                console.log(error);
            });
    })
}

this.gettambayanListDao = async (data,getBlockedUsers) => {
    var response = {}
    return new Promise(function (resolve, reject) {
        tambayanModal.find({
                is_active: 1,
                uid: { $nin: [...getBlockedUsers[0], ...getBlockedUsers[1]] },
            }).sort({"createdAt":-1})
            .skip(data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0)
            .limit(10)
            .then((result) => {
                response.error = false
                response.data = result
                // console.log(result);
                resolve(response)

            })
            .catch((error) => {
                response.error = true
                resolve(response)

                console.log(error);
            });
    })
  }
  this.tambayanPostDao = async (data) => {
    // console.log("payload",data)
      var response = {}
      return new Promise(function (resolve, reject) {
 
        const tambayanModalObject = new tambayanModal(data)
        tambayanModalObject.save(function (error, result) {
            // console.log("res",result)
          if (error) {
            console.log(error)
            response.error = true
          } else {
            response.error = false
            response.data = result
          }
          // console.log("daata",response)
          resolve(response)
        })
      })
    }

    this.viewPostDao = async (data) => {
      var response = {}
      return new Promise(function (resolve, reject) {
 
        tambayanModal.find({_id:data.post_id},function (error, result) {
            // console.log("res",result)
          if (error) {
            console.log(error)
            response.error = true
          } else {
            response.error = false
            response.data = result
          }
          // console.log("daata",response)
          resolve(response)
        })
      })
    }


    this.editOnePostDao = async (data) => {
      var response = {}
      return new Promise(function (resolve, reject) {
        tambayanModal.updateOne({
                  _id: data.post_id
              }, {
                  $set: {
                    subject:data.subject,
                    description:data.description,
                    file_type:data.file_type,
                    file_url:data.file_url,
                    template_id:data.template_id
                  }
              })
              .then((result) => {
                  response.error = false
                  response.result = result
                  // console.log(result);
                  resolve(response)

              })
              .catch((error) => {
                  response.error = true
                  resolve(response)

                  console.log(error);
              });
      })
  }


  this.deleteOneTambayanDao = async (data) => {
    var response = {}
    return new Promise(function (resolve, reject) {
      tambayanModal.deleteOne({
                _id: data.post_id
            })
            .then((result) => {
                response.error = false
                response.result = result
                // console.log(result);
                resolve(response)

            })
            .catch((error) => {
                response.error = true
                resolve(response)

                console.log(error);
            });
    })
}

}
