module.exports = function () {
    var JobCentreModel = require('../../modal/web/JobCentreModel')
    var MyProfileModal = require('../../modal/web/MyProfileModal')
    var jobCentreDraftModel = require('../../modal/web/jobCentreDraftModel')
    var JobFairModel = require('../../modal/admin/JobFairModel')
    var SubscriptionModel = require('../../modal/web/SubscriptionModel')
    var SubscriptionPlansModel = require('../../modal/admin/SubscriptionPlansModel')
    var couponModel = require('../../modal/web/CouponModel')
    var ObjectId = require('mongodb').ObjectId;
    var notificationModel = require('../../modal/web/notificationModel')
    var connectionModel = require('../../modal/web/connectionModel')






    this.getTotalNotificationListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {

            notificationModel.find({
                $and: [{
                    is_active: 1
                }, {
                    uid: data.uid
                }]
            })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }


    this.getNotificationListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {

            notificationModel.aggregate([{
                $match: {
                    $and: [{
                        $expr: {
                            $eq: ["$is_active", 1]
                        }
                    }, {
                        uid: data.uid
                    }]
                }
            },
            {
                $sort: {
                    createdAt: -1
                }
            },
            {
                $skip: data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0
            },
            {
                $limit: 10
            },
            {
                $project: {
                    _id: 1,
                    uid: 1,
                    post_id: 1,
                    post_type: 1,
                    sender: 1,
                    user_name: 1,
                    user_profile: 1,
                    post_module: 1,
                    notification_message: 1,
                    read: 1,
                    is_active: 1,
                    createdAt: 1,
                    updatedAt: 1,
                }
            }
            ])
                // .skip(data.pageNumber > 0 ? ((data.pageNumber - 1) * 10) : 0)
                // .limit(10)
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }
    this.getCouponDetails = async (data) => {
        // console.log('getCouponDetails',data)
        var data = data.toString()
        var response = {}
        return new Promise(function (resolve, reject) {
            couponModel.aggregate([

                {
                    $match: {
                        is_active: 1,
                        _id: ObjectId(data)
                    }
                },


            ]).then((result) => {
                response.error = false
                response.result = result
                // console.log(result);
                resolve(response)

            })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })

    }
    // getConnectionDetails

    this.getConnectionDetails = async (data) => {
        console.log('getConnectionDetails', data)
        var data = data.toString()
        var response = {}
        return new Promise(function (resolve, reject) {
            connectionModel.aggregate([

                {
                    $match: {
                        is_active: 1,
                        _id: ObjectId(data)
                    }
                },


            ]).then((result) => {
                response.error = false
                response.result = result
                // console.log(result);
                resolve(response)

            })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })

    }


    //getConversation

    this.getConversationDetails = async (data) => {
        console.log('getConversationDetails', data)
        var data = data.toString()
        var response = {}
        return new Promise(function (resolve, reject) {
            connectionModel.aggregate([

                {
                    $match: {
                        is_active: 1,
                        _id: ObjectId(data)
                    }
                },


            ]).then((result) => {
                response.error = false
                response.result = result
                // console.log(result);
                resolve(response)

            })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })

    }




    this.getNotificationUnreadCountListDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {

            notificationModel.find({
                $and: [{
                    is_active: 1
                }, {
                    uid: data.uid
                },
                {
                    read: 0
                },
                ]
            })
                .count()
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }



    this.updateNotificationDao = async (data) => {
        var response = {}
        return new Promise(function (resolve, reject) {
            notificationModel.updateOne({
                _id: data.id
            }, {
                $set: {
                    read: 1
                }
            })
                .then((result) => {
                    response.error = false
                    response.result = result
                    // console.log(result);
                    resolve(response)

                })
                .catch((error) => {
                    response.error = true
                    resolve(response)

                    console.log(error);
                });
        })
    }

    // var fcmNotifications=async(responseNotification)=>{
  
    // }


    this.addNotificationDao = async (data) => {
        console.log("addNotificationDaoInput", data)
        var response = {}

        return new Promise(function (resolve, reject) {
            const notificationModelObject = new notificationModel(data)
            notificationModelObject.save(function (error, result) {
                if (error) {
                    console.log(error)
                    response.error = true
                } else {
                    response.error = false
                    console.log("addNotificationDaoresponse2", result)
                    if (data.post_module == 'coupons') {
                        var newObj = Object.assign(result['_doc']);
                        // console.log("newObj5", newObj)
                        newObj.post_id = data.couponId
                        console.log("newObj4", newObj)
                    }
                    response.data = result
                    // console.log("addNotificationDaoresponse", response)


                    // res={}
                    // res.coupon='haaiiii'
                    global.io.emit(data.uid, JSON.stringify(response.data))
                    global.io.emit("notifications", JSON.stringify(result))
                    
                    // // deviceToken get method
                    // var getOneProfile = await MyprofileObject.getOneProfileDao({ user_id: objRes.uid })
                    // objRes.device_token = getOneProfile.data.device_token

                    // fcm notification
                    // fcmNotifications(response.data)

                }
                resolve(response)
            })
        })

    }
   

    // this.updateNotificationConversationDao = async (data) => {
    //     console.log("updateNotificationConversationDaoInput",data)
    //     var response = {};
    //     try {
    //       const result = 
    //         await messageModal.updateMany(
    //           { chatId: ObjectId(data),read:false },
    //           { $set: { read:true} }
    //         )
    //       response.error = false;
    //       response.result = result;
    //       console.log("resDao",response)
    //       return response;

    //     } catch (error) {
    //     console.log("errorDao",error)
    //       response.error = true;
    //       return response;
    //     }
    //   };


    //   this.updateNotificationConversationDao = async (data) => {
    //     var response = {}
    //     return new Promise(function (resolve, reject) {
    //         messageModal.updateMany(
    //             { chatId: ObjectId(data),read:false },
    //             { $set: { read:true} }
    //           )
    //             .then((result) => {
    //                 response.error = false
    //                 response.result = result
    //                 // console.log(result);
    //                 resolve(response)

    //             })
    //             .catch((error) => {
    //                 response.error = true
    //                 resolve(response)

    //                 console.log(error);
    //             });
    //     })
    // }
}