const mongoose = require("mongoose");

const Schema = mongoose.Schema;

const AdsSchema = new Schema({
  postedBy: {
    type: String,
    required: false,
    default: null
  },
  adUrl: {
    type: String,
    default: null
  },
  link: {
    type: String,
    default: null
  },

  mediaType: {
    type: String,
    default: null
  },

  location: {
    type: String,
    default: null,
  },
  title: {
    type: String,
    default: null
  },

  isActive: {
    type: Number,
    required: false,
    default: 1
  },
  type: {
    type: String,
    required: false,
    default: null
  },
  postType: {
    type: String,
    required: false,
    default: null
  },
}, {
  timestamps: {
    createdAt: "createdAt",
    updatedAt: "updatedAt",
  },
}, {
  versionKey: false
});

const AdsModal = mongoose.model("Ads", AdsSchema);

module.exports = AdsModal;