const mongoose = require("mongoose");

const Schema = mongoose.Schema;

const AdViewersSchema = new Schema({
  adId: {
    type: mongoose.Schema.Types.ObjectId,
    ref: 'Ads',
    required: true
  },
  viewedBy: {
    type: String,
    default: null
  },

  isActive: {
    type: Number,
    default: 1
  },
  viewedAt: {
    type: Date,
    default: Date.now
  },
  type: {
    type: String,
    default: Date.now
  },
}, {
  timestamps: {
    createdAt: "createdAt",
    updatedAt: "updatedAt",
  },
}, {
  versionKey: false
});

const AdViewersModal = mongoose.model("AdViewers", AdViewersSchema);

module.exports = AdViewersModal;