const mongoose = require("mongoose");

const Schema = mongoose.Schema;

const AdsSchema = new Schema({
  adId: {
    type: mongoose.Schema.Types.ObjectId,
    ref: 'Ads',
    required: true
  },
  assignedUid: {
    type: String,
    default: null
  }, 

  isActive: {
    type: Number,
    required: false,
    default: 1
  },

}, {
  timestamps: {
    createdAt: "createdAt",
    updatedAt: "updatedAt",
  },
}, {
  versionKey: false
});

const AdsModal = mongoose.model("assignedAds", AdsSchema);

module.exports = AdsModal;