const mongoose = require("mongoose");

const Schema = mongoose.Schema;

const newPinoysSchema = new Schema({
  Uid: {
    type: String,
    required: false,
    default: null
  },
  thumbNail_url: {
    type: String,
    required: [false, "thumbNail_url is required"],
  },
  backGround_imageUrl: {
    type: String,
    required: [false, "backGround_imageUrl is required"],
  },

  mediaType: {
    type: String,
    required: [false, "mediaType is required"]
  },

  province_name: {
    type: String,
    required: [false, "province_name is required"],
    default: null,
  },
  title: {
    type: String,
    required: [false, "title is required"],
  },
  description: {
    type: String,
    required: [false, "description is required"],
  },

  is_active: {
    type: Number,
    required: false,
    default: 0
  },

  number_of_likes: {
    type: Number,
    default: 0
  },
  number_of_comments: {
    type: Number,
    default: 0
  },
  pinStatus: {
    type: Boolean,
    default: false
  },
}, {
  timestamps: {
    createdAt: "createdAt",
    updatedAt: "updatedAt",
  },
}, {
  versionKey: false
});

const newPinoysModal = mongoose.model("newPinoys", newPinoysSchema);

module.exports = newPinoysModal;