const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const podCastEpisodeSchema = new Schema({

    uid: {
        type: String,
        required: false,
        default: null
    },

    title: {
        type: String,
        required: false,
        default: null
    },
    podcast_id: {
        type: String,
        required: false,
        default: null
    },
    audio_url: {
        type: String,
        required: false,
        default: null
    },
    description: {
        type: String,
        required: false,
        default: null
    },
    is_active: {
        type: Number,
        default: 0,
        required: false
    },
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    }
}, {
    versionKey: false
})

const podCastEpisodeModel = mongoose.model('podCastEpisode', podCastEpisodeSchema)
module.exports = podCastEpisodeModel