const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const podCastsSchema = new Schema({

    uid: {
        type: String,
        required: false,
        default: null
    },

    title: {
        type: String,
        required: false,
        default: null
    },
    author_imageUrl: {
        type: String,
        required: false,
        default: null
    },
    team: {
        type: String,
        required: false,
        default: null
    },
    description: {
        type: String,
        required: false,
        default: null
    },
    total_episodes: {
        type: Number,
        default: 0,
        required: false
    },
    is_active: {
        type: Number,
        default: 0,
        required: false
    },
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    }
}, {
    versionKey: false
})

const podCastsModel = mongoose.model('podcasts', podCastsSchema)
module.exports = podCastsModel