const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const commentsSchema = new Schema({

    uid: {
        type: String,
        required: true,
        default: null
    },
    post_id: {
        type: String,
        required: true,
        default: null
    },
    number_of_replies: {
        type: Number,
        default: 0
    },
    number_of_likes: {
        type: Number,
        default: 0
    },
    comment_description: {
        type: String,
        required: true,
        default: null
    },
    comment_ref: {
        type: Number,
        default: 0,
        required: false
    },
    comment_ref_id: {
        type: String,
        default: null,
        required: true
    },
    post_type: {
        type: String,
        required: true,
        default: null
    },
    full_name: {
        type: String,
        default: null
    },
    profile_photo: {
        type: String,
        default: null
    },
    is_active: {
        type: Number,
        default: 0,
        required: false
    },
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    }
})

const addFoodTripPost = mongoose.model('commentsList', commentsSchema)
module.exports = addFoodTripPost