const mongoose=require('mongoose');
const Schema=mongoose.Schema;

const couponSchema= new Schema({
    uid: {
        type: String,
        default: null
    },
    coupon_image: {
        type: String,
        default: null
    },
    coupon_name: {
        type: String,
        default: null
    },
    coupon_id: {
        type: String,
        default: null
    },
    coupon_description: {
        type: String,
        default: null
    },
    offer_type: {
        type: String,
        default: null
    },
    offer_value: {
        type: String,
        default: 0
    },
    total_Number_of_coupons:{
        type: Number,
        default: 0
    },
    claimed_coupons:{
        type: Number,
        default: 0
    },
    downloaded_coupons:{
        type: Number,
        default: 0
    },
    usage_limit_per_user: {
        type: Number,
        default: 0
    },
    coupon_validity_from: {
        type: Date,
        default: 0
    },
    coupon_validity_to: {
        type: Date,
        default: 0
    },
    province: {
        type: String,
        default: null
    },
    terms_and_condition: {
        type: String,
        default: null
    },
   
    is_active: {
        type: Number,
        default: 0
    },
    local_coupon_validity_from:{
        type:String,
        default:null
    },
    local_coupon_validity_to:{
        type:String,
        default:null
    },
    deleted:{
        type:String,
        default:"false"
    }


}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },

})

const couponDetails = mongoose.model('CouponDetails', couponSchema)
module.exports = couponDetails