const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const addFoodTripPostSchema = new Schema({

    uid: {
        type: String,
        default: null
    },
    post_description: {
        type: String,
        default: null
    },
    post_images: {
        type: Array,
        default: []
    },
    post_type: {
        type: String,
        default: null
    },
    hashtags: {
        type: String,
        default: null
    },
    location: {
        type: String,
        default: null
    },
    youtube_link:{
        type: String,
        default: null
    },
    number_of_likes: {
        type: Number,
        default: 0
    },
    number_of_comments: {
        type: Number,
        default: 0
    },
    profile_photo: {
        type: String,
        default: null
    },
    post_id: {
        type: String,
        default: null
    },
    full_name: {
        type: String,
        default: null
    }, 
    share_count: {
        type: Number,
        default: 0
    },
    hidden:{
        type: Number,
        default: 0
    },
    is_active: {
        type: Number,
        default: 0
    },

}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },

})

const addFoodTripPost = mongoose.model('FoodTripPosts', addFoodTripPostSchema)
module.exports = addFoodTripPost