const mongoose = require('mongoose')
const Schema = mongoose.Schema;

const groupChatMembers = new Schema({
    
    chatId: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'groupChatDetails',
        required: true
    },
    memberUid: {
        type: String,
        ref: 'userProfile',
        required: true
      },
    role: {
        type: String,
        default: null
    },
    is_active: {
        type: Number,
        default: 0
    },

}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },
})

const Members = mongoose.model('groupChatMembers', groupChatMembers)
module.exports = Members