const mongoose = require('mongoose')
const Schema = mongoose.Schema;

const groupChatMessages = new Schema({
    
    chatId: {
        type: mongoose.Schema.Types.ObjectId,
        ref: 'groupChatDetails',
        required: true
    },
    senderUid: {
        type: String,
        ref: 'userProfile',
        required: true
      },
    message: {
        type: String,
        default: null
    },
    messageId: {
        type: mongoose.Schema.Types.ObjectId,
        default: null
    },
    messageType: {
        type: String,
        default: 'message'
    },
    mediaType: {
        type: String,
        default: null
    },
    mediaUrl: {
        type: String,
        default: null
    },
    hide: {
        type: Boolean,
        default : false
    },
    hideBy: {
        type: mongoose.Schema.Types.Mixed,
        default:null
    },
    is_active: {
        type: Number,
        default: 0
    },
    

}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },
})

const GroupMessages = mongoose.model('groupChatMessages', groupChatMessages)
module.exports = GroupMessages