const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const PinoyPreneursSchema = new Schema({
    uid: {
        type: String,
        default: null
    },
    business_logo: {
        type: String,
        default: null

    },
    business_name: {
        type: String,
        default: null

    },
    business_description: {
        type: String,
        default: null
    },
    nature_of_business: {
        type: String,
        default: null

    },
    category: {
        type: String,
        default: 0
    },
    professional_license_number: {
        type: String,
        default: 0
    },
    brokerage_license_number: {
        type: String,
        default: null
    },
    company_website_link: {
        type: String,
        default: null
    },
    company: {
        type: String,
        default: null
    },
    email_id: {
        type: String,
        default: null
    },
    phone_number: {
        type: Number,
        default: null
    },
    address: {
        type: String,
        default: null
    },
    city: {
        type: String,
        default: null
    },
    province_name: {
        type: String,
        default: null
    },
    postal_code: {
        type: String,
        default: null
    },
    position: {
        type: String,
        default: null
    },
    template_id: {
        type: Number,
        default: null
    },
    profile_photo: {
        type: String,
        default: null
    },
    full_name: {
        type: String,
        default: null
    },
    rating: {
        type:String,
        default: 0
    },
    is_active: {
        type: Number,
        default: 0
    },
    end_time: {
        type: Date,
        default: 0
    },
    complimentary_period: {
        type: Date,
        default: 0
    },
    location: {
        type: String,
        default: null
    },
    status: {
        type: String,
        default: null
    }
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },

}, {
    versionKey: false
})

const PinoyPreneurs = mongoose.model('PinoyPreneurs', PinoyPreneursSchema)
module.exports = PinoyPreneurs