const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const reportSchema = new Schema({
    post_id : {
        type: mongoose.Schema.Types.ObjectId,
        required:true,
    },
    post_type:{
        type:String,
        required:true
    },
    userId : {
        type:String,
        required:true
    },
    reason:{
        type:mongoose.Schema.Types.Array,
        required:true
    },
    show : {
        type : Number,
        default : 1
    }
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },

}, {
    versionKey: false
})

const report = mongoose.model('report', reportSchema)
module.exports = report