const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const subscriptionSchema = new Schema({
    uid: {
        type: String,
        default: null
    },
    user_name: {
        type: String,
        default: null
    },
    post_id: {
        type: String,
        default: null
    },
    post_type: {
        type: String,
        default: null
    },
    subscription_validity: {
        type: Number,
        default: 0
    },
    subscription_validity_type: {
        type: String,
        default: null
    },
    start_time: {
        type:  Date,
        default: 0
    },
    end_time: {
        type:  Date,
        default: 0
    },
    is_active: {
        type: Number,
        default: 0
    },
    status: {
        type: String,
        default: null
    }
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },

}, {
    versionKey: false
})

const subscription = mongoose.model('subscription', subscriptionSchema)
module.exports = subscription