const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const surveySchema = new Schema({

    uid: {
        type: String,
        default: null
    },
    question: {
        type: String,
        default: null
    },
    options: {
        type: Array,
        required: true
    },
    votes: {
        type: Number,
        default: 0,
        required: false
    },
    is_active: {
        type: Number,
        default: 0,
        required: false
    },
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    }
})

const survey = mongoose.model('survey', surveySchema)
module.exports = survey