//to connect the app with mongo db
const mongoose = require('mongoose');
const AutoIncrement = require('mongoose-sequence')(mongoose);

//create schema
const messageSchema = mongoose.Schema(
  {
    sender: {
      type: String,
      ref: 'userProfile',
    },
    message : {
      type: String,
      trim:true
    },
    chatId: {
      type: mongoose.Schema.Types.ObjectId,
      ref: 'Conversation',
    },
    media_type: {
      type: String,
    },
    media_url:{
      type: String,
      default : null
    },
    read:{
      type: Boolean,
      default : false
    },
  },
  {timestamps: true}
);

//create model
exports.Message = mongoose.model('Message', messageSchema);