const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const paymentHistorySchema = new Schema({
    uid: {
        type: String,
        default: null
    },
    post_id: {
        type: String,
        default: 0
    },
    post_type: {
        type: String,
        default: 0
    },
    payment_ref_id: {
        type: String,
        default: 0
    },
    amount_total: {
        type: String,
        default: null
    },
    payment_status: {
        type: String,
        default: null
    },
    livemode: {
        type: String,
        default: null
    },
    status: {
        type: String,
        default: null
    },
    payment_method_types:{
        type: Array,
        default: []
    },
    is_active: {
        type: Number,
        default: 0
    }
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },

}, {
    versionKey: false
})

const paymentHistory = mongoose.model('paymentHistory', paymentHistorySchema)
module.exports = paymentHistory