const mongoose = require('mongoose')

const Schema = mongoose.Schema;

const scheduleLiveSchema = new Schema({
    uid: {
        type: String,
        default: null
    },
    time_slot: {
        type: String,
        default: null
    },
    title: {
        type: String,
        default: []
    },
    short_description: {
        type: String,
        default: null
    },
    live_date: {
        type: String,
        default: null
    },
    start_time: {
        type: Date,
        default: null
    },
    end_time: {
        type: Date,
        default: null
    },
    profile_photo: {
        type: String,
        default: null
    },
    full_name: {
        type: String,
        default: null
    },
    session_payment: {
        type: String,
        default: null
    },
    slotId: {
        type: Number,
        default: 0,
        required: false
    },
    payment_status: {
        type: String,
        default: "pending"
    },
    is_active: {
        type: Number,
        default: 0
    },
    status: {
        type: String,
        default: null
    }
}, {
    timestamps: {
        createdAt: 'createdAt',
        updatedAt: 'updatedAt'
    },

}, {
    versionKey: false
})

const scheduleLive = mongoose.model('scheduleLive', scheduleLiveSchema)
module.exports = scheduleLive