var express = require('express');
const app = express();
require('dotenv').config()
const path = require('path');
const { userJoin, getCurrentUser, userLeave, getRoomUsers } = require('./utils/users')

// profile details
const myprofile = require('./modal/web/MyProfileModal')
const GroupChatMembersModel = require('./modal/web/GroupChatMembersModel')
var ObjectId = require('mongodb').ObjectId;

var LikesModal = require('./modal/web/Likes')

app.use((req, res, next) => {
    if (req.originalUrl === '/webhook') {
        console.log("req.originalUrl", req.originalUrl)
        next();
    } else {
        express.json()(req, res, next);
    }
});

app.use('/assets', express.static(__dirname + '/assets'));

const webhooks = require('./routes/web/jobCentreRoutes')
const cors = require('cors')
const bodyParser = require('body-parser')
// app.use('/web/webhook', express.raw({ type: 'application/json' }),webhooks)
app.use('/web/webhook', express.raw({ type: 'application/json' }))
app.use(express.json());

const mongoose = require('./config/dfConfig')

app.use(cors())

app.use('/public/uploads', express.static(path.join(__dirname, '/public/uploads')));

// app.use(bodyParser.json({
//     limit: '2mb'
// }))
app.use(bodyParser.urlencoded({
    limit: '2mb',
    extended: true
}))

app.use((req, res, next) => {
    if (req.originalUrl === '/webhook') {
        console.log("req.originalUrl body parser", req.originalUrl)
        next();
    } else {
        bodyParser.json({
            limit: '2mb'
        })(req, res, next);
    }
});

//   app.use((req, res, next) => {
//     if (req.originalUrl === '/webhook') {
//         console.log("req.originalUrl body parser",req.originalUrl)
//       next();
//     } else {
//         bodyParser.urlencoded({
//             limit: '2mb',
//             extended: true
//         })(req, res, next);
//     }
//   });




app.disable("x-powered-by")

app.use('/', function (request, response, next) {
    request.headers.lang = request.headers.lang || 'default'
    console.log('Method: ' + request.method + ' Route: ' + request.originalUrl + ' Body: ' +
        JSON.stringify(request.body)
    )
    next()
})
const http = require('http').Server(app)


var admin = require("firebase-admin");
var serviceAccount = require('./Auth/Key/mykapitbahay-firebase-adminsdk.json');

admin.initializeApp({
    credential: admin.credential.cert(serviceAccount)
});


async function Verifyauth(request, res, next) {
    // console.log('requestVerifyauth',request.body,request.header,res,next)
    var error = {}
    var response = {}
    try {
        var authorization = request.headers.authorization
        request.body.uid = 0;

        if (authorization == 'NoAuth') {
            switch (request.originalUrl) {
                case '/web/WhatsUpCanadaHome':
                    console.log('/web/WhatsUpCanadaHome')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/getArticleList':
                    console.log('/web/getArticleList')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/getProudlyPinoyList':
                    console.log('/web/getProudlyPinoyList')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/getPodcastList':
                    console.log('/web/getPodcastList')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/getVideoFeedList':
                    console.log('/web/getVideoFeedList')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/viewOneArticle':
                    console.log('/web/viewOneArticle')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/viewPodcast':
                    console.log('/web/viewPodcast')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/relatedPodcastList':
                    console.log('/web/relatedPodcastList')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/relatedArticleList':
                    console.log('/web/relatedArticleList')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/newPinoysArticleList':
                    console.log('/web/newPinoysArticleList')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/newPinoysArticleDetails':
                    console.log('/web/newPinoysArticleDetails')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/newPinoysRelatedArticles':
                    console.log('/web/newPinoysRelatedArticles')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/newPinoysHomeRelatedArticles':
                    console.log('/web/newPinoysHomeRelatedArticles')
                    request.body.uid = null;
                    next();
                    break;
                case '/web/UserSurveyList':
                    console.log('/web/UserSurveyList')
                    request.body.uid = null;
                    next();
                    break;
                default:
                    request.body.uid = 0;
                    break;
            }
        }
        if (request.body.uid == 0) {

            var idToken = authorization
            admin
                .auth()
                .verifyIdToken(idToken)
                .then((decodedToken) => {
                    // See the UserRecord reference doc for the contents of userRecord.
                    const uid = decodedToken.uid;
                    // console.log("auth details",decodedToken)
                    // console.log(`Successfully fetched user data: ${uid}`);
                    // response.error = "false"
                    // response.status = "200"
                    // response.result = uid
                    console.log("auth success", decodedToken.uid)
                    request.body.uid = decodedToken.uid
                    next()
                })
                .catch((error) => {
                    console.log('Error fetching user data:', error);
                    response.error = "true"
                    response.status = "401"
                    response.message = "UNAUTHORIZED"
                    // console.log(error)
                    return res.status(401).send(response)
                });
        }
    } catch (err) {
        error.error = "true"
        error.status = "401"
        error.message = "UNAUTHORIZED"
        console.log("service error", err)
        return res.status(401).send(error)
    }
}



app.admin = admin
app.Verifyauth = Verifyauth



//admin routes

require('./routes/admin/ArticleRoutes')(app)
require('./routes/admin/TagRoutes')(app)
require('./routes/admin/ProudlyPinoyRoutes')(app)
require('./routes/admin/PodcastRoutes')(app)
require('./routes/admin/PodcastEpisodesRoutes')(app)
require('./routes/admin/VideosFeedsRoutes')(app)
require('./routes/admin/NewPinoysRoute')(app)
require('./routes/admin/NiknokRoutes')(app)
require('./routes/admin/ProvincesNameRoutes')(app)
require('./routes/admin/ShoutOutsRoutes')(app)
require('./routes/admin/CategoryRoutes')(app)
require('./routes/admin/AdminUserRoutes')(app)
require('./routes/admin/SurveyRoutes')(app)
require('./routes/admin/PinoyPreneursRoutes')(app)
require('./routes/admin/JobCentreRoutes')(app)
require('./routes/admin/SubscriptionRoutes')(app)
require('./routes/admin/goodVibesRoutes')(app)
require('./routes/admin/reportListRoutes')(app)
require('./routes/admin/RegisteredContact')(app)
require('./routes/admin/CouponRoutes')(app)
require('./routes/admin/FoodTripRoutes')(app)
require('./routes/admin/JobCentersRoutes')(app)
require('./routes/admin/ReferralRoutes')(app)
require('./routes/admin/AdRoutes')(app)






//web routes

require('./routes/web/WhatsUpRoutes')(app)
require('./routes/web/MyProfileRoutes')(app)
require('./routes/web/FoodTripRoutes')(app)
require('./routes/web/LikesRoutes')(app)
require('./routes/web/CommentRoutes')(app)
require('./routes/web/NiknokRoutes')(app)
require('./routes/web/HomeRoutes')(app)
require('./routes/web/NewPinoysRoutes')(app)
require('./routes/web/TambayanRoutes')(app)
require('./routes/web/DonasyanRoutes')(app)
require('./routes/web/FeaturePostRoutes')(app)
require('./routes/web/PinoyPreneursRoutes')(app)
require('./routes/web/P-NationCalendarRoutes')(app)
require('./routes/web/bazaarCityRoutes')(app)
require('./routes/web/jobCentreRoutes')(app)
require('./routes/web/notificationRoutes')(app)
require('./routes/web/RatingRoutes')(app)
require('./routes/web/reportRoutes')(app)
require('./routes/web/ConversationRoutes')(app)
require('./routes/web/MessageRoutes')(app)
require('./routes/web/postImageRoutes')(app)
require('./routes/web/ContactRoutes')(app)
require('./routes/web/CouponRoutes')(app)
require('./routes/web/ReferralRoutes')(app)
require('./routes/web/GroupChatRoutes')(app)
require('./routes/web/EventRoutes')(app)
require('./routes/web/AdRoutes')(app)



//modal for socket
const { Conversation } = require('./modal/web/conversationModel');
const { Message } = require('./modal/web/messageModal');



var connectedClients = 0;

port = process.env.PORT || 5000;
const server = app.listen(port, () => {
    console.log(`listening in port ${port}`)
})

const io = require('socket.io')(server, {
    pingTimeout: 60000,
    cors: {
        origin: '*',
    },
});

io.on('connection', (socket) => {
    global.setSocketId = socket
    // console.log("socket.id",socket.id)
    socket.on("online", roomId => {
        socket.join(roomId);
    });
    socket.on("unreadcount", () => {
        socket.emit({ "error": "false" })
    })
    console.log('socket connected');
    socket.on('setup', (userData) => {
        console.log("uidddd", userData.uid);
        socket.join(userData.uid);
        socket.emit('connected');
    });

    // socket.on('joinChat', (room) => {
    //     console.log('user joined room:', room.chatId);
    //     socket.join(room.chatId);
    //     console.log("socket.id",socket.id)

    //     socket.on('sendMessage', async (newMessageReceived) => {
    //         const MessageReceived = await JSON.parse(newMessageReceived.data)
    //         if (!MessageReceived) {
    //             return console.log('user not defined');
    //         } else {
    //             // console.log("messageSent", MessageReceived)
    //             MessageReceived.chat[0].users.forEach((user) => {
    //                 console.log("messageFor", user, MessageReceived.sender[0].uid)
    //                 if (user == MessageReceived.sender[0].uid) return;
    //                 console.log("emittedMessafe",user,MessageReceived)
    //                 socket.in(user).emit('receiveMessage', MessageReceived);
    //             });
    //         }
    //     });
    // });


    socket.on('joinChat', (room) => {
        console.log('user joined room:', room.chatId);
        socket.join(room.chatId);
        console.log("socket.id", socket.id)
        var chatIdRecieved = room.chatId
    });
    socket.on('sendMessage', async (newMessageReceived) => {
        const MessageReceived = await JSON.parse(newMessageReceived.data)
        console.log("MessageReceived",MessageReceived,MessageReceived.chatId)
        // if (!MessageReceived) {
        //     return console.log('user not defined');
        // } else {
        //     // console.log("messageSent", MessageReceived)
        //     MessageReceived.chat[0].users.forEach((user) => {
        //         console.log("messageFor", user, MessageReceived.sender[0].uid)
        //         if (user == MessageReceived.sender[0].uid) return;
        //         console.log("emittedMessafe",user,MessageReceived)
        //         socket.in(user).emit('receiveMessage', MessageReceived);
        //     });
        // }
        
        socket.in(MessageReceived.chatId).emit('receiveMessage', MessageReceived,function(err){
            console.log("errorInSocket",err)
         });
    });

    socket.on('disconnect', function (data) {
        console.log('user disconnected', data, 'socket id', socket.id)
    });

    //     // console.log('New client connected');

    //     // Handle the join event
    //     socket.on('joinGroup', async groupId => {
    //       console.log(`Client joined group ${groupId}`);

    //       // Join the group's room
    //       socket.join(groupId);

    //       // Send a welcome message to the user
    //       socket.emit('groupMessage', `Welcome to group ${groupId}`);

    //       // Send a join message to the other users
    //       socket.to(groupId).emit('groupMessage', `${socket.id} has joined the group`);
    //     });

    //     // Handle the message event
    //     socket.on('groupMessage', async ({ groupId, text }) => {
    //       console.log(`Client sent message to group ${groupId}: ${text}`);

    //       // Send the message to all users in the group
    //       io.in(groupId).emit('groupMessage', `${socket.id}: ${text}`);
    //     });



    // socket.on('joinGroupChat', (room) => {
    //     console.log('user joined room:', room.chatId);
    //     socket.join(room.chatId);
    //     const GroupChatMembersModelData= GroupChatMembersModel.find({chatId:ObjectId(room.chatId)}).then((res)=>{
    //         // console.log("res",res)
    //         console.log("GroupChatMembersModelData",res)
    //         socket.on('sendGroupMessage', async(newMessageReceived) => {
    //         //   const MessageReceived = await  JSON.parse(newMessageReceived)
    //         //   if (!MessageReceived) {
    //         //     return console.log('user not defined');
    //         //   } else {
    //           console.log("messageSent", newMessageReceived)
    //         //   res.forEach((user) => {
    //             //   console.log("messageFor", user.memberUid)
    //             //   if (user == MessageReceived.sender[0].uid) return;
    //             //   socket.in(room.chatId).emit('receiveGroupMessage', newMessageReceived);
    //             // });
    //         //   }
    //         });
    //     })

    //   });

    //chatUnread
    const messageContoller = require('./controller/web/MessageControllers');
    socket.on("messageRead", ({ chatId }) => {
        try {

            messageContoller.allMessagesRead(chatId)
            console.log('unreadMessages1')

        } catch (e) {

            console.log('unreadMessages', e)
        }
    })

    socket.off('setup', (userData) => {
        console.log('user disconnected');
        socket.leave(userData);
    });



    socket.on('joinLive', async function (username) {
        // console.log("username",username);
        var response = {}
        const profileDetails = myprofile.findOne({ uid: username.data.uid }).then((result) => {
            response.result = result
            console.log(result);
            // io.to(user.room).emit('liveComment',{response:result,message:userData.data.message});
            // console.log("response",response)
            const user = userJoin(socket.id, result.full_name, username.data.room, username.data.uid)
            socket.join(user.room)

            const likeForLive = LikesModal.find({
                $and: [{
                    post_id: username.data.room
                }, {
                    post_type: 'live'
                }]
            }).then((result) => {
                console.log("LikeCountDaoResponse", result.length)

                io.to(user.room).emit("liveCount", result.length)

            })



            //send user count info
            io.to(user.room).emit('roomUsers', {
                room: user.room,
                users: getRoomUsers(user.room)
            })

            //   socket.broadcast.emit("replyComment",`${result.full_name} joined live`)
        })





    })

    socket.on('disconnectLive', () => {
        const user = userLeave(socket.id);

        if (user) {
            io.emit('connectedClients', connectedClients--);
            io.to(user.room).emit('left');
            //send user count info
            io.to(user.room).emit('roomUsers', {
                room: user.room,
                users: getRoomUsers(user.room)
            });
        }
    })


    socket.on('liveComment', async function (userData) {
        var user = getCurrentUser(socket.id)
        console.log("user", userData);
        var response = {}
        console.log('profileDetails', userData);
        const profileDetails = myprofile.findOne({ uid: userData.data.uid }).then((result) => {
            // response.result = result
            console.log(result);
            io.to(user.room).emit('replyComment', { response: result, message: userData.data.message });
        })
    });


    //   io.emit('connectedClients',
    // //   ()=>{
    //     io.engine.clientsCount)
    // //     console.log(io.engine.clientsCount)
    // //   })
    // const userId = 'user123';
    // const message = 'You have a new message!';

    // const socketId = users.get(userId);
    // if (socketId) {
    //   io.to(socketId).emit(userId, message);
    // }


});
// var mailer=require("./Mailer")
// console.log("(mailer.sendMail()",mailer())

// io.on('connection', (socket) => {
//     console.log("userconnected")
//     socket.on('online', roomId => {
//         socket.join(roomId);
//     });
//     socket.on('unreadcount',()=>{
//         socket.emit({"error":"false"})
//     })

//     // socket.on('join chat', (room) => {
//     //     console.log('=======>', room);
//     //     // console.log('user joined room:', + room);
//     //     socket.join(room);

//     //     socket.on('new message', (newMessageReceived) => {
//     //       console.log("------>", newMessageReceived); 
//     //       socket.in(newMessageReceived._id).emit('message recieved', newMessageReceived);
//     //     });
//     //   });

//     socket.on('sendMessage', async ({conversationId, sender, text}) => {
//         console.log("========>",conversationId, sender, text);
//         const newMessage = await new Message({
//           conversationId: conversationId,
//           sender: sender,
//           text: text,
//         });
//         const check = await Conversation.findByIdAndUpdate(
//             conversationId,
//             {
//               lastMessage : text,
//               createdAt : new Date()
//             },
//             {new: true}
//           );
//         try {
//           const saveMessage = await newMessage.save();
//           socket.emit('receiveMessage',saveMessage);
//         } catch (err) {
//           socket.emit('receiveMessage', 'message not received');
//         }
//       });
// });

global.io = io;