const { request, response } = require('express')
const { ObjectId } = require('mongodb');

module.exports = function(app) {
    const {
        check,validationResult
    } =require('express-validator')
    var userPath ='/admin'
    require('dotenv').config()
    var ReportModal = require("../../modal/web/ReportModal")
    var BazaarCityModel = require('../../modal/web/BazaarCityModel')
    var DonasyanModal = require('../../modal/web/DonasyanModal')
    var FoodTripModal = require('../../modal/web/FoodTripModal')
    var tambayanModal = require('../../modal/web/TambayanModal')


    app.post(userPath + '/getonereport', app.Verifyauth, async(req,res) =>{
      const {report_id, post_type} = req.body
      if(post_type == "BazaarCity"){
        const report = await ReportModal.aggregate([
          {
            "$match": {
                _id : ObjectId(report_id)
            },      
          },
          {
            "$lookup": {
                "from": "userprofiles",
                "localField": "userId",
                "foreignField": "uid",
                "as": "reported_by"
            },      
          },
        {
          "$lookup": {
              "from": "bazaarcities",
              "localField": "post_id",
              "foreignField": "_id",
              "as": "post"
          },
      },
      {
        "$project": {
          "reported_by": {
            "uid": 1,
            "full_name": 1,
            "profile_photo":1
          },
          "post": {
            "_id":1,
            "full_name":1,
            "profile_photo":1,
            "item_name":1,
            "item_images":1,
            "post_description": 1,
            "category":1,
            "price":1,
            "province_name":1
          },
          "reason" : 1,
          "show" :1,
          "post_type":1,
        }
      }  ,
        ])
      res.send({error:false,data : report})
      } else if(post_type == "FoodTrip"){
        const report = await ReportModal.aggregate([
          {
            "$match": {
                _id : ObjectId(report_id)
            },      
          },
          {
            "$lookup": {
                "from": "userprofiles",
                "localField": "userId",
                "foreignField": "uid",
                "as": "reported_by"
            },      
          },
        {
          "$lookup": {
              "from": "foodtripposts",
              "localField": "post_id",
              "foreignField": "_id",
              "as": "post"
          },
      },
      {
        "$project": {
          "reported_by": {
            "uid": 1,
            "full_name": 1,
            "profile_photo":1
          },
          "post": {
            "_id":1,
            "full_name":1,
            "profile_photo":1,
            "post_type":1,
            "post_images":1,
            "post_description": 1,
            "location":1,
            "youtube_link":1
          },
          "reason" : 1,
          "show" :1,
          "post_type":1,
        }
      }  ,
        ])
      res.send({error:false,data : report})
      }else if(post_type == "Donasyan"){
        const report = await ReportModal.aggregate([
          {
            "$match": {
                _id : ObjectId(report_id)
            },      
          },
          {
            "$lookup": {
                "from": "userprofiles",
                "localField": "userId",
                "foreignField": "uid",
                "as": "reported_by"
            },      
          },
        {
          "$lookup": {
              "from": "donasyanposts",
              "localField": "post_id",
              "foreignField": "_id",
              "as": "post"
          },
      },
      {
        "$project": {
          "reported_by": {
            "uid": 1,
            "full_name": 1,
            "profile_photo":1
          },
          "post": {
            "_id":1,
            "full_name":1,
            "profile_photo":1,
            "item_name":1,
            "post_images":1,
            "post_description": 1,
            "category":1,
           "location":1
          },
          "reason" : 1,
          "show" :1,
          "post_type":1,
        }
      }  ,
        ])
      res.send({error:false,data : report})
      }
      
      else if(post_type == "tambayan"){
        const report = await ReportModal.aggregate([
          {
            "$match": {
                _id : ObjectId(report_id)
            },      
          },
          {
            "$lookup": {
                "from": "userprofiles",
                "localField": "userId",
                "foreignField": "uid",
                "as": "reported_by"
            },      
          },
        {
          "$lookup": {
              "from": "tambayanposts",
              "localField": "post_id",
              "foreignField": "_id",
              "as": "post"
          },
      },
      {
        "$project": {
          "reported_by": {
            "uid": 1,
            "full_name": 1,
            "profile_photo":1
          },
          "post": 1,
   
          "reason" : 1,
          "show" :1,
          "post_type":1,
          "file_url":1,
          "file_type":1,
          
        }
      }  ,
        ])
      res.send({error:false,data : report})
      }
      
      else{
        res.send({error:true,message:"something went wrong"})
      }

     
    })


    app.post(userPath + '/reportlist', app.Verifyauth , async(req,res)=>{
      const {post_type, page_number, row_per_page} = req.body
      const all_page = row_per_page / 3 
      const obj = []
      if(post_type == "All"){
        const BazaarCityList = await ReportModal.aggregate([
          {
            "$match": {
                post_type : "BazaarCity"
            },      
          },
          {
            $sort: {
                createdAt: -1
            }
        },
          {
            "$lookup": {
                "from": "userprofiles",
                "localField": "userId",
                "foreignField": "uid",
                "as": "user_name"
            },      
          },
        {
          "$lookup": {
              "from": "bazaarcities",
              "localField": "post_id",
              "foreignField": "_id",
              "as": "post"
          },
      },
         {
              "$project": {
                "user_name": {
                  "uid": 1,
                  "full_name": 1,
                },
                "post": {
                  "_id":1,
                  "post_description": 1,
                  "item_images":1
                },
                "reason" : 1,
                "show" :1,
                "post_type":1,
                "createdAt" : 1
              }
            }  ,
            {
              $set: {
                user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
              },
            },
          
          ])

          //tambayan
          const tambayan = await ReportModal.aggregate([
            {
              "$match": {
                  post_type : "tambayan"
              },      
            },
            {
              $sort: {
                  createdAt: -1
              }
          },
            {
              "$lookup": {
                  "from": "userprofiles",
                  "localField": "userId",
                  "foreignField": "uid",
                  "as": "user_name"
              },      
            },
          {
            "$lookup": {
                "from": "tambayanposts",
                "localField": "post_id",
                "foreignField": "_id",
                "as": "post"
            },
        },
           {
                "$project": {
                  "user_name": {
                    "uid": 1,
                    "full_name": 1,
                  },
                  "post": {
                    "_id":1,
                    "post_description": 1,
                    "file_type":1,
                    "file_url":1
                  },
                  "reason" : 1,
                  "show" :1,
                  "post_type":1,
                  "createdAt" : 1
                }
              }  ,
              {
                $set: {
                  user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
                },
              },
            
            ])

          const DonasyanList = await ReportModal.aggregate([
            {
              "$match": {
                  post_type : "Donasyan"
              },      
            },
            {
              $sort: {
                  createdAt: -1
              }
          },
        
            {
              "$lookup": {
                  "from": "userprofiles",
                  "localField": "userId",
                  "foreignField": "uid",
                  "as": "user_name"
              },      
            },
          {
            "$lookup": {
                "from": "donasyanposts",
                "localField": "post_id",
                "foreignField": "_id",
                "as": "post"
            },
        },
           {
                "$project": {
                  "user_name": {
                    "uid": 1,
                    "full_name": 1,
                  },
                  "post": {
                    "_id":1,
                    "post_description":1,
                    "post_images":1
                  },
                  "reason" : 1,
                  "show" :1,
                  "post_type" : 1,
                  "createdAt" : 1
                }
              },
              {
                $set: {
                  user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
                },
              },
            ])

            const FoodTripList = await ReportModal.aggregate([
              {
                "$match": {
                    post_type : "FoodTrip"
                },      
              },
              {
                $sort: {
                    createdAt: -1
                }
            },
              {
                "$lookup": {
                    "from": "userprofiles",
                    "localField": "userId",
                    "foreignField": "uid",
                    "as": "user_name"
                },      
              },
            {
              "$lookup": {
                  "from": "foodtripposts",
                  "localField": "post_id",
                  "foreignField": "_id",
                  "as": "post"
              },
          },
             {
                  "$project": {
                    "user_name": {
                      "uid": 1,
                      "full_name": 1,
                    },
                    "post": {
                      "_id":1,
                      "post_description": 1,
                      "post_images":1
                    },
                    "reason" : 1,
                   "show" :1,
                   "post_type" : 1,
                   "createdAt" : 1
                  }
                },
                {
                  $set: {
                    user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
                  },
                },
              ])


              const whatsUpCanadaList = await ReportModal.aggregate([
                {
                  "$match": {
                      post_type : "whatsUpCanada"
                  },      
                },
                {
                  $sort: {
                      createdAt: -1
                  }
              },
                {
                  "$lookup": {
                      "from": "userprofiles",
                      "localField": "userId",
                      "foreignField": "uid",
                      "as": "user_name"
                  },      
                },
              {
                "$lookup": {
                    "from": "articles",
                    "localField": "post_id",
                    "foreignField": "_id",
                    "as": "post"
                },
            },
               {
                    "$project": {
                      "user_name": {
                        "uid": 1,
                        "full_name": 1,
                      },
                      "post": {
                        "_id":1,
                        "post_description": 1,
                        "item_images":1
                      },
                      "reason" : 1,
                      "show" :1,
                      "post_type":1,
                      "createdAt" : 1
                    }
                  }  ,
                  {
                    $set: {
                      user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
                    },
                  },
                
                ])

                const newToCanadaList = await ReportModal.aggregate([
                  {
                    "$match": {
                        post_type : "newToCanada"
                    },      
                  },
                  {
                    $sort: {
                        createdAt: -1
                    }
                },
                  {
                    "$lookup": {
                        "from": "userprofiles",
                        "localField": "userId",
                        "foreignField": "uid",
                        "as": "user_name"
                    },      
                  },
                {
                  "$lookup": {
                      "from": "newPinoys",
                      "localField": "post_id",
                      "foreignField": "_id",
                      "as": "post"
                  },
              },
                 {
                      "$project": {
                        "user_name": {
                          "uid": 1,
                          "full_name": 1,
                        },
                        "post": {
                          "_id":1,
                          "post_description": 1,
                          "item_images":1
                        },
                        "reason" : 1,
                        "show" :1,
                        "post_type":1,
                        "createdAt" : 1
                      }
                    }  ,
                    {
                      $set: {
                        user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
                      },
                    },
                  
                  ])
  
          if(!obj){
            res.send({error:true,message : "no data found"})
          }
          obj.push(...BazaarCityList,...DonasyanList,...FoodTripList,...tambayan)
          
          const total_pages = await  ReportModal.find({}).countDocuments() / row_per_page
         
          let paginationArray = obj.slice((page_number-1)*row_per_page,page_number * row_per_page)

          const final_data = paginationArray.sort((a,b) => {
            return a.createdAt + b.createdAt
          })
          res.send({total_pages: Math.ceil(total_pages),data : final_data})
      }else if(post_type == "BazaarCity"){
        const BazaarCityList = await ReportModal.aggregate([
          {
            "$match": {
                post_type : post_type
            },      
          },
          {
            $sort: {
                createdAt: -1
            }
        },
        {
            $skip: page_number > 0 ? ((page_number - 1) * row_per_page) : 0
        },
        {
            $limit: row_per_page
        },
          {
            "$lookup": {
                "from": "userprofiles",
                "localField": "userId",
                "foreignField": "uid",
                "as": "user_name"
            },      
          },
        {
          "$lookup": {
              "from": "bazaarcities",
              "localField": "post_id",
              "foreignField": "_id",
              "as": "post"
          },
      },
         {
              "$project": {
                "user_name": {
                  "uid": 1,
                  "full_name": 1,
                },
                "post": {
                  "_id":1,
                  "post_description": 1,
                  "item_images":1

                },
                "reason" : 1,
                "show" :1,
                "post_type":1
              }
            }  ,
            {
              $set: {
                user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
              },
            },
          ])
          const total_pages = await  ReportModal.find({post_type:post_type}).countDocuments() / row_per_page
        if (!BazaarCityList) {
            res.status(400).json({success: false});
          }
          res.send({total_pages : Math.ceil(total_pages) ,data: BazaarCityList})
      }else if(post_type == "Donasyan"){
        const DonasyanList = await ReportModal.aggregate([
          {
            "$match": {
                post_type : post_type
            },      
          },
          {
            $sort: {
                createdAt: -1
            }
        },
        {
            $skip: page_number > 0 ? ((page_number - 1) * row_per_page) : 0
        },
        {
            $limit: row_per_page
        },
          {
            "$lookup": {
                "from": "userprofiles",
                "localField": "userId",
                "foreignField": "uid",
                "as": "user_name"
            },      
          },
        {
          "$lookup": {
              "from": "donasyanposts",
              "localField": "post_id",
              "foreignField": "_id",
              "as": "post"
          },
      },
         {
              "$project": {
                "user_name": {
                  "uid": 1,
                  "full_name": 1,
                },
                "post": {
                  "_id":1,
                  "post_description":1,
                  "post_images":1
                },
                "reason" : 1,
                "show" :1,
                "post_type" : 1
              }
            },
            {
              $set: {
                user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
              },
            },
          ])
          const total_pages = await  ReportModal.find({post_type:post_type}).countDocuments() / row_per_page
        if (!DonasyanList) {
            res.status(400).json({success: false});
          }
          res.send({total_pages : Math.ceil(total_pages),data: DonasyanList})
      }
      
    else if(post_type == "tambayan"){
      const DonasyanList = await ReportModal.aggregate([
        {
          "$match": {
              post_type : "tambayan"
          },      
        },
        {
          $sort: {
              createdAt: -1
          }
      },
        {
          "$lookup": {
              "from": "userprofiles",
              "localField": "userId",
              "foreignField": "uid",
              "as": "user_name"
          },      
        },
      {
        "$lookup": {
            "from": "tambayanposts",
            "localField": "post_id",
            "foreignField": "_id",
            "as": "post"
        },
    },
       {
            "$project": {
              "user_name": {
                "uid": 1,
                "full_name": 1,
              },
              "post": {
                "_id":1,
                "post_description": 1,
                "file_type":1,
                "file_url":1
              },
              "reason" : 1,
              "show" :1,
              "post_type":1,
              "createdAt" : 1
            }
          }  ,
          {
            $set: {
              user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
            },
          },
        
        ])
        const total_pages = await  ReportModal.find({post_type:post_type}).countDocuments() / row_per_page
      if (!DonasyanList) {
          res.status(400).json({success: false});
        }
        res.send({total_pages : Math.ceil(total_pages),data: DonasyanList})
    }else if(post_type == "FoodTrip") {
        const FoodTripPost = await ReportModal.aggregate([
          {
            "$match": {
                post_type : post_type
            },      
          },
          {
            $sort: {
                createdAt: -1
            }
        },
        {
            $skip: page_number > 0 ? ((page_number - 1) * row_per_page) : 0
        },
        {
            $limit: row_per_page,
        },
   
          {
            "$lookup": {
                "from": "userprofiles",
                "localField": "userId",
                "foreignField": "uid",
                "as": "user_name"
            },      
          },
        {
          "$lookup": {
              "from": "foodtripposts",
              "localField": "post_id",
              "foreignField": "_id",
              "as": "post"
          },
      },
         {
              "$project": {
                "user_name": {
                  "uid": 1,
                  "full_name": 1,
                },
                "post": {
                  "_id":1,
                  "post_description": 1,
                  "post_images":1
                },
                "reason" : 1,
               "show" :1,
               "post_type" : 1
              }
            },
            {
              $set: {
                user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
              },
            },
          ])
          const total_pages = await  ReportModal.find({post_type : post_type}).countDocuments() / row_per_page
          // console.log("=====>",total_pages)
        if (!FoodTripPost) {
            res.status(400).json({success: false});
          }
          res.send({total_pages : Math.ceil(total_pages),data: FoodTripPost})
        }else if(post_type == "whatsUpCanada") {
          const FoodTripPost = await ReportModal.aggregate([
            {
              "$match": {
                  post_type : post_type
              },      
            },
            {
              $sort: {
                  createdAt: -1
              }
          },
          {
              $skip: page_number > 0 ? ((page_number - 1) * row_per_page) : 0
          },
          {
              $limit: row_per_page,
          },
     
            {
              "$lookup": {
                  "from": "userprofiles",
                  "localField": "userId",
                  "foreignField": "uid",
                  "as": "user_name"
              },      
            },
          {
            "$lookup": {
                "from": "articles",
                "localField": "post_id",
                "foreignField": "_id",
                "as": "post"
            },
        },
           {
                "$project": {
                  "user_name": {
                    "uid": 1,
                    "full_name": 1,
                  },
                  "post": {
                    "_id":1,
                    "post_description": 1,
                    "post_images":1
                  },
                  "reason" : 1,
                 "show" :1,
                 "post_type" : 1
                }
              },
              {
                $set: {
                  user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
                },
              },
            ])
            const total_pages = await  ReportModal.find({post_type : post_type}).countDocuments() / row_per_page
            // console.log("=====>",total_pages)
          if (!FoodTripPost) {
              res.status(400).json({success: false});
            }
            res.send({total_pages : Math.ceil(total_pages),data: FoodTripPost})
        }else if(post_type == "newToCanada") {
          const FoodTripPost = await ReportModal.aggregate([
            {
              "$match": {
                  post_type : post_type
              },      
            },
            {
              $sort: {
                  createdAt: -1
              }
          },
          {
              $skip: page_number > 0 ? ((page_number - 1) * row_per_page) : 0
          },
          {
              $limit: row_per_page,
          },
     
            {
              "$lookup": {
                  "from": "userprofiles",
                  "localField": "userId",
                  "foreignField": "uid",
                  "as": "user_name"
              },      
            },
          {
            "$lookup": {
                "from": "newPinoys",
                "localField": "post_id",
                "foreignField": "_id",
                "as": "post"
            },
        },
           {
                "$project": {
                  "user_name": {
                    "uid": 1,
                    "full_name": 1,
                  },
                  "post": {
                    "_id":1,
                    "post_description": 1,
                    "post_images":1
                  },
                  "reason" : 1,
                 "show" :1,
                 "post_type" : 1
                }
              },
              {
                $set: {
                  user_name: { $arrayElemAt: ['$user_name.full_name', 0] },
                },
              },
            ])
            const total_pages = await  ReportModal.find({post_type : post_type}).countDocuments() / row_per_page
            // console.log("=====>",total_pages)
          if (!FoodTripPost) {
              res.status(400).json({success: false});
            }
            res.send({total_pages : Math.ceil(total_pages),data: FoodTripPost})
        }
      
      else{
        res.status(400).json({success: false,message : "invalid post type"});
      }
       
    })

    app.post(userPath + '/deletereportedpost', app.Verifyauth , async(req,res)=>{
        try {
        const report = await ReportModal.deleteMany({post_id : req.body.post_id})
            if(req.body.post_type == "BazaarCity"){
                const bazaarCity = await BazaarCityModel.findByIdAndDelete({_id : req.body.post_id})
                res.status(200).send({"error":false, message : "post deleted sucessfully"})
            }else if(req.body.post_type == "Donasyan"){
                const Donasyan = await DonasyanModal.findByIdAndDelete({_id : req.body.post_id})
                res.status(200).send({"error":false,message : "post deleted sucessfully"})
            }else if(req.body.post_type == "FoodTrip"){
                const FoodTrip = await FoodTripModal.findByIdAndDelete({_id : req.body.post_id})
                res.status(200).send({"error":false,Foodmessage : "post deleted sucessfully"})
            }
            else if(req.body.post_type == "tambayan"){
              const FoodTrip = await tambayanModal.findByIdAndDelete({_id : req.body.post_id})
              res.status(200).send({"error":false,Foodmessage : "post deleted sucessfully"})
          }else{
                res.status(200).send({"error":true,message: 'invalid type or post_id or report_id'})
            }
          } catch (err) {
            res.status(200).json({"error":true,message :"invalid  id"});
          }
    
        // const post = await ReportModal.findByIdAndDelete(req.body.post_id)
          res.send({error:false,message : "sucessfully deleted"})
    })

    app.post(userPath + '/hide', app.Verifyauth , async(req,res)=>{
        console.log("in")
        try {
            if(req.body.post_type == "BazaarCity"){
                if(req.body.show == 0){
                  const report = await ReportModal.updateMany({post_id : req.body.post_id},{
                    show : 0,
                  },
                  {new: true})
                  const bazaarCity = await BazaarCityModel.findByIdAndUpdate({_id : req.body.post_id},{
                        is_active: 0,
                      },
                      {new: true})
                    res.status(200).send({"error":false, message : "post hidden sucessfully"})
                }
                if(req.body.show == 1){
                  const report = await ReportModal.updateMany({post_id : req.body.post_id},{
                    show : 1,
                  },
                  {new: true})
                    const bazaarCity = await BazaarCityModel.findByIdAndUpdate({_id : req.body.post_id},{
                        is_active: 1,
                      },
                      {new: true})
                    res.status(200).send({"error":false, message : "post unhidden sucessfully"})
                }
            }else if(req.body.post_type == "Donasyan"){
                if(req.body.show == 0){
                  const report = await ReportModal.updateMany({post_id : req.body.post_id},{
                    show : 0,
                  },
                  {new: true})
                    const Donasyan = await DonasyanModal.findByIdAndUpdate({_id : req.body.post_id},{
                        is_active: 0,
                      },
                      {new: true})
                    res.status(200).send({"error":false, message : "post hidden sucessfully"})
                }
                if(req.body.show == 1){
                  const report = await ReportModal.updateMany({post_id : req.body.post_id},{
                    show : 1,
                  },
                  {new: true})
                    const Donasyan = await DonasyanModal.findByIdAndUpdate({_id : req.body.post_id},{
                        is_active: 1,
                      },
                      {new: true})
                    res.status(200).send({"error":false, message : "post unhidden sucessfully"})
                }
            }else if(req.body.post_type == "FoodTrip"){
                if(req.body.show == 0){
                  const report = await ReportModal.updateMany({post_id : req.body.post_id},{
                    show : 0,
                  },
                  {new: true})
                    const FoodTrip = await FoodTripModal.findByIdAndUpdate({_id : req.body.post_id},{
                        is_active: 0,
                      },
                      {new: true})
                    res.status(200).send({"error":false, message : "post hidden sucessfully"})
                }
                if(req.body.show == 1){
                  const report = await ReportModal.updateMany({post_id : req.body.post_id},{
                    show : 1,
                  },
                  {new: true})
                    const FoodTrip = await FoodTripModal.findByIdAndUpdate({_id : req.body.post_id},{
                        is_active: 1,
                      },
                      {new: true})
                    res.status(200).send({"error":false, message : "post unhidden sucessfully"})
                }
            }
            // tambayan
            else if(req.body.post_type == "tambayan"){
              if(req.body.show == 0){
                const report = await ReportModal.updateMany({post_id : req.body.post_id},{
                  show : 0,
                },
                {new: true})
                  const FoodTrip = await tambayanModal.findByIdAndUpdate({_id : req.body.post_id},{
                      is_active: 0,
                    },
                    {new: true})
                  res.status(200).send({"error":false, message : "post hidden sucessfully"})
              }
              if(req.body.show == 1){
                const report = await ReportModal.updateMany({post_id : req.body.post_id},{
                  show : 1,
                },
                {new: true})
                  const FoodTrip = await tambayanModal.findByIdAndUpdate({_id : req.body.post_id},{
                      is_active: 1,
                    },
                    {new: true})
                  res.status(200).send({"error":false, message : "post unhidden sucessfully"})
              }
            }
            else{
                res.status(200).send({"error":true,message: 'invalid type or post_id'})
            }
          } catch (err) {
            res.status(200).json({"error":true,message :"invalid  id"});
          }
        // const post = await ReportModal.findByIdAndDelete(req.body.post_id)
          res.send({error:false,message : "sucessfully deleted"})
    })


   
}