const { request } = require('express')

module.exports= function(app){
    const{check,validationResult}=require('express-validator')
    const userPath='/web'
    require('dotenv').config()
    const groupchatController=require('../../controller/web/GroupChatController')
    const groupchatControllerObject=new groupchatController()

    app.post(userPath+'/CreateGroup',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.creategroupChatController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath + '/deleteGroup',app.Verifyauth,(request,response)=>{
        const errors=validationResult(request)
        if(!errors.isEmpty()){
            var errorArray =errors.array()
            var errorResponse = {}
            errorResponse.error = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.deleteGroupController(request, function (results) {
            if(results.error){
                response.status(results.statusCode);
                return response.send(results)
            }else{
                return response.send(results)
            }
          })
    })


    app.post(userPath+'/listGroups',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.listGroupChatsController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    app.post(userPath+'/editGroups',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.editGroupsController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    app.post(userPath+'/listGroupMembers',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.listGroupMembersController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    
    app.post(userPath+'/groupMemberRole',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.groupMemberRoleController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })


    app.post(userPath+'/addGroupMembers',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.addGroupMembersController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })


    app.post(userPath+'/sendGroupMessage',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.sendGroupMessageController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })


    app.post(userPath+'/listGroupMessage',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.listGroupMessageController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    
    app.post(userPath+'/permissionGroup',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.permissionGroupController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    
    
    app.post(userPath+'/deviceTokenUpdate',app.Verifyauth, (request,response)=>{
        console.log('deviceTokenUpdate',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.deviceTokenUpdateController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    app.post(userPath+'/reactMessage',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.reactMessageController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    

    app.post(userPath+'/hideUnhide',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.hideUnhideController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    
    app.post(userPath+'/removeGroupUser',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.removeGroupUserController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })

    
    app.post(userPath+'/listUsers',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.listUsersController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    
     app.post(userPath+'/userGroupSearch',app.Verifyauth, (request,response)=>{
        // console.log('requestaddCoupon',request.body);
        const errors = validationResult(request)
        if (!errors.isEmpty()) {
            const errorArray = errors.array()
            const errorResponse = {}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response.send(errorResponse)
        }
        groupchatControllerObject.userGroupSearchController(request, function (results) {
            if (results.error) {
                response.status(results.statusCode);
                return response.send(results)
            } else {
                return response.send(results)
            }
        })
    })
    
}