module.exports = function(app){
    const { check, validationResult} =require('express-validator')
    const userPath = '/web'
    const niknokController = require('../../controller/web/NiknokController')
    const niknokRoutesObject = new niknokController()

    require('dotenv').config()

    app.post(userPath + "/niknokList" , (request,response)=>{
        const errors =validationResult(request)
        if(!errors.isEmpty()){
            const errorArray =errors.array()
            const errorResponse ={}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response .send(errorResponse)
        }
        niknokRoutesObject.niknokListController(request, function(results){
            if(results.error){
                response.status(results.statusCode);
                return response.send(results)
            }else{
                return response.send(results)
            }
        })
    })

    app.post(userPath + "/getNiknokDetail" , (request,response)=>{
        const errors =validationResult(request)
        if(!errors.isEmpty()){
            const errorArray =errors.array()
            const errorResponse ={}
            errorResponse = true
            errorResponse.message = errorArray[0].msg
            response.status(404);
            return response .send(errorResponse)
        }
        niknokRoutesObject.getNiknokDetailController(request, function(results){
            if(results.error){
                response.status(results.statusCode);
                return response.send(results)
            }else{
                return response.send(results)
            }    })
    })

}