module.exports = function () {
    const STRINGS = require('../../strings.json')
    require('dotenv').config()
    const AdDao = require('../../dao/admin/AdDao')
    const AdDaoObject = new AdDao()




    this.listAdsService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                // console.log("request.body", request.body)
                var listAdDaoCount = await AdDaoObject.listAdDaoCount(request.body)
                // console.log('listAdDaoConc', listAdDaoCount);

                if (listAdDaoCount.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {

                    const totalDatas = listAdDaoCount.data;
                    const page_number = request.body.page_number - 1 || 0
                    const limit = request.body.row_per_page
                    const totalPages = Math.ceil(totalDatas / limit)

                    object.page_number = page_number
                    object.totalPages = totalPages
                    object.limit = limit

                    const assignInput = { ...request.body, ...object }
                    // console.log('listAdDaoConc', assignInput);
                    var listAdDao = await AdDaoObject.listAdDao(assignInput)
                    // console.log('var listAdDao = await', listAdDao);

                    if (listAdDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {

                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = totalPages
                        response.data = listAdDao.data
                        resolve(response)
                    }
                }

            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.listAllUsersService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                // console.log("request.body", request.body)
                var listAllUsersDaoCount = await AdDaoObject.listAllUsersDaoCount(request.body)
                // console.log('listAllUsersDaoConc', listAllUsersDaoCount);

                if (listAllUsersDaoCount.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {

                    const totalDatas = listAllUsersDaoCount.data;
                    const page_number = request.body.page_number - 1 || 0
                    const limit = request.body.row_per_page
                    const totalPages = Math.ceil(totalDatas / limit)

                    object.page_number = page_number
                    object.totalPages = totalPages
                    object.limit = limit

                    const assignInput = { ...request.body, ...object }
                    // console.log('listAllUsersDaoConc', assignInput);
                    var listAllUsersDao = await AdDaoObject.listAllUsersDao(assignInput)
                    // console.log('var listAdDao = await', listAllUsersDao);

                    if (listAllUsersDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {

                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = totalPages
                        response.data = listAllUsersDao.data
                        resolve(response)
                    }
                }

            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.viewAdService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                // console.log("request.body", request.body)
                var viewAdDaoCount = await AdDaoObject.viewAdDaoCount(request.body)
                // console.log('viewAdDaoConc', viewAdDaoCount);

                if (viewAdDaoCount.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {

                    const totalDatas = viewAdDaoCount.data;
                    const page_number = request.body.page_number - 1 || 0
                    const limit = request.body.row_per_page
                    const totalPages = Math.ceil(totalDatas / limit)

                    object.page_number = page_number
                    object.totalPages = totalPages
                    object.limit = limit

                    const assignInput = { ...request.body, ...object }
                    // console.log('viewAdServiceDaoConc', assignInput);
                    var viewAdDao = await AdDaoObject.viewAdDao(assignInput)
                    // console.log('var viewAdDao = await', viewAdDao);

                    if (viewAdDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {

                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = totalPages
                        response.data = viewAdDao.data
                        resolve(response)
                    }
                }

            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.postAddService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var postAddDao = await AdDaoObject.postAddDao(request.body)
                if (postAddDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = postAddDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.editAdService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var editAdDao = await AdDaoObject.editAdDao(request.body)
                if (editAdDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = editAdDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.deleteAdService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var deleteAdDao = await AdDaoObject.deleteAdDao(request.body)
                // console.log("deleteAdDao",deleteAdDao)
                if (deleteAdDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = deleteAdDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.assignAdService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var assignAdDao = await AdDaoObject.assignAdDao(request.body)
                if (assignAdDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = assignAdDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }
    // adAnalytics

    this.adAnalyticsService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                request.body.viewdedBy = request.body.uid

                var adAnalyticsViewDao = await AdDaoObject.adAnalyticsViewDao(request.body)
                var adAnalyticsClickDao = await AdDaoObject.adAnalyticsClickDao(request.body)


                if (adAnalyticsViewDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    const month = [
                        "January",
                        "February",
                        "March",
                        "April",
                        "May",
                        "June",
                        "July",
                        "August",
                        "September",
                        "October",
                        "November",
                        "December"
                    ]
                    var viewedCount = []
                    var clickedCount = []
                    var totalViewCount = 0
                    var totalClickCount = 0



                    if (adAnalyticsViewDao.result.length) {

                        await Promise.all(adAnalyticsViewDao.result[0].counts.map(async (e, i) => {
                            viewedCount.push(e.count)

                        }))

                        totalViewCount = adAnalyticsViewDao.result[0].totalViewCount;
                    
                    }
                    if (adAnalyticsClickDao.result.length) {

                        await Promise.all(adAnalyticsClickDao.result[0].counts.map(async (e, i) => {
                            clickedCount.push(e.count,)

                        }))

                        totalClickCount = adAnalyticsClickDao.result[0].totalClickCount;

                    }
                


                    var output = {
                        viewedCount: viewedCount,
                        clickedCount: clickedCount,
                        totalViewCount: totalViewCount,
                        totalClickCount: totalClickCount,
                        month: month,
                    }


                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    // response.totalPages = totalPages
                    response.data = output
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

}