module.exports = function () {
    var adminUserDao = require('../../dao/admin/AdminUserDao')

    const STRINGS = require('../../strings.json')
    // require('../utils/common.js')()
    require('dotenv').config()
    var adminUserDaoObject = new adminUserDao()
    const auth = require('./..//../Auth/auth')

    var authObject = new auth()

    this.addAdminUserService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                    var adminUserDaoRespone = await adminUserDaoObject.addAdminUserDao(request.body)
                    if (adminUserDaoRespone.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = adminUserDaoRespone.data
                        resolve(response)
                    }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }

    this.CheckadminUserService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                    var adminUserDaoRespone = await adminUserDaoObject.CheckadminUserDao(request.body)
                    if (adminUserDaoRespone.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else  if(adminUserDaoRespone.data.length > 0){
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = adminUserDaoRespone.data
                        resolve(response)
                    }
                     else {
                        response.error = true
                        response.statusCode = STRINGS.successStatusCode
                        response.message = "Admin Not exists"
                        // response.data = adminUserDaoRespone.data
                        resolve(response)
                    }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }





    this.GetAdminUserService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                pageNumber = request.body.pageNumber
                request.body.RowsPerpage = request.body.RowsPerpage.length == 0 ? 0 : request.body.RowsPerpage
                RowsPerpage = request.body.RowsPerpage
                var getTotalAdminUserListCountDao = await adminUserDaoObject.getTotalAdminUserListCountDao(request.body)
                if (getTotalAdminUserListCountDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {

                    var lenght = getTotalAdminUserListCountDao.result
                    var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, RowsPerpage)
                    var adminUserDaoRespone = await adminUserDaoObject.getAdminUserDao(request.body)
                    if (adminUserDaoRespone.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = paginationDetails.totalPages
                        response.data = adminUserDaoRespone.result
                        resolve(response)
                    }
                }
                // console.log("getdata",signupDaoRespone)

            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }


    this.GetOneAdminUserService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var adminUserDaoRespone = await adminUserDaoObject.getOneAdminUserDao(request.body)
                if (adminUserDaoRespone.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = adminUserDaoRespone.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }



    this.deleteAdminUserService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var adminUserDaoRespone = await adminUserDaoObject.deleteAdminUserDao(request.body)

                if (adminUserDaoRespone.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = adminUserDaoRespone.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }

    this.editAdminUserService = async (request) => {

        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var adminUserDaoRespone = await adminUserDaoObject.editAdminUserDao(request.body)

                if (adminUserDaoRespone.error) {
                    response.error = true

                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = adminUserDaoRespone.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }


}