module.exports = function () {
    const STRINGS = require('../../strings.json')
    require('dotenv').config()
    const couponDao = require('../../dao/admin/CouponDao')
    const couponDaoObject = new couponDao()




    this.listCouponsService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                // console.log("request.body", request.body)
                var listCouponDaoCount = await couponDaoObject.listCouponDaoCount(request.body)
                // console.log('listCouponDaoConc', listCouponDaoCount);

                if (listCouponDaoCount.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {

                    const totalDatas = listCouponDaoCount.data.length;
                    const page_number = request.body.page_number - 1 || 0
                    const limit = request.body.row_per_page
                    const totalPages = Math.ceil(totalDatas / limit)

                    object.page_number = page_number
                    object.totalPages = totalPages
                    object.limit = limit

                    const assignInput = { ...request.body, ...object }
                    // console.log('listCouponDaoConc', assignInput);
                    var listCouponDao = await couponDaoObject.listCouponDao(assignInput)
                    // console.log('var listCouponDao = await', listCouponDao);

                    if (listCouponDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        var finalDataArray = [];
                        if (listCouponDao.data.length > 0) {
                            //    userListCouponDao.data.forEach(element => {
                            for (var i = 0; i < listCouponDao.data.length; i++) {
                                var dateValidations = await couponDaoObject.dateValidations(listCouponDao.data[i])
                                // var downloadCount = await couponDaoObject.downloadCount(listCouponDao.data[i])

                                // console.log(dateValidations.data,"dataValidation")
                                var stutusDownloadCount = {
                                    // downloadCount:downloadCount.data.length,
                                    couponStatus: dateValidations.data.length > 0 ? 'Active' : 'Expired'
                                }

                                const addKey = { ...listCouponDao.data[i], ...stutusDownloadCount }
                                finalDataArray.push(addKey)

                                // });
                            }
                        }
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = totalPages
                        response.data = finalDataArray
                        resolve(response)
                    }
                }

            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.viewCouponService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var viewCouponDao = await couponDaoObject.viewCouponDao(request.body)
                if (viewCouponDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = viewCouponDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.userLogsAdminCouponServices = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var viewCouponDao = await couponDaoObject.viewCouponDao(request.body)
                // console.log("pinoyPreneurCouponListDao",viewCouponDao)
                if (viewCouponDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {

                    if (request.body.userLog == 'claim') {
                        object.coupon_id = request.body.coupon_id
                        object.total_count = viewCouponDao.data[0].usage_limit_per_user



                        var countUserLogsAdminCouponDao = await couponDaoObject.countUserLogsAdminCouponDao(object)
                        console.log("countUserLogsAdminCouponDao", countUserLogsAdminCouponDao);

                        if (countUserLogsAdminCouponDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {

                            const totalDatas = countUserLogsAdminCouponDao.data.length;
                            const page_number = request.body.page_number - 1 || 0
                            const limit = request.body.row_per_page
                            const totalPages = Math.ceil(totalDatas / limit)

                            object.page_number = page_number
                            object.totalPages = totalPages
                            object.limit = limit

                            const assignInput = { ...request.body, ...object }


                            var userLogsAdminCouponDao = await couponDaoObject.userLogsAdminCouponDao(assignInput)


                            if (userLogsAdminCouponDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.commanErrorString
                                resolve(response)
                            } else {
                                var finalDataArray = [];
                                //    userListCouponDao.data.forEach(element => {
                                for (var i = 0; i < userLogsAdminCouponDao.data.length; i++) {

                                    const addKey = { ...userLogsAdminCouponDao.data[i], no_of_times_claimed: (viewCouponDao.data[0].usage_limit_per_user) - (userLogsAdminCouponDao.data[i].claim_count) }
                                    finalDataArray.push(addKey)
                                }
                                // });

                                response.error = false
                                response.statusCode = STRINGS.successStatusCode
                                response.message = STRINGS.SuccessString
                                response.totalPages = totalPages
                                response.data = finalDataArray ? finalDataArray : []
                                resolve(response)
                            }
                        }
                    }
                    else if (request.body.userLog == 'downloads') {

                        const Count = {}
                        var CountdownloadUserLogsAdminCouponDao = await couponDaoObject.CountdownloadUserLogsAdminCouponDao(request.body)
                        if (CountdownloadUserLogsAdminCouponDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {

                            const totalDatas = CountdownloadUserLogsAdminCouponDao.data.length;
                            const page_number = request.body.page_number - 1 || 0
                            const limit = request.body.row_per_page
                            const totalPages = Math.ceil(totalDatas / limit)

                            Count.page_number = page_number
                            Count.totalPages = totalPages
                            Count.limit = limit

                            const assignInput = { ...request.body, ...Count }


                            var downloadUserLogsAdminCouponDao = await couponDaoObject.downloadUserLogsAdminCouponDao(assignInput)
                            if (downloadUserLogsAdminCouponDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.commanErrorString
                                resolve(response)
                            } else {

                                var finalDataArray = [];
                                // console.log('downloadUserLogsAdminCouponDao',downloadUserLogsAdminCouponDao)
                                //    userListCouponDao.data.forEach(element => {
                                for (var i = 0; i < downloadUserLogsAdminCouponDao.data.length; i++) {
                                    var obj = {}
                                    obj._id = downloadUserLogsAdminCouponDao.data[i]._id
                                    obj.uid = downloadUserLogsAdminCouponDao.data[i].uid
                                    obj.coupon_id = downloadUserLogsAdminCouponDao.data[i].coupon_id
                                    obj.user_coupon_id = downloadUserLogsAdminCouponDao.data[i].user_coupon_id
                                    obj.claim_count = downloadUserLogsAdminCouponDao.data[i].downloaded_count
                                    obj.profileDetails = downloadUserLogsAdminCouponDao.data[i].profileDetails

                                    finalDataArray.push(obj)
                                }



                                response.error = false
                                response.statusCode = STRINGS.successStatusCode
                                response.message = STRINGS.SuccessString
                                response.totalPages = totalPages
                                response.data = finalDataArray
                                resolve(response)
                            }
                        }
                    }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


}