module.exports = function () {
    const FoodTripDao = require('../../dao/admin/FoodTripDao')
    const STRINGS = require('../../strings.json')
    require('dotenv').config()
    const foodTripDaoObject = new FoodTripDao()
    const likesDao = require('../../dao/web/LikesDao')
    const likesObject = new likesDao()



    
    this.listFoodTripService = async (request) => {
        // console.log("pageNumber");
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                // console.log("request.body", request.body)
                var getTotalFoodTripListCountDao = await foodTripDaoObject.getTotalFoodTripListCountDao(request.body)
                // console.log('consoleJob', getTotalFoodTripListCountDao.data.length);

                if (getTotalFoodTripListCountDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {

                    const totalDatas = getTotalFoodTripListCountDao.data.length;
                    const page_number = request.body.page_number - 1 || 0
                    const limit = request.body.row_per_page
                    const totalPages = Math.ceil(totalDatas / limit)

                    object.page_number = page_number
                    object.totalPages = totalPages
                    object.limit = limit

                    const assignInput = { ...request.body, ...object }
                    // console.log('listJobCentresDaoConc', assignInput);
                    var listFoodTripDao = await foodTripDaoObject.listFoodTripDao(assignInput)
                    // console.log('var listFoodTripDao = await', listFoodTripDao);

                    if (listFoodTripDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        // if (listFoodTripDao.data.length > 0) {
                        //     var finalDataArray = [];
                        //     //    userlistFoodTripDao.data.forEach(element => {
                        //     for (var i = 0; i < listFoodTripDao.data.length; i++) {
                        // var dateValidations = await JobCentresDao.dateValidations(listFoodTripDao.data[i])
                        // var downloadCount = await JobCentresDao.downloadCount(listFoodTripDao.data[i])


                        //         var stutusDownloadCount = {
                        //             downloadCount:downloadCount.data.length,
                        //             JobCentresStatus:dateValidations.data.length>0?'Active':'Expired'
                        //         }
                               
                        //             const addKey = { ...listFoodTripDao.data[i], ...stutusDownloadCount }
                        //             finalDataArray.push(addKey)
                                
                        //         // });
                        //     }
                        // }
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = totalPages
                        response.data = listFoodTripDao.data
                        resolve(response)
                    }
                }

            } catch (e) {
                ////console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.getOneFoodTripService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var getOneFoodTripDao = await foodTripDaoObject.getOneFoodTripDao(request.body)
             
                if (getOneFoodTripDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    

                    // object.articlesList = foodTripDaoObject.result
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = getOneFoodTripDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log("new werrors handl", e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })

    }
    
    
    this.editFoodTripService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var editFoodTripDao = await foodTripDaoObject.editFoodTripDao(request.body)
             
                if (editFoodTripDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    

                    // object.articlesList = foodTripDaoObject.result
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = editFoodTripDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log("new werrors handl", e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })

    }
    



    

    this.deleteOneFoodTripService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var deleteOneFoodTripDao = await foodTripDaoObject.deleteOneFoodTripDao(request.body)
             
                if (deleteOneFoodTripDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    

                    // object.articlesList = foodTripDaoObject.result
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = deleteOneFoodTripDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log("new werrors handl", e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })

    }
    this.hideUnhideFoodTripService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                if(request.body.hide==true){
                    var hideFoodTripDao = await foodTripDaoObject.hideFoodTripDao(request.body)
                 
                    if (hideFoodTripDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        
    
                        // object.articlesList = foodTripDaoObject.result
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = hideFoodTripDao.data
                        resolve(response)
                    }
                }else{
                    var unhideFoodTripDao = await foodTripDaoObject.unhideFoodTripDao(request.body)
                 
                    if (unhideFoodTripDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        
    
                        // object.articlesList = foodTripDaoObject.result
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = unhideFoodTripDao.data
                        resolve(response)
                    }
                }
            } catch (e) {
                console.log("new werrors handl", e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })

    }
}