module.exports = function () {
    var JobCentreDao = require('../../dao/admin/JobCentreDao')

    const STRINGS = require('../../strings.json')
    // const common= require('../../utils/common')
    require('../../utils/common')()


    require('dotenv').config()
    var JobCentreDaoObject = new JobCentreDao()
    // var commonObject = new common()

    this.addOneJobFairService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                request.body.is_active = 1
                var addOneJobFairDao = await JobCentreDaoObject.addOneJobFairDao(request.body)
                if (addOneJobFairDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = addOneJobFairDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.getJobFairListService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                request.body.is_active = 1
                request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                var pageNumber = request.body.pageNumber
                request.body.RowsPerpage = request.body.RowsPerpage.length == 0 ? 0 : request.body.RowsPerpage
                RowsPerpage = request.body.RowsPerpage
                var getTotalJobFairListDao = await JobCentreDaoObject.getTotalJobFairListDao(request.body)
                if (getTotalJobFairListDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else if (getTotalJobFairListDao.result > 0) {
                    var lenght = getTotalJobFairListDao.result
                    var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, RowsPerpage)

                    var getJobFairListDao = await JobCentreDaoObject.getJobFairListDao(request.body)
                    if (getJobFairListDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = paginationDetails.totalPages
                        response.data = getJobFairListDao.result
                        resolve(response)
                    }
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.totalPages = 0
                    response.data = []
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.viewOneJobFairService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var viewOneJobFairDao = await JobCentreDaoObject.viewOneJobFairDao(request.body)
                if (viewOneJobFairDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = viewOneJobFairDao.result
                    resolve(response)
                }
            } catch (e) {
                // console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.editOneSurveyService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var editOneSurveyDao = await JobCentreDaoObject.editOneSurveyDao(request.body)
                if (editOneSurveyDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = editOneSurveyDao.result
                    resolve(response)
                }
            } catch (e) {
                // console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.deleteOneJobFairService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var deleteOneJobFairDao = await JobCentreDaoObject.deleteOneJobFairDao(request.body)
                if (deleteOneJobFairDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = deleteOneJobFairDao.result
                    resolve(response)
                }
            } catch (e) {
                // console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.getALLSubscriptionListService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                request.body.is_active = 1
                request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                var pageNumber = request.body.pageNumber
                request.body.RowsPerpage = request.body.RowsPerpage.length == 0 ? 0 : request.body.RowsPerpage
                RowsPerpage = request.body.RowsPerpage
                var getTotalSubscriptionListDao = await JobCentreDaoObject.getTotalSubscriptionListDao(request.body)
                if (getTotalSubscriptionListDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else if (getTotalSubscriptionListDao.result > 0) {
                    var lenght = getTotalSubscriptionListDao.result
                    var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, RowsPerpage)

                    // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                    var getALLSubscriptionListDao = await JobCentreDaoObject.getALLSubscriptionListDao(request.body)
                    if (getALLSubscriptionListDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = paginationDetails.totalPages
                        response.data = getALLSubscriptionListDao.result
                        resolve(response)
                    }
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.totalPages = 0
                    response.data = []
                    resolve(response)
                }
            } catch (e) {
                // console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }





    this.getOneSubscriptionService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // console.log('getOneSubscriptionService');
                var getOneSubscriptionCheckDao = await JobCentreDaoObject.getOneSubscriptionCheckDao(request.body)
                if (getOneSubscriptionCheckDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    request.body.post_type = getOneSubscriptionCheckDao.result.post_type;
                    // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                    if (request.body.post_type == 'jobPost' || request.body.post_type == 'businessDirectory') {
                        var getOneSubscriptionDao = await JobCentreDaoObject.getOneSubscriptionDao(request.body)


                        if (getOneSubscriptionDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {

                            var date = new Date()
                            var endTime = new Date(getOneSubscriptionDao.result.end_time)
                            var status = endTime >= date ? "Active" : "Expired"
                            getOneSubscriptionDao.result.status = status
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.data = getOneSubscriptionDao.result[0]
                            resolve(response)
                        }
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = 'please give valid post_type'
                        resolve(response)
                    }
                }
            } catch (e) {
                // console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }












}