module.exports = function () {
    const STRINGS = require('../../strings.json')
    require('dotenv').config()
    const Referral = require('../../dao/admin/ReferralDao')
    const ReferralObject = new Referral()




    this.listReferralServices = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var listReferralCountDao = await ReferralObject.listReferralCountDao(request.body)
                // console.log("listReferralCountDao",listReferralCountDao)
                if (listReferralCountDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    const totalDatas = listReferralCountDao.data.length;
                    const page_number = request.body.page_number - 1 || 0
                    const limit = request.body.row_per_page
                    const totalPages = Math.ceil(totalDatas / limit)

                    object.page_number = page_number
                    object.totalPages = totalPages
                    object.limit = limit
                    const assignInput = { ...request.body, ...object }

                var listReferralDao = await ReferralObject.listReferralDao(assignInput)
                if (listReferralDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = listReferralDao.data
                    response.totalPages=totalPages
                    resolve(response)
                }
            }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.viewReferralService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var viewReferralDao = await ReferralObject.viewReferralDao(request.body)
                if (viewReferralDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    const totalDatas = viewReferralDao.data;
                    const page_number = request.body.page_number - 1 || 0
                    const limit = request.body.row_per_page
                    const totalPages = Math.ceil(totalDatas / limit)

                    object.page_number = page_number
                    object.totalPages = totalPages
                    object.limit = limit
                    const assignInput = { ...request.body, ...object }

                    var viewUserDetailsDao = await ReferralObject.viewUserDetailsDao(assignInput)
                    // console.log("viewUserDetailsDao",viewUserDetailsDao)
                    if (viewUserDetailsDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                       
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    // response.data=viewUserDetailsDao.data,
                    response.referralDetails=viewUserDetailsDao.data
                    response.totalPages=totalPages
                    resolve(response)
                    }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }





}