module.exports = function () {
    const commentsDao = require('../../dao/web/CommentDao')
    const profiledao = require('../../dao/web/MyProfileDao')

    const STRINGS = require('../../strings.json')
    require('dotenv').config()
    const commentsDaoObject = new commentsDao()
    const profileDaoObject = new profiledao()
    //likes dao
    const likesDao = require('../../dao/web/LikesDao')
    const likesObject = new likesDao()
    var notificationController = require('../../controller/web/notificationController')
    var notificationControllerObject = new notificationController()

    this.postCommentsService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                if (request.body.type == "reply") {
                    var persist1 = {
                        is_active: 1
                    };
                    var persist = Object.assign(request.body, persist1)

                    //profile getting
                    var object1 = {}
                    var getOneProfileDao = await commentsDaoObject.getOneProfileDao(request.body)
                    if (getOneProfileDao.data.length !== 0) {
                        object1.profile_photo = getOneProfileDao.data.profile_photo
                        object1.full_name = getOneProfileDao.data.full_name
                    }
                    object1.is_active = 1
                    var persist = Object.assign(request.body, object1)

                    var commentsDaoResponse = await commentsDaoObject.replyCommentsDao(persist)
                    var updt = {}
                    var getCountReplies = await commentsDaoObject.getCountRepliesDao(request.body)
                    var a = getCountReplies.data
                    updt.updatecount = Object.keys(a).length
                    updt.comment_ref_id = request.body.comment_ref_id

                    var replyCountDaoResponse = await commentsDaoObject.putTotalRepliesDao(updt)

                } else if (request.body.type == "comment") {

                    //profile getting
                    var object1 = {}
                    var getOneProfileDao = await commentsDaoObject.getOneProfileDao(request.body)
                    // console.log("getOneProfileDao", getOneProfileDao)
                    if (getOneProfileDao.data == null) {

                    } else if (getOneProfileDao.data.length !== 0) {
                        object1.profile_photo = getOneProfileDao.data.profile_photo
                        object1.full_name = getOneProfileDao.data.full_name
                    }
                    object1.is_active = 1
                    var persist = Object.assign(request.body, object1)
                    //update in comments collection
                    var commentsDaoResponse = await commentsDaoObject.postCommentsDao(persist)

                    //obj
                    var commentsCount = await commentsDaoObject.getOneCommentsDao(request.body)
                    var a = commentsCount.data
                    object.updatecount = Object.keys(a).length
                    object.comment_ref_id = request.body.comment_ref_id
                    object.post_type = request.body.post_type

                    //updating to corresponding dao

                    var commentsCountUpdate = await commentsDaoObject.putTotalCommentsDao(object)
                }

                if (commentsDaoObject.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {

                    var getOnePostDao = await commentsDaoObject.getOnePostDao(request.body)
                    if (getOnePostDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    }

                    var postType = request.body.post_type == 'foodTripPost' ? 'foodtrip' :
                        request.body.post_type == 'bazaarCity' ? 'pinoy-market-place' :
                        request.body.post_type == 'donasayon' ? 'dkny' :
                        request.body.post_type == 'tambayan' ? 'tambayan' : null


                    if (postType != null && request.body.uid!= getOnePostDao.data[0].uid) {

                        var user_name = getOneProfileDao.data.full_name
                        var user_profile = getOneProfileDao.data.profile_photo
                        var obj = {};

                        if (request.body.type == "comment") {
                            obj.uid = getOnePostDao.data[0].uid
                            obj.notification_message = `have Commented on your ${postType} post`
                            obj.post_type = "comment"
                            obj.post_module=postType
                            obj.post_id = request.body.post_id
                        } else {
                            obj.uid = getCountReplies.data[0].uid
                            obj.notification_message = `replied to your comment on ${postType} post`
                            obj.post_type = "reply"
                            obj.post_module=postType
                            obj.post_id = request.body.post_id
                        }
                        obj.user_name = user_name
                        obj.user_profile = user_profile
                        
                        obj.is_active = 1
                        request.body.obj = obj
                        var addNotification = await notificationControllerObject.addNotificationController(request)
                        // console.log("addNotification", addNotification)
                        if (addNotification.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.data = commentsDaoResponse.data
                            resolve(response)
                        }
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = commentsDaoResponse.data
                        resolve(response)
                    }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.getcommentsListService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var commentsList = await commentsDaoObject.getOneCommentsDao(request.body)
                // console.log("commentsList", commentsList.data)
                //LIKED OR NOT
                var iteraration = commentsList.data.length

                for (var i = 0; i < iteraration; i++) {
                    var obj = {
                        post_id: commentsList.data[i]._id.toString(),
                        uid: request.body.uid
                    }
                    var likedby = await likesObject.forlikedbyList(obj)
                    if (likedby.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        return resolve(response)
                    }

                    // console.log("likedby", likedby)
                    commentsList.data[i].likedby = likedby.data.length > 0 ? 1 : 0
                }
                if (commentsDaoObject.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = commentsList.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.getReplyListService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var commentsList = await commentsDaoObject.getCountRepliesDao(request.body)
                if (commentsDaoObject.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = commentsList.data

                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

}