module.exports = function () {
    const STRINGS = require('../../strings.json')
    require('dotenv').config()
    const couponDao = require('../../dao/web/CouponDao')
    const couponDaoObject = new couponDao()
    var PinoyPreneursDao = require('../../dao/web/PinoyPreneursDao')
    var PinoyPreneursDaoObject = new PinoyPreneursDao()
    var myprofile = require('../../dao/web/MyProfileDao')
    var myprofileDaoObject = new myprofile()
    const likesDao = require('../../dao/web/LikesDao')
    const likesObject = new likesDao()
    const { v4: uuidv4 } = require('uuid')
    const { cloudinary } = require('../../utils/cloudinary')
    const puppeteer = require('puppeteer');
    const common= require('../../utils/common')
    var commonObject = new common()

    this.addCouponService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                // console.log("request.body", request.body)
                var checkPinoyPreneurDao = await PinoyPreneursDaoObject.checkPinoyPreneurDao(request.body)
                if (checkPinoyPreneurDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else if (checkPinoyPreneurDao.data && checkPinoyPreneurDao.data !== null) {

                    var checkCouponNameExist = await couponDaoObject.checkCouponNameExist(request.body)
                    console.log("checkCouponNameExist", checkCouponNameExist)

                    if (checkCouponNameExist.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    }
                    // active coupon prevents new coupon

                    // else if (checkCouponNameExist.data && checkCouponNameExist.data.length >0) {
                    //     // console.log("checkPinoyPreneurDao", checkPinoyPreneurDao)
                    //     response.error = true
                    //     response.statusCode = STRINGS.errorStatusCode
                    //     response.message = 'Try after expiration of current coupon '
                    //     resolve(response)
                    // }

                    else {
                        console.log('addding', request.body.coupon_validity_to, new Date(request.body.coupon_validity_to).toUTCString())
                        const newDateConversion = {
                            is_active: 1,
                            local_coupon_validity_to: new Date(request.body.coupon_validity_to).toUTCString(), local_coupon_validity_from: new Date(request.body.coupon_validity_from).toUTCString()
                        }
                        const coupon_id = uuidv4().slice(0, 8);
                        var concat = { ...request.body, coupon_id }
                        object = { ...concat, ...newDateConversion }
                        console.log("concat", object)

                        var addCouponDao = await couponDaoObject.addCouponDao(object)
                        // console.log("getOneProfileDao", getOneProfileDao)

                        if (addCouponDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.data = addCouponDao.data
                            resolve(response)
                        }
                    }
                }
                else {
                    // console.log("checkPinoyPreneurDao", checkPinoyPreneurDao)
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = 'Please Use A PinoyPreneur Login'
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.listCouponsService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var getBlockedUsers=await commonObject.getBlockedUsers(request.body)
                // console.log("getBlockedUsers",getBlockedUsers);

                var listCouponDaoCount = await couponDaoObject.listCouponDaoCount(request.body,getBlockedUsers)
                // console.log("listCouponDaoCount", listCouponDaoCount.data.length)
                if (listCouponDaoCount.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {

                    const totalDatas = listCouponDaoCount.data.length;
                    const page_number = request.body.page_number - 1 || 0
                    const limit = request.body.row_per_page
                    const totalPages = Math.ceil(totalDatas / limit)

                    object.page_number = page_number
                    object.totalPages = totalPages
                    object.limit = limit

                    const assignInput = { ...request.body, ...object }
                    // console.log('listCouponDaoConc', assignInput);
                    var listCouponDao = await couponDaoObject.listCouponDao(assignInput,getBlockedUsers)
                    // console.log('listCouponDao', listCouponDao);

                    if (listCouponDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        if (listCouponDao.data.length > 0) {
                            var finalDataArray = [];
                            //    userListCouponDao.data.forEach(element => {
                            for (var i = 0; i < listCouponDao.data.length; i++) {
                                if (listCouponDao.data[i].total_Number_of_coupons > listCouponDao.data[i].claimed_coupons) {
                                    var likeinput = {
                                        post_id: listCouponDao.data[i]._id,
                                        uid: request.body.uid
                                    }
                                    var searchinlike = await likesObject.forlikedbyList(likeinput)
                                    // console.log("loop beginning", searchinlike)
                                    if (searchinlike.error) {
                                        response.error = true
                                        response.statusCode = STRINGS.errorStatusCode
                                        response.message = STRINGS.commanErrorString
                                        resolve(response)
                                    } else {

                                        const addKey = { ...listCouponDao.data[i], likedBy: searchinlike.data.length > 0 ? '1' : '0' }
                                        finalDataArray.push(addKey)
                                    }
                                }
                                // });
                            }
                        }
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = totalPages
                        response.data = finalDataArray
                        resolve(response)
                    }
                }

            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.viewCouponService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var viewCouponDao = await couponDaoObject.viewCouponDao(request.body)
                if (viewCouponDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    // console.log("loopbeginning", viewCouponDao)

                    if (viewCouponDao.data.length > 0) {
                        var finalDataArray = [];
                        //    userviewCouponDao.data.forEach(element => {
                        for (var i = 0; i < viewCouponDao.data.length; i++) {
                            var likeinput = {
                                post_id: viewCouponDao.data[i]._id,
                                uid: request.body.uid
                            }
                            var searchinlike = await likesObject.forlikedbyList(likeinput)
                            // console.log("loop beginning", searchinlike)
                            if (searchinlike.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.commanErrorString
                                resolve(response)
                            } else {

                                const addKey = { ...viewCouponDao.data[i], likedBy: searchinlike.data.length > 0 ? '1' : '0' }
                                finalDataArray.push(addKey)
                            }
                            // });
                        }
                    }
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    // response.totalPages = totalPages
                    response.data = finalDataArray
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.editCouponService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                // const new_coupon_id =  uuidv4().slice(0, 8);
                // var concat = { ...request.body, new_coupon_id }
                request.body.local_coupon_validity_to= new Date(request.body.coupon_validity_to).toUTCString(),
                request.body.local_coupon_validity_from=new Date(request.body.coupon_validity_from).toUTCString()

                object = { ...request.body, is_active: 1 }
                var editCouponDao = await couponDaoObject.editCouponDao(object)
                if (editCouponDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = editCouponDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }




    this.deleteCouponService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var deleteCouponDao = await couponDaoObject.deleteCouponDao(request.body)
                if (deleteCouponDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = deleteCouponDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.updateHiddenCouponService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                // console.log(request.body,"hello")
                var CouponDaoDetails = await couponDaoObject.findOneCouponDao(request.body)
                if (CouponDaoDetails.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    // console.log(CouponDaoDetails, "Coupon")
                    if (CouponDaoDetails.result) {
                        if (CouponDaoDetails.result.uid == request.body.uid) {
                            var updateHiddenCouponDao = await couponDaoObject.updateHiddenCouponDao(request.body)
                            if (updateHiddenCouponDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.commanErrorString
                                resolve(response)
                            } else {
                                response.error = false
                                response.statusCode = STRINGS.successStatusCode
                                response.message = 'Hidden updated successfully ..!!'
                                // response.data = updateHiddenCouponDao.data
                                resolve(response)
                            }
                        } else {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = 'Coupon not found ..!!'
                            resolve(response)

                        }
                    } else {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = 'Invalid Coupon ..!!'
                        resolve(response)
                    }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.pinoyPreneurCouponListService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                if (request.body.viewing_uid) {
                    // console.log("data1")
                    var pinoyPreneurCouponListDao = await couponDaoObject.pinoyPreneurCouponListDao(request.body)
                } else {
                    // console.log("data2")
                    var pinoyPreneurCouponListDao = await couponDaoObject.pinoyPreneurOwnCouponListDao(request.body)
                }
                if (pinoyPreneurCouponListDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    // console.log("pinoyPreneurCouponListDao", pinoyPreneurCouponListDao)

                    // if (pinoyPreneurCouponListDao.data.length > 0) {
                    var finalDataArray = [];
                    //    userListCouponDao.data.forEach(element => {
                    for (var i = 0; i < pinoyPreneurCouponListDao.data.length; i++) {
                        var dateValidations = await couponDaoObject.dateValidations(pinoyPreneurCouponListDao.data[i])
                        // console.log("dateValidations", dateValidations,"length",dateValidations.data.length > 0)

                        var likeinput = {
                            post_id: pinoyPreneurCouponListDao.data[i]._id,
                            uid: request.body.uid
                        }
                        var searchinlike = await likesObject.getLikedByDao(likeinput)
                        // console.log("loop beginning", searchinlike)
                        if (searchinlike.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            var addingKeys = {}
                            // console.log("dateValidations", dateValidations,"length",dateValidations.data.length > 0)
                            addingKeys.couponStatus = dateValidations.data.length > 0 ? 'Active' : 'Expired',
                                addingKeys.like_count = searchinlike.data.length
                            const addKey = { ...pinoyPreneurCouponListDao.data[i], ...addingKeys }
                            finalDataArray.push(addKey)
                        }
                        // });
                    }
                    // }

                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = finalDataArray
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }




    const template = (data) => {
        // console.log("dataaaaas", data)
        const from = data.local_coupon_validity_from.split(" ")
        const to = data.local_coupon_validity_to.split(" ")

        return `
    <!DOCTYPE html>
<html lang="en">

<head>
<style>html {
    -webkit-print-color-adjust: exact;
  }</style>
  <meta charset="UTF-8" />
  <meta http-equiv="X-UA-Compatible" content="IE=edge" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>Coupon</title>
</head>

<body>
  <div style="
        position: absolute;
        height: 260px;
        width: 520px;
        top: 50%;
        left: 50%;
        transform: translate(-50%, -50%);
        border: 2px dotted;
        padding: 16px;
        display: flex;
      ">
    <div style="height: 100%;width:40%">
<img style="object-fit:contain;" src=${data.coupon_image} height=100%, width=100%/>
    </div>
    <div style="height: 100%;width:60%">
      <div style="height:10%;width:100%">
      </div>
   <div style="height: 6%;background:#4B3E21">
   </div>

      <div style="height: 84%;width:92%;padding-left: 4%;padding-right: 4%;">
        <div style="height: 30%;width:100%;display: flex;justify-content: flex-end;position: relative;">
          <div style="height:100%;width: 72%;display: flex;align-items: center;">
            <span style="color: #808080;font: size 16px;">${from[2]}</span>
            <span style="font-size: 30px ;">
              &nbsp;${from[1]}&nbsp;-&nbsp;
            </span>
            <span style="color: #808080;font: size 16px;">${to[2]}</span>
            <span style="font-size: 30px;">
              &nbsp; ${to[1]}
            </span>
          </div>
          
          ${data.offer_type != 'Service/Item' ? (`
          <div style="position: absolute;height:100%;width:28%;left:0;top:-30px">
        
            <img src="https://res.cloudinary.com/mykapitbahay/image/upload/v1666008718/offer_percentage_zg8tnl.png"  style="height: auto; width: 100%"></img>

            <div
              style="
                position: absolute;
                top: 6px;
                left: 0;
                height: 100%;
                width: 100%;
                display: flex;
                align-items: center;
                justify-content: center;
                color: white;
                font-size: 14px;
              "
            >
              ${data.offer_value}${data.offer_type == 'In CAD' ? '$' : '%'}
          </div>
        </div>`) : (`

          <div style="position: absolute;height:100%;width:28%;left:-20px;top:-22px">
            <img src="https://res.cloudinary.com/mykapitbahay/image/upload/v1666008717/offer_services_or_text_badge_iiui0k.png" height="80px"/>

            <div style="
              font-size: 9px;
              color: white;
              text-align: center;
              transform: rotate(-45deg);
              margin-top: -58px;
              margin-left: -28px;
              width:120px;
            ">
              ${data.offer_value}
            </div>
          </div>`)}
        </div>
        <div style="min-height: 35%;width:100%">
          <div style="font-size: 16px;color:#4B3E21;font-weight: 600;padding-bottom: 2%;">
           ${data.coupon_name}
          </div>
          <div style="font-size: 11px;color:#808080;">
          ${data.coupon_description.slice(0, 110)}
          </div>
        </div>
        <div style="height: 35%;width:100%;display: flex;">
          <div style="height: 100%;width:50%;display: flex;flex-direction: column;">
            <div style="height: 40%;font-size: 12px; width:100%;display: flex;">
              <img src="https://res.cloudinary.com/mykapitbahay/image/upload/v1666008700/vuesax-bold-ticket-star_zmqobm.png" height="100%"></img>
              <div style="font-size: 10px;padding-left:10px;max-width: fit-content;display: flex;align-items: center;">
              ${data.coupon_id}
              </div>
            </div>
            <div style="height:60%;width: 100%;font-size: 10px;padding-top: 4%;color: #808080;">
              * &nbsp; ${data.usage_limit_per_user} Usage per coupon
            </div>
          </div>
          <div style="height: 100%;width:50%">
            <div style="font-size: 12px;color:#808080;">
              Your Coupon Code:
            </div>
            <div>
            ${data.user_couponid}
            </div>
          </div>
        </div>
      </div>
    </div>
   
</body>

</html>`
    }


    this.userCouponDownloadService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var userCouponDownloadDao = await couponDaoObject.userCouponDownloadValidationDao(request.body)
                // console.log("userCouponDownloadDao", userCouponDownloadDao);

                if (userCouponDownloadDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {



                    if (userCouponDownloadDao.data.length == 0) {

                        var viewCouponDao = await couponDaoObject.viewCouponDao(request.body)
                        
                        if (viewCouponDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            var couponObject = {}
                            var couponCount = (viewCouponDao.data[0].claimed_coupons) + 1
                            // console.log(viewCouponDao,"viewCouponDao",couponCount, viewCouponDao.data[0].claimed_coupons);
                            if (couponCount <= viewCouponDao.data[0].total_Number_of_coupons) {
                                couponObject = { ...request.body, couponCount }
                                var myprofileDao = await myprofileDaoObject.getOneProfileDao({ user_id: request.body.uid })
                                // console.log("myprofileDao", myprofileDao);

                                if (myprofileDao.error) {
                                    response.error = true
                                    response.statusCode = STRINGS.errorStatusCode
                                    response.message = STRINGS.commanErrorString
                                    resolve(response)
                                } else {
                                    const user_coupon_id = uuidv4().slice(0, 6);
                                    var concat = { ...request.body, user_coupon_id }
                                    var usageLimit = {
                                        claim_count: viewCouponDao.data[0].usage_limit_per_user,
                                        is_active: 1
                                    }
                                    object = { ...concat, ...usageLimit }

                                    var addUserCouponDao = await couponDaoObject.addUserCouponDao(object)
                                    // console.log("addUserCouponDao", addUserCouponDao);
                                    if (addUserCouponDao.error) {
                                        response.error = true
                                        response.statusCode = STRINGS.errorStatusCode
                                        response.message = STRINGS.commanErrorString
                                        resolve(response)
                                    } else {


                                        var updateCountCouponDao = await couponDaoObject.updateDownloaded_couponsDao(couponObject)
                                        // console.log("updateCountCouponDao", updateCountCouponDao,couponCount);
                                        var arrayPdf = []
                                        if (updateCountCouponDao.error) {
                                            response.error = true
                                            response.statusCode = STRINGS.errorStatusCode
                                            response.message = STRINGS.commanErrorString
                                            resolve(response)
                                        } else {
                                            // const browser = await puppeteer.launch({
                                            //     headless: true,
                                            //     args: ['--no-sandbox']
                                            // })
                                            // const page = await browser.newPage();
                                            // await page.setContent(template(viewCouponDao.data[0]));
                                            // const data = await page.pdf({ format: 'A3' });
                                            // await browser.close();
                                            // const datasSer = await cloudinary.uploader
                                            //     .upload_stream({ upload_preset: 'documents' }, async (error, result) => {

                                            //         responseData.data = result.secure_url
                                            //         return result.secure_url
                                            //         console.log("documentsURL", result.secure_url)
                                            //     })
                                            //     .end(data);


                                            var responseData = {}
                                            // var input = viewCouponDao.data[0]
                                            const puppet = async (input, request) => {
                                                var response = {}
                                                console.log("innn")
                                                const browser = await puppeteer.launch({
                                                    headless: true,
                                                    args: ['--no-sandbox']
                                                })
                                                const page = await browser.newPage();
                                                await page.setContent(template(input));
                                                const data = await page.pdf({ format: 'A5', landscape: true });
                                                await browser.close();
                                                await cloudinary.uploader
                                                    .upload_stream({ upload_preset: 'documents' }, async (error, result) => {

                                                        request.body.is_active=1
                                                        var couponpdfObject = { ...request.body, pdf_url: result.secure_url }

                                                        // console.log("pdfdownloader")
                                                        // console.log("documentsURL", result.secure_url)
                                                        var addCouponpdfDao = await couponDaoObject.addCouponpdfDao(couponpdfObject)
                                                        // console.log("addCouponpdfDao", updateCountCouponDao,couponCount);



                                                        // responseData.data = result.secure_url
                                                        // return result.secure_url
                                                        if (addCouponpdfDao.error) {
                                                            response.error = true
                                                            response.statusCode = STRINGS.errorStatusCode
                                                            response.message = STRINGS.commanErrorString
                                                            resolve(response)
                                                        } else {

                                                            response.error = false
                                                            response.statusCode = STRINGS.successStatusCode
                                                            response.message = STRINGS.SuccessString
                                                            // response.data = addCouponpdfDao.data
                                                            response.pdf_url = addCouponpdfDao.data.pdf_url
                                                            resolve(response)
                                                        }
                                                    })
                                                    .end(data);
                                            }

                                            const cloud = await puppet({ ...viewCouponDao.data[0], user_couponid: user_coupon_id }, request)



                                            // const res = {}
                                            // const cloud = await puppet(viewCouponDao.data[0], request)
                                            // console.log('cloud', cloud)
                                            // console.log('cloud2', responseData)

                                            // console.log("responsepuppetDocument", datasSer);
                                            //    else {

                                            // }
                                        }

                                    }
                                }
                            }
                            else {
                                response.error = false
                                response.statusCode = STRINGS.successStatusCode
                                response.message = 'No Couponse Left'
                                // response.data = updateCountCouponDao.data
                                resolve(response)
                            }
                        }
                    } else if (userCouponDownloadDao.data.length > 0) {

                        var viewCouponDao = await couponDaoObject.viewCouponDao(request.body)
                        // console.log("viewCouponDao", viewCouponDao);
                        if (viewCouponDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            var responseData = {}
                            // const browser = await puppeteer.launch({headless: true,
                            //     args: ['--no-sandbox']})
                            // const page = await browser.newPage();
                            // await page.setContent(template(viewCouponDao.data[0]));
                            // const data = await page.pdf({format: 'A3'});
                            // await browser.close();
                            //     await cloudinary.uploader
                            //               .upload_stream({upload_preset:'documents'}, async(error, result) => {
                            //                 console.log("documents",result.secure_url)

                            //                 responseData.data=result.secure_url

                            //               })
                            //               .end(data);
                            //      console.log("responsepuppet",responseData);
                            var checkPdfUserExists = await couponDaoObject.checkPdfUserExists(request.body)


                            const puppet = async (input, request) => {
                                var response = {}
                                console.log("innn")
                                const browser = await puppeteer.launch({
                                    headless: true,
                                    args: ['--no-sandbox']
                                })
                                const page = await browser.newPage();
                                await page.setContent(template(input));
                                const data = await page.pdf({ format: 'A5', landscape: true });
                                await browser.close();
                                await cloudinary.uploader
                                    .upload_stream({ upload_preset: 'documents' }, async (error, result) => {


                                        var couponpdfObject = { ...request.body, pdf_url: result.secure_url }

                                        // console.log("pdfdownloader")
                                        // console.log("documentsURL", result.secure_url)
                                        var updatepdfUrl = await couponDaoObject.updatepdfUrl(couponpdfObject)
                                        // console.log("addCouponpdfDao", updateCountCouponDao,couponCount);



                                        // responseData.data = result.secure_url
                                        // return result.secure_url
                                        if (updatepdfUrl.error) {
                                            response.error = true
                                            response.statusCode = STRINGS.errorStatusCode
                                            response.message = STRINGS.commanErrorString
                                            resolve(response)
                                        } else {

                                            // response.error = false
                                            // response.statusCode = STRINGS.successStatusCode
                                            // response.message = STRINGS.SuccessString
                                            // resolve(response)



                                            if(updatepdfUrl.data){
                                                var checkPdfExists = await couponDaoObject.checkPdfExists(request.body)
                                                // console.log("checkPdfExists", checkPdfExists);
                    
                                                // update already downloaded coupons count
                                                var couponObject = {}
                                                var couponCount = (viewCouponDao.data[0].downloaded_coupons) + 1
                                                couponObject = { ...request.body, couponCount }
                    
                                                var updateDownloadedforAlreadyDownloaded = await couponDaoObject.updateDownloaded_couponsDao(couponObject)
                                                // console.log("updateCountCouponDao", updateCountCouponDao,couponCount);
                                                if (updateDownloadedforAlreadyDownloaded.error) {
                                                    response.error = true
                                                    response.statusCode = STRINGS.errorStatusCode
                                                    response.message = STRINGS.commanErrorString
                                                    resolve(response)
                                                } else {
                                                    if (viewCouponDao.error) {
                                                        response.error = true
                                                        response.statusCode = STRINGS.errorStatusCode
                                                        response.message = STRINGS.commanErrorString
                                                        resolve(response)
                                                    } else {
                                                        var download = {
                                                            uid: request.body.uid,
                                                            coupon_id: request.body.coupon_id,
                                                            downloaded_count: (userCouponDownloadDao.data[0].downloaded_count) + 1,
                                                        }
                    
                                                        var downloadedCouponCountDao = await couponDaoObject.downloadedCouponCountDao(download)
                                                        // console.log("checkPdfUserExists", checkPdfUserExists);
                                                        if (downloadedCouponCountDao.error) {
                                                            response.error = true
                                                            response.statusCode = STRINGS.errorStatusCode
                                                            response.message = STRINGS.commanErrorString
                                                            resolve(response)
                                                        } else {
                                                            response.error = false
                                                            response.statusCode = STRINGS.successStatusCode
                                                            response.message = STRINGS.SuccessString
                                                            response.data = viewCouponDao.data
                                                            response.pdf_url = checkPdfExists.data[0].pdf_url
                                                            resolve(response)
                                                        }
                                                    }
                                                }
                                            }

                                        }
                                    })
                                    .end(data);
                            }
                            
                            const cloud = await puppet({ ...viewCouponDao.data[0], user_couponid: userCouponDownloadDao.data[0].user_coupon_id }, request)
                            
                            
                            
                            
                            
                            


                            
                        }
                    }
                    else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = userCouponDownloadDao.data
                        resolve(response)
                    }
                    // }
                    // }else{
                    //     response.error = false
                    //     response.statusCode = STRINGS.successStatusCode
                    //     response.message = 'Sorry No Coupons Left'
                    //     resolve(response)   
                    // }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }





    this.userCouponListService = async (request) => {

        const today = new Date()

        // to return the date number(1-31) for the specified date
        var a = today.toISOString().substring(0, 10);
        var b = new Date(a)

        var tomorrow = new Date(a)

        tomorrow.setDate(b.getDate() - 1)
        //returns the prev date
        let expire = new Date(a)

        expire.setDate(b.getDate() - 2)


        // console.log(request,"rest")
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                if (request.body.viewing_uid) {
                    // console.log("data1")
                    var userListCouponDao = await couponDaoObject.userListCouponDao(request.body)
                } else {
                    // console.log("data2")
                    var userListCouponDao = await couponDaoObject.ownUserListCouponDao(request.body)
                }
                // console.log("userListCouponDao", userListCouponDao)

                if (userListCouponDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)

                } else {
                    var finalDataArray = [];
                    if (userListCouponDao.data.length > 0) {
                        //    userListCouponDao.data.forEach(element => {
                        for (var i = 0; i < userListCouponDao.data.length; i++) {
                            var likeinput = {
                                post_id: userListCouponDao.data[i].result._id,
                                uid: request.body.uid
                            }
                            var searchinlike = await likesObject.forlikedbyList(likeinput)
                            // console.log("loop beginning", searchinlike)
                            console.log("userListCouponDao", userListCouponDao.data[i],JSON.stringify(userListCouponDao.data[i].result.coupon_validity_to),JSON.stringify(tomorrow),"condition",JSON.stringify(userListCouponDao.data[i].result.coupon_validity_to) > (JSON.stringify(tomorrow)), "claim",userListCouponDao.data[i].result.claimed_coupons<=userListCouponDao.data[i].result.total_Number_of_coupons, "count",userListCouponDao.data[i].claimed_coupons,userListCouponDao.data[i].total_Number_of_coupons)

                            var CouponDetails = {
                                likedBy: searchinlike.data.length > 0 ? '1' : '0',
                                // coupon_status: (JSON.stringify(userListCouponDao.data[i].result.coupon_validity_to)) > (JSON.stringify(new Date())) ? "Active" : (JSON.stringify(userListCouponDao.data[i].result.coupon_validity_to)) <= (JSON.stringify(new Date())) ? 'Expired' : '',
                                // coupon_claim_status: (userListCouponDao.data[i].claim_count && userListCouponDao.data[i].claim_count) == 0 ? "Claimed" : 'NotClaimed'
                                user_coupon_id: request.body.uid == userListCouponDao.data[i].uid ? userListCouponDao.data[i].user_coupon_id : 'sorry',
                                couponStatus: ((JSON.stringify(userListCouponDao.data[i].result.coupon_validity_to)) > (JSON.stringify(tomorrow)) && userListCouponDao.data[i].result.claimed_coupons<=userListCouponDao.data[i].result.total_Number_of_coupons) ? "Active" : 'Expired' ,
                                // coupon_claim_status: (userListCouponDao.data[i].claim_count && userListCouponDao.data[i].claim_count) == 0 ? "Claimed" : 'NotClaimed'

                            }

                            finalDataArray.push({ ...userListCouponDao.data[i].result, ...CouponDetails })
                            // });
                        }
                    }
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = finalDataArray ? finalDataArray : []
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.claimCouponService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var viewclaimCouponDao = await couponDaoObject.viewCouponDao(request.body)
                if (viewclaimCouponDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    if (viewclaimCouponDao.data.length > 0) {
                        var expirationChecking = await couponDaoObject.expirationChecking(request.body)
                        if (viewclaimCouponDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            if (expirationChecking.data.length > 0) {

                                const userCouponClaimValidationDao = await couponDaoObject.userCouponClaimValidationDao(request.body)
                                // console.log("userCouponClaimValidationDao",userCouponClaimValidationDao,viewclaimCouponDao)

                                if (userCouponClaimValidationDao.error) {
                                    response.error = true
                                    response.statusCode = STRINGS.errorStatusCode
                                    response.message = STRINGS.commanErrorString
                                    resolve(response)
                                } else {
                                    
                                    if (userCouponClaimValidationDao.data.length == 0) {
                                        response.error = false
                                        response.statusCode = STRINGS.successStatusCode
                                        response.message = 'Coupon is not Downloaded'
                                        // response.data = claimCouponDao.data
                                        resolve(response)
                                    } else if (userCouponClaimValidationDao.data.length == 1 && userCouponClaimValidationDao.data[0].claim_count == 0) {
                                        response.error = false
                                        response.statusCode = STRINGS.successStatusCode
                                        response.message = 'Already Claimed Your Coupon Within Your Limit'
                                        // response.data = claimCouponDao.data
                                        resolve(response)
                                    }
                                    else if ((request.body.claim_option == 'claim') && (viewclaimCouponDao.data[0].claimed_coupons < viewclaimCouponDao.data[0].total_Number_of_coupons )&& (userCouponClaimValidationDao.data.length == 1) && (userCouponClaimValidationDao.data[0].claim_count > 0)) {
                                        // console.log("claiming conditions",(request.body.claim_option == 'claim') && (viewclaimCouponDao.data[0].claimed_coupons <= viewclaimCouponDao.data[0].total_Number_of_coupons )&& (userCouponClaimValidationDao.data.length == 1) && (userCouponClaimValidationDao.data[0].claim_count > 0))
                                        var praramClaim = {}
                                        praramClaim.claimed_coupons = (viewclaimCouponDao.data[0].claimed_coupons) + 1
                                        praramClaim.uid = request.body.uid
                                        praramClaim.coupon_id = request.body.coupon_id

                                        var claimCouponDao = await couponDaoObject.claimCouponDao(praramClaim)
                                        if (claimCouponDao.error) {
                                            response.error = true
                                            response.statusCode = STRINGS.errorStatusCode
                                            response.message = STRINGS.commanErrorString
                                            resolve(response)
                                        } else {
                                            var userClaimObj = {}

                                            userClaimObj.user_coupon_id = request.body.user_coupon_id
                                            userClaimObj.coupon_id = request.body.coupon_id
                                            userClaimObj.claim_count = (userCouponClaimValidationDao.data[0].claim_count) - 1

                                            var UserClaimCouponDao = await couponDaoObject.UserClaimCouponDao(userClaimObj)
                                            if (UserClaimCouponDao.error) {
                                                response.error = true
                                                response.statusCode = STRINGS.errorStatusCode
                                                response.message = STRINGS.commanErrorString
                                                resolve(response)
                                            } else {
                                                response.error = false
                                                response.statusCode = STRINGS.successStatusCode
                                                response.message = STRINGS.SuccessString
                                                response.data = UserClaimCouponDao.data
                                                resolve(response)
                                            }
                                            response.error = false
                                            response.statusCode = STRINGS.successStatusCode
                                            response.message = STRINGS.SuccessString
                                            response.data = claimCouponDao.data
                                            resolve(response)
                                        }
                                    }


                                    else if (request.body.claim_option == 'verify' && viewclaimCouponDao.data[0].claimed_coupons <= (viewclaimCouponDao.data[0].total_Number_of_coupons) * viewclaimCouponDao.data[0].usage_limit_per_user && userCouponClaimValidationDao.data.length == 1 && userCouponClaimValidationDao.data[0].claim_count > 0) {
                                        console.log("claimverifying")
                                        response.error = false
                                        response.statusCode = STRINGS.successStatusCode
                                        response.message = 'Coupon_Verified'
                                        // response.data = claimCouponDao.data
                                        resolve(response)

                                    }
                                    else {
                                        response.error = false
                                        response.statusCode = STRINGS.successStatusCode
                                        response.message = 'coupon limit exceeded or something went wrong'
                                        // response.data = claimCouponDao.data
                                        resolve(response)
                                    }
                                }
                                // console.log("claimverifying",request.body.claim_option=='verify',viewclaimCouponDao.data[0].claimed_coupons <= viewclaimCouponDao.data[0].total_Number_of_coupons , userCouponClaimValidationDao.data.length == 1 , userCouponClaimValidationDao.data[0].claim_count > 0);

                            } else {
                                response.error = false
                                response.statusCode = STRINGS.successStatusCode
                                response.message = 'Your Coupon Is Expired'
                                // response.data = claimCouponDao.data
                                resolve(response)
                            }
                        }
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = 'Your Coupon Is Not Available'
                        // response.data = claimCouponDao.data
                        resolve(response)
                    }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.viewImageService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var viewImageDao = await couponDaoObject.viewImageDao(request.body)
                if (viewImageDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = viewImageDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

}
