module.exports = function () {
    const STRINGS = require('../../strings.json')
    require('dotenv').config()
    const GroupChatDao = require('../../dao/web/GroupChatDao')
    const MyProfileDao = require('../../dao/web/MyProfileDao')
    var HomeDao = require('../../dao/web/HomeDao')

    const GroupChatDaoObject = new GroupChatDao()
    const MyprofileObject = new MyProfileDao()
    var common = require('../../utils/common')
    var HomeDaoObject = new HomeDao()

    const commonFunction = common();

    this.createGroupChatService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                request.body.is_active = 1
                var createGroupChatDao = await GroupChatDaoObject.createGroupChatDao(request.body)
                console.log("createGroupChatDao", createGroupChatDao)

                if (createGroupChatDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    var addMember = {
                        role: "owner",
                        memberUid: request.body.uid,
                        chatId: createGroupChatDao.data._id,
                        is_active: 1
                    }

                    var addGroupMembersDao = await GroupChatDaoObject.addGroupMembersDao(addMember)
                    console.log("addGroupMembersDao", addGroupMembersDao)

                    if (addGroupMembersDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = (createGroupChatDao.data && addGroupMembersDao.result) ? createGroupChatDao.data : "Group Creation Failed"
                        resolve(response)
                    }
                }
            }

            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.deleteGroupService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var deleteGroupDao = await GroupChatDaoObject.deleteGroupDao(request.body)
                console.log("deleteAdDao",deleteGroupDao)
                if (deleteGroupDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = deleteGroupDao.data
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.listGroupChatsService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var listGroupChatsCountDao = await GroupChatDaoObject.listGroupChatCountsDao(request.body)
                // console.log("listGroupChatsCountDao", listGroupChatsCountDao)

                if (listGroupChatsCountDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    const totalDatas = listGroupChatsCountDao.result.length;
                    const pageNumber = request.body.page_number - 1 || 0
                    const limit = 10
                    var totalPages = Math.ceil(totalDatas / limit)

                    object.pageNumber = pageNumber
                    object.totalPages = totalPages
                    object.limit = limit

                    const assignInput = { ...request.body, ...object }

                    var listGroupChatsDao = await GroupChatDaoObject.listGroupChatsDao(assignInput)
                    // console.log("listGroupChatsDao", listGroupChatsDao,"totalPages",totalPages)

                    if (listGroupChatsDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        // response.totalPages = totalPages
                        response.totalPages = { totalPages: totalPages, totalCount: listGroupChatsCountDao.result.length, currentPage: request.body.page_number }

                        response.data = listGroupChatsDao.result
                        resolve(response)
                    }
                }
            }

            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }
    
    this.editGroupsService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var editGroupDao = await GroupChatDaoObject.editGroupDao(request.body)
                // console.log("editGroupDao", editGroupDao)

                if (editGroupDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                   
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString

                        response.data = editGroupDao.result.modifiedCount>0?"Modified Successfully":"No Changes Found"
                        resolve(response)
                    // }
                }
            }

            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }
    this.listGroupMembersService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var listGroupMembersCountDao = await GroupChatDaoObject.listGroupMembersCountDao(request.body)
                console.log("listGroupMembersCountDao", listGroupMembersCountDao)

                if (listGroupMembersCountDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    var totalDatas = listGroupMembersCountDao.result;
                    const pageNumber = request.body.page_number - 1 || 0
                    const limit = 10
                    var totalPages = Math.ceil(totalDatas / limit)

                    object.pageNumber = pageNumber
                    object.totalPages = totalPages
                    object.limit = limit

                    const assignInput = { ...request.body, ...object }

                    var listGroupMembersDao = await GroupChatDaoObject.listGroupMembersDao(assignInput)
                    // console.log("getOneProfileDao", getOneProfileDao)

                    if (listGroupMembersDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = { totalPages: totalPages, totalCount: totalDatas, currentPage: request.body.page_number }
                        response.data = listGroupMembersDao.result
                        resolve(response)
                    }
                }
            }

            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.groupMemberRoleService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var groupMemberRoleDao = await GroupChatDaoObject.groupMemberRoleDao(request.body)
                // console.log("groupMemberRoleDao", groupMemberRoleDao)

                if (groupMemberRoleDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {

                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = groupMemberRoleDao.result
                    resolve(response)

                }
            }

            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.addGroupMembersService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                // request.body.memberUid = request.body.addingUid
                request.body.is_active = 1
                // request.body.user_id = request.body.addingUid
                // var getOneProfile = await MyprofileObject.getOneProfileDao(request.body)
                // console.log("getOneProfile", getOneProfile)
                // if (getOneProfile.error) {
                //     response.error = true
                //     response.statusCode = STRINGS.errorStatusCode
                //     response.message = STRINGS.commanErrorString
                //     resolve(response)
                // } else if (getOneProfile.data) {
                // console.log("request.body.addingUid", request.body.addingUid)
                let addGroupMember = null;

                await Promise.all(request.body.addingUid.map(async (e, i) => {
                    var newInputs = {}
                    newInputs = { ...request.body, memberUid: e }
                    var addGroupMembersDao = await GroupChatDaoObject.addMemberIfNotDao(newInputs)

                    if (addGroupMembersDao.message == 'not present') {
                        addGroupMember = await GroupChatDaoObject.addGroupMember(newInputs)
                        console.log("addGroupMember", addGroupMember)
                    }


                }))
                if (addGroupMember && addGroupMember.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = "added successfully"
                    // response.data = 

                    resolve(response)
                }
            }
            //     else {
            //         response.error = true
            //         response.statusCode = STRINGS.errorStatusCode
            //         response.message = "User Not Found"
            //         resolve(response)
            //     }
            // }

            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.sendGroupMessageService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                request.body.senderUid = request.body.uid
                request.body.is_active = 1
                var checkPermissionDao = await GroupChatDaoObject.checkPermissionDao(request.body)
                // console.log("checkPermissionDao", checkPermissionDao)

                if (checkPermissionDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (checkPermissionDao.result.length > 0) {
                    if (request.body.messageType == 'reply') {
                        var sendGroupMessageDao = await GroupChatDaoObject.sendGroupMessageDao(request.body)
                    } else {
                        delete request.body.messageId;
                        var sendGroupMessageDao = await GroupChatDaoObject.sendGroupMessageDao(request.body)
                    }
                    // console.log("getOneProfileDao", getOneProfileDao)
                    // console.log("sendGroupMessageDao", sendGroupMessageDao)

                    if (sendGroupMessageDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {

                        var updateLastMessageDao = await GroupChatDaoObject.updateLastMessageDao(request.body)
                        // console.log("updateLastMessageDao", updateLastMessageDao)

                        if (updateLastMessageDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            const uidBinding = {
                                user_id: request.body.uid
                            }
                            var getOneProfile = await MyprofileObject.getOneProfileDao(uidBinding)
                            if (getOneProfile.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.commanErrorString
                                resolve(response)
                            } else {
                                var listGroupMembersDao = await GroupChatDaoObject.listGroupMembersDao({ chatId: request.body.chatId })
                                // console.log("getOneProfileDao", getOneProfileDao)

                                if (listGroupMembersDao.error) {
                                    response.error = true
                                    response.statusCode = STRINGS.errorStatusCode
                                    response.message = STRINGS.commanErrorString
                                    resolve(response)
                                } else {
                                    response.error = false
                                    response.statusCode = STRINGS.successStatusCode
                                    response.message = STRINGS.SuccessString
                                    response.data = sendGroupMessageDao.result
                                    var socketResponse = {
                                    }
                                    var sendResponse = (sendGroupMessageDao.result).toObject();

                                    if (request.body.messageType == 'reply') {
                                        var validateReplyingMessageDao = await GroupChatDaoObject.validateReplyingMessageDao({ messageId: request.body.messageId })
                                        // console.log("validateReplyingMessageDao", validateReplyingMessageDao)
                                        var socketResponse = {
                                            ...sendResponse,
                                            replyingFor: validateReplyingMessageDao.result,
                                        }
                                    } else {
                                        var socketResponse = {
                                            ...sendResponse,
                                            senderDetails: getOneProfile.data,
                                        }
                                    }
                                    // console.log("socketResponse", socketResponse)
                                    // global.io.emit(sendGroupMessageDao.result.chatId, socketResponse)
                                    // listGroupMembersDao.result.forEach((user) => {
                                    //             console.log("messageFor", user.memberUid)
                                    //             // if (user == MessageReceived.sender[0].uid) return;
                                    //             global.io.in(user.memberUid).emit('receiveGroupMessage', socketResponse);
                                    //           });
                                    console.log("receiveGroupMessagesocketResponse", socketResponse.message, "chatID", request.body.chatId)

                                    global.io.in(request.body.chatId).emit('receiveGroupMessage', socketResponse);

                                    // for sending notifications
                                    await Promise.all(listGroupMembersDao.result.map(async (e, i) => {
                                        global.io.emit(e.memberUid, socketResponse)
                                        // // fcm notification
                                        // var tokendata = await commonFunction.sendNotification(socketResponse)
                                        // console.log("tokendata", tokendata, "getOneProfile", getOneProfile)

                                    }))

                                    resolve(response)
                                }
                            }
                        }
                    }
                } else {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = 'You Are Not A Member Of Chat'
                    resolve(response)
                }
            }

            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.listGroupMessageService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var checkPermissionDao = await GroupChatDaoObject.checkPermissionDao(request.body)
                // console.log("checkPermissionDao", checkPermissionDao)

                if (checkPermissionDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (checkPermissionDao.result.length > 0) {
                    if (checkPermissionDao.result[0].role == 'owner' || checkPermissionDao.result[0].role == 'admin') {

                        var listGroupMessageCountDao = await GroupChatDaoObject.listGroupMessageCountDao(request.body)
                        // console.log("listGroupMessageCountDao", listGroupMessageCountDao)

                        if (listGroupMessageCountDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            const totalDatas = listGroupMessageCountDao.result;
                            const pageNumber = request.body.page_number - 1 || 0
                            const limit = 10
                            var totalPages = Math.ceil(totalDatas / limit)

                            object.pageNumber = pageNumber
                            object.totalPages = totalPages
                            object.limit = limit

                            const assignInput = { ...request.body, ...object }

                            var listGroupMessageDao = await GroupChatDaoObject.listGroupMessageAdminDao(assignInput)
                            await Promise.all(listGroupMessageDao.result.map(async (e, i) => {
                                var listReactionDao = await GroupChatDaoObject.listReactionDao(e, request.body.uid)
                                e.reaction = listReactionDao.result

                                if (e.messageType && e.messageId != null) {
                                    var listGroupReplyDao = await GroupChatDaoObject.listGroupReplyDao(e)
                                    e.replyingFor = listGroupReplyDao.result
                                }

                            }))

                            // console.log("getOneProfileDao", getOneProfileDao)

                            if (listGroupMessageDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.commanErrorString
                                resolve(response)
                            } else {
                                response.error = false
                                response.statusCode = STRINGS.successStatusCode
                                response.message = STRINGS.SuccessString
                                response.totalPages = { totalPages: totalPages, totalCount: listGroupMessageCountDao.result, currentPage: request.body.page_number }
                                response.data = listGroupMessageDao.result
                                resolve(response)
                            }
                        }
                    } else if (checkPermissionDao.result[0].role == 'user') {

                        var listGroupMessageCountHiddenDao = await GroupChatDaoObject.listGroupMessageCountHiddenDao(request.body)
                        // console.log("listGroupMessageCountHiddenDao", listGroupMessageCountHiddenDao)

                        if (listGroupMessageCountHiddenDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            const totalDatas = listGroupMessageCountHiddenDao.result;
                            const pageNumber = request.body.page_number - 1 || 0
                            const limit = 10
                            var totalPages = Math.ceil(totalDatas / limit)

                            object.pageNumber = pageNumber
                            object.totalPages = totalPages
                            object.limit = limit

                            const assignInput = { ...request.body, ...object }

                            var listGroupMessagehiddenDao = await GroupChatDaoObject.listGroupMessagehiddenDao(assignInput)
                            await Promise.all(listGroupMessagehiddenDao.result.map(async (e, i) => {
                                var listReactionDao = await GroupChatDaoObject.listReactionDao(e)
                                e.reaction = listReactionDao.result

                                if (e.messageType && e.messageId != null) {
                                    var listGroupReplyDao = await GroupChatDaoObject.listGroupReplyDao(e)
                                    e.replyingFor = listGroupReplyDao.result
                                }

                            }))

                            // console.log("getOneProfileDao", getOneProfileDao)

                            if (listGroupMessagehiddenDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.commanErrorString
                                resolve(response)
                            } else {
                                response.error = false
                                response.statusCode = STRINGS.successStatusCode
                                response.message = STRINGS.SuccessString
                                response.totalPages = { totalPages: totalPages, totalCount: listGroupMessageCountHiddenDao.result, currentPage: request.body.page_number }
                                response.data = listGroupMessagehiddenDao.result
                                resolve(response)
                            }
                        }
                    }
                } else {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = " you are not a member"
                    resolve(response)
                }
            }
            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.permissionGroupService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var checkPermissionDao = await GroupChatDaoObject.checkPermissionDao(request.body)
                console.log("checkPermissionDao", checkPermissionDao,request.body)

                if (checkPermissionDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (checkPermissionDao.result.length > 0 && (checkPermissionDao.result[0].role == 'owner' || checkPermissionDao.result[0].role == 'admin')) {

                    var writePermissionDao = await GroupChatDaoObject.writePermissionDao(request.body)
                    console.log("writePermissionDao", writePermissionDao)

                    if (writePermissionDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = writePermissionDao.result.modifiedCount > 0 ? "permission modified" : "permission updatation failed"
                        resolve(response)
                    }
                } else {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = "not Permissable"
                    resolve(response)
                }
            }

            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.removeGroupUserService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var checkPermissionDao = await GroupChatDaoObject.checkPermissionDao(request.body)
                // console.log("checkPermissionDao", checkPermissionDao)

                if (checkPermissionDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (checkPermissionDao.result.length > 0 && (checkPermissionDao.result[0].role == 'owner' || checkPermissionDao.result[0].role == 'admin')) {

                    var removeGroupUserDao = await GroupChatDaoObject.removeGroupUserDao(request.body)
                    console.log("removeGroupUserDao", removeGroupUserDao, "count", removeGroupUserDao.result.deletedCount)

                    if (removeGroupUserDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.data = removeGroupUserDao.result.deletedCount > 0 ? "removed user" : "updatation failed"
                        resolve(response)
                    }
                } else {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = "not Permissable"
                    resolve(response)
                }
            }

            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }
    this.deviceTokenUpdateService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                console.log("requestdeviceTokenUpdateService", request.body)
                var deviceTokenUpdateDao = await GroupChatDaoObject.deviceTokenUpdateDao(request.body)
                console.log("deviceTokenUpdateDao", deviceTokenUpdateDao)

                if (deviceTokenUpdateDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    //                     var tokendata = await this.sendNotification({hai:"hai"})
                    // console.log("tokendata",tokendata)
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = deviceTokenUpdateDao.result.modifiedCount > 0 ? "token modified" : "token updatation failed"
                    resolve(response)
                }

            }


            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.hideUnhideService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var checkPermissionDao = await GroupChatDaoObject.checkPermissionDao(request.body)
                // console.log("checkPermissionDao", checkPermissionDao)


                if (checkPermissionDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (checkPermissionDao.result.length > 0) {
                    var getOneProfileDao2 = await MyprofileObject.getOneProfileDao2({ user_id: request.body.uid })
                    console.log("getOneProfileDao2", getOneProfileDao2)

                    if (getOneProfileDao2.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        var hideBy = {
                            uid: getOneProfileDao2.data.uid,
                            full_name: getOneProfileDao2.data.full_name
                        }
                        if (checkPermissionDao.result[0].role == 'owner' || checkPermissionDao.result[0].role == 'admin' || request.body.uid == checkPermissionDao.result[0].memberUid) {
                            var hideUnhideDao = await GroupChatDaoObject.hideUnhideDao(request.body, hideBy)
                            console.log("hideUnhideDao", hideUnhideDao)

                            if (hideUnhideDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.commanErrorString
                                resolve(response)
                            } else {
                                // var tokendata = await this.sendNotification({hai:"hai"})

                                response.error = false
                                response.statusCode = STRINGS.successStatusCode
                                response.message = STRINGS.SuccessString
                                response.data = hideUnhideDao.result.modifiedCount > 0 ? request.body : "document updatation failed"

                                // format one message for reaction
                                var getOneGroupMessageDao = await GroupChatDaoObject.getOneGroupMessageDao(request.body)
                                // console.log("getOneGroupMessageDao",getOneGroupMessageDao)
                                await Promise.all(getOneGroupMessageDao.result.map(async (e, i) => {
                                    var listReactionDao = await GroupChatDaoObject.listReactionDao(e, request.body.uid)
                                    e.reaction = listReactionDao.result

                                    if (e.messageType && e.messageId != null) {
                                        var listGroupReplyDao = await GroupChatDaoObject.listGroupReplyDao(e)
                                        e.replyingFor = listGroupReplyDao.result
                                    }

                                }))
                                if (hideUnhideDao.result.modifiedCount > 0) {
                                    global.io.in(request.body.chatId).emit('hideUnhideGroupMessage', getOneGroupMessageDao.result[0]);
                                    global.io.emit(`hide-${request.body.chatId}`, request.body)
                                }
                                resolve(response)
                            }
                        } else {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = " you are not a admin"
                            resolve(response)
                        }
                    }
                } else {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = " you are not a member"
                    resolve(response)
                }

            }


            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.reactMessageService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                request.body.is_active = 1
                var checkPermissionDao = await GroupChatDaoObject.checkPermissionDao(request.body)
                // console.log("checkPermissionDao", checkPermissionDao)

                if (checkPermissionDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (checkPermissionDao.result.length > 0) {
                    var reactMessageDao = await GroupChatDaoObject.reactMessageDao(request.body)
                    // console.log("reactMessageDao", reactMessageDao)

                    if (reactMessageDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        const uidBinding = {
                            user_id: request.body.uid
                        }
                        var getOneProfile = await MyprofileObject.getOneProfileDao(uidBinding)
                        console.log("getOneProfile", getOneProfile)
                        if (getOneProfile.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.data = (reactMessageDao.result.modifiedCount > 0 || reactMessageDao.result.messageId) ? request.body : "Reaction updatation failed"
                            // var validateReactMessageDao = await GroupChatDaoObject.validateReactMessageDao({ messageId: request.body.messageId })
                            // var getReactionDao = await GroupChatDaoObject.getReactionDao({ messageId: request.body.messageId,uid:request.body.uid })

                            // var reactedMessage=validateReactMessageDao.result[0]
                            // var reaction=getReactionDao.result[0]
                            // console.log('reaction',reactedMessage,reaction)
                            // var userDetail = {}
                            // userDetail.full_name = getOneProfile.data.full_name
                            // userDetail.profile_photo = getOneProfile.data.profile_photo
                            // userDetail.uid = getOneProfile.data.uid

                            // const responseSocket={ ...userDetail, ...request.body }

                            // format one message for reaction
                            var getOneGroupMessageDao = await GroupChatDaoObject.getOneGroupMessageDao(request.body)
                            // console.log("getOneGroupMessageDao",getOneGroupMessageDao)
                            await Promise.all(getOneGroupMessageDao.result.map(async (e, i) => {
                                var listReactionDao = await GroupChatDaoObject.listReactionDao(e, request.body.uid)
                                e.reaction = listReactionDao.result

                                if (e.messageType && e.messageId != null) {
                                    var listGroupReplyDao = await GroupChatDaoObject.listGroupReplyDao(e)
                                    e.replyingFor = listGroupReplyDao.result
                                }

                            }))


                            // console.log('reactGroupMessagesocketResponse', { ...getOneGroupMessageDao.result }, "condition", reactMessageDao.result.modifiedCount > 0 || reactMessageDao.result.messageId)
                            // socketService.sendGroupMessage("reactGroupMessage", request.body);
                            if ((reactMessageDao.result.modifiedCount > 0 || reactMessageDao.result.messageId)) {
                                global.io.in(request.body.chatId).emit('reactGroupMessage', getOneGroupMessageDao.result[0]);
                                global.io.emit(`react-${request.body.chatId}`, request.body)

                            }

                            resolve(response)
                        }
                    }
                } else {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = " you are not a member"
                    resolve(response)
                }

            }


            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.listUsersService = async (request) => {

        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                request.body.is_active = 1
                request.body.pageNumber = request.body.page_number


                // var getTotalUserConnectionListDao = await MyprofileObject.getTotalUserConnectionListDao(request.body)
                const data1Count = await MyprofileObject.getUserConnectionListGroupCountDao(request.body);

                const totalDatas = data1Count.result.length;
                const pageNumber = request.body.page_number - 1 || 0
                const limit = 10
                var totalPages = Math.ceil(totalDatas / limit)

                object.pageNumber = pageNumber
                object.totalPages = totalPages
                object.limit = limit
                const assignInput = { ...request.body, ...object }

                const data1 = await MyprofileObject.getUserConnectionListGroupDao(assignInput);


                console.log('data', data1);

                response.error = false
                response.statusCode = STRINGS.successStatusCode
                response.message = STRINGS.SuccessString
                response.total = {
                    totalPages: totalPages,
                    currentPage: request.body.page_number,
                    totalCount: totalDatas
                }
                response.data = data1
                resolve(response)
            }





            catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }




    this.userGroupSearchService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                if (request.body.search) {

                    request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                    pageNumber = request.body.pageNumber
                    
                    const memberListSearchDao = await GroupChatDaoObject.memberListSearchDao(request.body);
                    const memberUids = memberListSearchDao.result.map(member => member.memberUid);
                    console.log("memberUids",memberUids);

                    // console.log(pageNumber);
                var getBlockedUsers=await this.getBlockedUsers(request.body)

                    var getTotalGroupSearchDao = await HomeDaoObject.getTotalGroupSearchDao(request.body,getBlockedUsers,memberUids)
                    console.log("getTotalGroupSearchDao",getTotalGroupSearchDao);

                    if (getTotalGroupSearchDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        var lenght = getTotalGroupSearchDao.result
                        var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, 10)

                        var userGroupSearchDao = await HomeDaoObject.userGroupSearchDao(request.body,getBlockedUsers,memberUids)
                        if (userGroupSearchDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.commanErrorString
                            resolve(response)
                        } else {
                            // object.articlesList = getArticlesListDao.result
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.totalPages = paginationDetails.totalPages
                            response.data = userGroupSearchDao.result
                            resolve(response)

                        }
                    }
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.totalPages = 0
                    response.data = []
                    return resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }
}