module.exports = function () {
    const likeServicesDao = require('../../dao/web/LikesDao')
    var notificationController = require('../../controller/web/notificationController')
    var notificationControllerObject = new notificationController()

    const STRINGS = require('../../strings.json')
    require('dotenv').config()
    const likeserviceObject = new likeServicesDao()

    this.postLikeService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                if (request.body.type === "unlike") {
                    var persist1 = {
                        is_active: 1
                    };
                    var persist = Object.assign(request.body, persist1)

                    var validate = await likeserviceObject.likeValidation(request.body)
                    var a = validate.data
                    var validating = Object.keys(a).length
                    console.log("validation count", validating)
                    if (validating !== 0) {
                        var postLikeDaoResponse = await likeserviceObject.unLikeDao(persist)

                        var updt = {}
                        var LikeCountDaoResponse = await likeserviceObject.getLikesForOnePostDao(request.body)

                        var a = LikeCountDaoResponse.data
                        updt.updatecount = Object.keys(a).length
                        updt.post_id = request.body.post_id
                        updt.post_type = request.body.post_type
                        updt.uid = request.body.uid

                        var countDaoResponse = await likeserviceObject.putLikeDao(updt)

                        if (countDaoResponse.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.data = postLikeDaoResponse.data

                            resolve(response)
                        }
                    } else {
                        response.data = "You Already Unliked This Post"
                        resolve(response)
                    }
                } else if (request.body.type === "like") {

                    var getOnePostDao = await likeserviceObject.getOnePostDao(request.body)

                    console.log("getOnePostDao")
                    if (getOnePostDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else if (getOnePostDao.data.length > 0) {

                        var validate = await likeserviceObject.likeValidation(request.body)
                        var a = validate.data
                        var validating = Object.keys(a).length
                        if (validating == 0) {

                            var object1 = {}
                            var persist1 = {
                                is_active: 1
                            };
                            var persist = Object.assign(request.body, persist1)

                            var getOneProfileDao = await likeserviceObject.getOneProfileDao(persist)
                            // console.log("likes for onepost", getOneProfileDao)
                            if ((getOneProfileDao.data.length) !== 0) {

                                object1.profile_photo = getOneProfileDao.data[0].profile_photo
                                object1.full_name = getOneProfileDao.data[0].full_name
                                object1.post_id = request.body.post_id
                                object1.uid = request.body.uid
                                object1.post_type = request.body.post_type
                                object1.is_active = 1

                                var postLikeDaoResponse = await likeserviceObject.postLikeDao(object1)
                                console.log("countingoflikkes", postLikeDaoResponse)

                                //  var postLikedBy = await likeserviceObject.PostLikedByDao(object1)


                                var updt = {}
                                var LikeCountDaoResponse = await likeserviceObject.getLikesForOnePostDao(request.body)
                                // console.log("LikeCountDaoResponse", LikeCountDaoResponse)
                                var a = LikeCountDaoResponse.data
                                updt.updatecount = Object.keys(a).length
                                updt.post_id = request.body.post_id
                                updt.post_type = request.body.post_type
                                updt.uid = request.body.uid

                                // console.log("counting o flikkes", LikeCountDaoResponse)
                                var countDaoResponse = await likeserviceObject.putLikeDao(updt)
                                // console.log("counting o flikkes", updt)



                                if (countDaoResponse.error) {
                                    response.error = true
                                    response.statusCode = STRINGS.errorStatusCode
                                    response.message = STRINGS.oopsErrorMessage
                                    resolve(response)
                                } else {
                                    console.log('postType',request.body)

                                    var postType = request.body.post_type == 'foodTripPost' ? 'foodtrip' :
                                        request.body.post_type == 'bazaarCity' ? 'pinoy-market-place' :
                                        request.body.post_type == 'donasayon' ? 'dkny' :
                                        request.body.post_type == 'tambayan' ? 'tambayan':
                                        request.body.post_type == 'coupons' ? 'coupons' : 
                                        request.body.post_type == 'live' ? 'live' : null

                                     
                                    if (postType != null && request.body.uid!= getOnePostDao.data[0].uid) {
                                        // console.log('postType2',request.body,getOnePostDao)
                                        var user_name = getOneProfileDao.data[0].full_name
                                        var user_profile = getOneProfileDao.data[0].profile_photo


                                        var obj = {};
                                        obj.uid = getOnePostDao.data[0].uid
                                        obj.post_id = request.body.post_id
                                        obj.post_type = "Like"
                                        obj.user_name = user_name
                                        obj.user_profile = user_profile
                                        obj.post_module=postType
                                        obj.notification_message = `have Liked your ${postType} post`
                                        obj.is_active = 1
                                        if(postType==='coupons'){
                                            // console.log('getOnePostDao',getOnePostDao.data[0].coupon_id)
                                            obj.couponId=getOnePostDao.data[0].coupon_id
                                        }
                                        request.body.obj = obj
                                        var addNotification = await notificationControllerObject.addNotificationController(request)
                                        console.log("addNotification", addNotification)
                                        if (addNotification.error) {
                                            response.error = true
                                            response.statusCode = STRINGS.errorStatusCode
                                            response.message = STRINGS.oopsErrorMessage
                                            resolve(response)
                                        } else {
                                            response.error = false
                                            response.statusCode = STRINGS.successStatusCode
                                            response.message = STRINGS.SuccessString
                                            response.data = postLikeDaoResponse.data
                                            resolve(response)
                                        }

                                    } else {
                                        response.error = false
                                        response.statusCode = STRINGS.successStatusCode
                                        response.message = STRINGS.SuccessString
                                        response.data = postLikeDaoResponse.data
                                        resolve(response)

                                    }
                                }
                            } else {
                                response.data = "Enter User Id Is Not Valid Please Check It"
                                resolve(response)
                            }
                        } else {
                            response.data = "You Already Liked This Post"
                            resolve(response)
                        }
                    } else {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = "Post Not Found"
                        resolve(response)
                    }
                }

            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.getLikedByService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                var likedByList = await likeserviceObject.likeValidation(request.body)
                if (likedByList.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = likedByList.data.length>0?1:0

                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

}