module.exports = function () {
    var bazaarCityDao = require('../../dao/web/bazaarCityDao')

    const STRINGS = require('../../strings.json')
    const common= require('../../utils/common')
    var commonObject = new common()
    require('../../utils/common')()
    var random = require('random-string-generator')

    require('dotenv').config()
    var bazaarCityDaoObject = new bazaarCityDao()

    const MyProfileDao = require('../../dao/web/MyProfileDao')
    const MyprofileObject = new MyProfileDao()

    this.addBazaarCityItemService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var getOneUserDao = await bazaarCityDaoObject.getOneUserDao(request.body)
                // console.log("getOneUserDao", getOneUserDao)
                var getOnePinoyPreneurDao = await bazaarCityDaoObject.getOnePinoyPreneurDao(request.body)

                if (getOneUserDao.error || getOnePinoyPreneurDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (!getOnePinoyPreneurDao.data) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = 'PinoyPreneur Expired'
                    resolve(response)
                } else if (getOneUserDao.data && getOnePinoyPreneurDao.data) {

                    var object = {
                        uid: request.body.uid,
                        item_name: request.body.item_name,
                        item_images: request.body.item_images,
                        category: request.body.category,
                        price: request.body.price,
                        province_name: request.body.province,
                        is_active: 1,
                        profile_photo: getOneUserDao.data.profile_photo,
                        full_name: getOneUserDao.data.full_name,
                        post_description: request.body.post_description,
                        location: request.body.location
                    }
                    var addPinoyPreneurDao = await bazaarCityDaoObject.addBazaarCityItemDao(object)
                    if (addPinoyPreneurDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        resolve(response)
                    }
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = "user Not Found"
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }




    this.GetBazaarCityListService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var getOneProfileDao = await bazaarCityDaoObject.getOneProfileDao(request.body)

                if (getOneProfileDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                }

                request.body.province = getOneProfileDao.result.province


                request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                pageNumber = request.body.pageNumber
                // console.log(pageNumber);
            
            
                // const getOneBlockedBYDao=await MyprofileObject.getOneBlockedBYDao(request.body)
                // const getOneBlockedUsersDao=await MyprofileObject.getOneBlockedUsersDao(request.body)
                // console.log("getOneBlockedBYDao",getOneBlockedBYDao,getOneBlockedUsersDao);

                // const blockedUsers = getOneBlockedUsersDao.result.map(block => block.uuid); // Array of user IDs that the user has blocked
                // const blockedByUsers = getOneBlockedBYDao.result.map(block => block.actionBy); // Array of user IDs that have blocked the user
                
                var getBlockedUsers=await commonObject.getBlockedUsers(request.body)
                console.log("getBlockedUsers",getBlockedUsers);

                var GetTotalBazaarCityListCountDao = await bazaarCityDaoObject.GetTotalBazaarCityListCountDao(request.body,getBlockedUsers)
                console.log("getTotaltPinoyPreneursListCountDao",GetTotalBazaarCityListCountDao);

                if (GetTotalBazaarCityListCountDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (GetTotalBazaarCityListCountDao.result > 0) {
                    var lenght = GetTotalBazaarCityListCountDao.result
                    var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, 10)

                    var GetBazaarCityListDao = await bazaarCityDaoObject.GetBazaarCityListDao(request.body,getBlockedUsers)
                    if (GetBazaarCityListDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        var length = GetBazaarCityListDao.result.length
                        for (let i = 0; i < length; i++) {
                            var data = {}
                            data.bazzarCityPost_id = GetBazaarCityListDao.result[i]._id
                            data.uid = request.body.uid
                            // console.log("data",data)
                            var GetOneBazaarCityLikedDao = await bazaarCityDaoObject.GetOneBazaarCityLikedDao(data)
                            // console.log("GetOneBazaarCityLikedDao", GetOneBazaarCityLikedDao)
                            if (GetOneBazaarCityLikedDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.commanErrorString
                                resolve(response)
                            } else {
                                GetBazaarCityListDao.result[i].likedBy = GetOneBazaarCityLikedDao.result ? 1 : 0
                            }
                        }

                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = paginationDetails.totalPages
                        response.data = GetBazaarCityListDao.result
                        resolve(response)
                    }
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.totalPages = 0
                    response.data = []
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }



    this.GetOneBazaarCityPostService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}
                // console.log("GetOneBazaarCityPostDao")

                var GetOneBazaarCityPostDao = await bazaarCityDaoObject.GetOneBazaarCityPostDao(request.body)
                //    console.log("GetOneBazaarCityPostDao",GetOneBazaarCityPostDao.result[0].report.length > 0 , GetOneBazaarCityPostDao.result[0].user.length > 0)
                let reported
                if (GetOneBazaarCityPostDao.result[0].report.length > 0) {
                    if (GetOneBazaarCityPostDao.result[0].report[0].userId == request.body.uid) {
                        reported = 1
                    } else {
                        reported = 0
                    }
                } else {
                    reported = 0
                }
                // console.log("=========+>",reported)
                if (GetOneBazaarCityPostDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (GetOneBazaarCityPostDao.result.length > 0) {
                    // request.body.uid = ''
                    var GetOneBazaarCityLikedDao = await bazaarCityDaoObject.GetOneBazaarCityLikedDao(request.body)
                    if (GetOneBazaarCityLikedDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {

                        var checkFeaturePostDao = await bazaarCityDaoObject.checkFeaturePostDao(request.body)
                        var checkUserFeaturePostDao = await bazaarCityDaoObject.checkUserFeaturePostDao(request.body)

                        if (checkFeaturePostDao.error || checkUserFeaturePostDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {

                            object = {
                                _id: GetOneBazaarCityPostDao.result[0]._id,
                                // uid: GetOneBazaarCityPostDao.result[0].uid,
                                item_name: GetOneBazaarCityPostDao.result[0].item_name,
                                item_images: GetOneBazaarCityPostDao.result[0].item_images,
                                category: GetOneBazaarCityPostDao.result[0].category,
                                price: GetOneBazaarCityPostDao.result[0].price,
                                province_name: GetOneBazaarCityPostDao.result[0].province_name,
                                location: GetOneBazaarCityPostDao.result[0].location,
                                profile_photo: GetOneBazaarCityPostDao.result[0].profile_photo,
                                full_name: GetOneBazaarCityPostDao.result[0].full_name,
                                post_description: GetOneBazaarCityPostDao.result[0].post_description,
                                number_of_likes: GetOneBazaarCityPostDao.result[0].number_of_likes,
                                number_of_comments: GetOneBazaarCityPostDao.result[0].number_of_comments,
                                is_active: GetOneBazaarCityPostDao.result[0].is_active,
                                createdAt: GetOneBazaarCityPostDao.result[0].createdAt,
                                FeaturePost: checkFeaturePostDao.result > 0 ? 1 : 0,
                                userFeaturePosted: checkUserFeaturePostDao.result > 0 ? 1 : 0,
                                likedBy: GetOneBazaarCityLikedDao.result ? 1 : 0,
                                reported: reported,
                                my_post: GetOneBazaarCityPostDao.result[0].uid == request.body.uid ? 1 : 0
                            }
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            response.data = object
                            resolve(response)
                        }
                    }
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = "bazaarCity Post Not Exist"
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }

    this.PostSchduleLiveService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var getOneUserDao = await bazaarCityDaoObject.getOneUserDao(request.body)
                // console.log("getOneUserDao", getOneUserDao)
                if (getOneUserDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (getOneUserDao.data) {
                    var getOneScheduleDao = await bazaarCityDaoObject.getOneScheduleDao(request.body)
                    // console.log("getOneScheduleDao", getOneScheduleDao)
                    if (getOneScheduleDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else if (getOneScheduleDao.result) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = "Slot Already Booked"
                        return resolve(response)
                    }
                    var object = {
                        uid: request.body.uid,
                        time_slot: request.body.time_slot,
                        title: request.body.title,
                        short_description: request.body.short_description,
                        live_date: request.body.live_date,
                        start_time: request.body.start_time,
                        end_time: request.body.end_time,
                        session_payment: null,
                        slotId: request.body.slot_id,
                        is_active: 1,
                        profile_photo: getOneUserDao.data.profile_photo,
                        full_name: getOneUserDao.data.full_name
                    }
                    var PostSchduleLiveDao = await bazaarCityDaoObject.PostSchduleLiveDao(object)
                    if (PostSchduleLiveDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        resolve(response)
                    }
                } else {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = "User Not Found"
                    // response.data = "user Not Found"
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.GetAllScheduleLiveListService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var getOneProfileDao = await bazaarCityDaoObject.getOneProfileDao(request.body)

                if (getOneProfileDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                }

                request.body.province = getOneProfileDao.result.province


                request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                pageNumber = request.body.pageNumber
                // console.log(pageNumber);
                var GetTotalScheduleLiveListCountDao = await bazaarCityDaoObject.GetTotalScheduleLiveListCountDao(request.body)
                // console.log("getTotaltPinoyPreneursListCountDao",getTotaltPinoyPreneursListCountDao);

                if (GetTotalScheduleLiveListCountDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (GetTotalScheduleLiveListCountDao.result > 0) {
                    var lenght = GetTotalScheduleLiveListCountDao.result
                    var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, 10)

                    var GetAllScheduleLiveListDao = await bazaarCityDaoObject.GetAllScheduleLiveListDao(request.body)
                    if (GetAllScheduleLiveListDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        var length = GetAllScheduleLiveListDao.result.length


                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = paginationDetails.totalPages
                        response.data = GetAllScheduleLiveListDao.result
                        resolve(response)
                    }
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.totalPages = 0
                    response.data = []
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }

    this.slotTimeListService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}


                var slotTimeListDao = await bazaarCityDaoObject.slotTimeListDao(request.body)
                if (slotTimeListDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {

                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = slotTimeListDao.result
                    resolve(response)
                }

            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }

    this.postSlotService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                request.body.data = [{
                    "slot_id": 1,
                    "slot_time": "09:00 - 10:00 am",
                    "from_time": 9,
                    "to_time": 10,
                    "is_active": 1
                }, {
                    "slot_id": 2,
                    "slot_time": "10:00 - 11:00 am",
                    "from_time": 10,
                    "to_time": 11,
                    "is_active": 1
                }, {
                    "slot_id": 3,
                    "slot_time": "11:00 - 12:00 am",
                    "from_time": 11,
                    "to_time": 12,
                    "is_active": 1
                }, {
                    "slot_id": 4,
                    "slot_time": "12:00 - 01:00 pm",
                    "from_time": 12,
                    "to_time": 13,
                    "is_active": 1
                }, {
                    "slot_id": 5,
                    "slot_time": "01:00 - 02:00 pm",
                    "from_time": 13,
                    "to_time": 14,
                    "is_active": 1
                }, {
                    "slot_id": 6,
                    "slot_time": "02:00 - 03:00 pm",
                    "from_time": 14,
                    "to_time": 15,
                    "is_active": 1
                }, {
                    "slot_id": 7,
                    "slot_time": "03:00 - 04:00 pm",
                    "from_time": 15,
                    "to_time": 16,
                    "is_active": 1
                }, {
                    "slot_id": 8,
                    "slot_time": "04:00 - 05:00 pm",
                    "from_time": 16,
                    "to_time": 17,
                    "is_active": 1
                }, {
                    "slot_id": 9,
                    "slot_time": "05:00 - 06:00 pm",
                    "from_time": 17,
                    "to_time": 18,
                    "is_active": 1
                }, {
                    "slot_id": 10,
                    "slot_time": "06:00 - 07:00 pm",
                    "from_time": 18,
                    "to_time": 19,
                    "is_active": 1
                }, {
                    "slot_id": 11,
                    "slot_time": "07:00 - 08:00 pm",
                    "from_time": 19,
                    "to_time": 20,
                    "is_active": 1
                }, {
                    "slot_id": 12,
                    "slot_time": "08:00 - 09:00 pm",
                    "from_time": 20,
                    "to_time": 21,
                    "is_active": 1
                }, {
                    "slot_id": 13,
                    "slot_time": "09:00 - 10:00 pm",
                    "from_time": 21,
                    "to_time": 22,
                    "is_active": 1
                }, {
                    "slot_id": 14,
                    "slot_time": "10:00 - 11:00 pm",
                    "from_time": 22,
                    "to_time": 23,
                    "is_active": 1
                }]

                request.body.data1 = {
                    "slot_id": 14,
                    "slot_time": "10:00 - 11:00 pm",
                    "from_time": 22,
                    "to_time": 23,
                    "is_active": 1
                }
                var postSlotDao = await bazaarCityDaoObject.postSlotDao(request.body.data1)
                if (postSlotDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {

                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = postSlotDao.result
                    resolve(response)
                }

            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }


    this.GetOneScheduleLiveService = async (request) => {
        var response = {}
        return new Promise(async function (resolve) {
            try {
                var object = {}

                var getOneProfileDao = await bazaarCityDaoObject.getOneProfileDao(request.body)

                if (getOneProfileDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                }


                // console.log(random('numeric'))

                var GetAllScheduleLiveListDao = await bazaarCityDaoObject.GetOneScheduleLiveDao(request.body)
                // console.log("GetAllScheduleLiveListDao",GetAllScheduleLiveListDao.result[0].business_details)
                if (GetAllScheduleLiveListDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else if (GetAllScheduleLiveListDao.result.length > 0) {
                    var pnoy = GetAllScheduleLiveListDao.result
                    var length = GetAllScheduleLiveListDao.result.length
                    var obj = {}
                    obj.live = true
                    obj.post_id = GetAllScheduleLiveListDao.result[0]._id
                    obj.slot_time = GetAllScheduleLiveListDao.result[0].time_slot
                    obj.title = GetAllScheduleLiveListDao.result[0].title
                    obj.short_description = GetAllScheduleLiveListDao.result[0].short_description
                    obj.profile_photo = GetAllScheduleLiveListDao.result[0].profile_photo
                    obj.full_name = GetAllScheduleLiveListDao.result[0].full_name

                    obj.user_id = random('numeric')
                    obj.host = request.body.uid == GetAllScheduleLiveListDao.result[0].uid ? 1 : 0
                    obj.business_details = pnoy.length > 0 ? pnoy[0].business_details : null
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = obj
                    resolve(response)
                } else {
                    var obj = {}
                    obj.live = false
                    obj.post_id = null
                    obj.slot_time = null
                    obj.title = null
                    obj.short_description = null
                    obj.profile_photo = null
                    obj.full_name = null
                    obj.user_id = null
                    obj.host = null
                    obj.business_details = null
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = obj
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }

        })

    }








}