module.exports = function () {
    var jobCentreDao = require('../../dao/web/jobCentreDao')
    var PinoyPreneursDao = require('../../dao/web/PinoyPreneursDao')


    const STRINGS = require('../../strings.json')
    // const common= require('../../utils/common')
    require('../../utils/common')()
    var random = require('random-string-generator');

    require('dotenv').config()
    var jobCentreDaoObject = new jobCentreDao()
    // var commonObject = new common()
    var PinoyPreneursDaoObject = new PinoyPreneursDao()


    this.addJobPostService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'

                var getOneJobPostDao = await jobCentreDaoObject.getOneJobpostDao(request.body)
                // console.log("getOneJobPostDao",getOneJobPostDao)
                if (getOneJobPostDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    var jobId = getOneJobPostDao.result.length == 0 ? 0 : getOneJobPostDao.result[0].job_id
                    var getOneProfileDao = await jobCentreDaoObject.getOneProfileDao(request.body)
                    if (getOneProfileDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {

                        var getSubscriptionDao = await jobCentreDaoObject.getSubscriptionDao(request.body)
                        if (getSubscriptionDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {

                            var obj = {}


                            var start_time = new Date()
                            var date = new Date()
                            var endtime;
                            if (getSubscriptionDao.result.subscription_validity_type == "hours") {
                                obj.subscription_validity = getSubscriptionDao.result.subscription_validity
                                obj.subscription_validity_type = "hours"
                                obj.start_time = start_time
                                endtime = date.setHours(date.getHours() + getSubscriptionDao.result.subscription_validity)
                                obj.end_time = endtime
                            } else if (getSubscriptionDao.result.subscription_validity_type == "day") {
                                obj.subscription_validity = getSubscriptionDao.result.subscription_validity
                                obj.subscription_validity_type = "day"
                                obj.start_time = start_time
                                endtime = date.setDate(date.getDate() + getSubscriptionDao.result.subscription_validity)
                                obj.end_time = endtime
                            } else if (getSubscriptionDao.result.subscription_validity_type == "month") {
                                obj.subscription_validity = getSubscriptionDao.result.subscription_validity
                                obj.subscription_validity_type = "month"
                                obj.start_time = start_time
                                endtime = date.setMonth(date.getMonth() + getSubscriptionDao.result.subscription_validity)
                                obj.end_time = endtime
                            } else if (getSubscriptionDao.result.subscription_validity_type == "year") {
                                obj.subscription_validity = getSubscriptionDao.result.subscription_validity
                                obj.subscription_validity_type = "year"
                                obj.start_time = start_time
                                endtime = date.setFullYear(date.getFullYear() + getSubscriptionDao.result.subscription_validity)
                                obj.end_time = endtime
                            }
                            request.body.is_active = 1
                            request.body.posted_by = getOneProfileDao?.data?.full_name ? getOneProfileDao.data.full_name : ''
                            request.body.job_id = parseInt(jobId) + 1
                            request.body.payment_status = "pending"
                            request.body.end_time = endtime
                            var addJobPostDao = await jobCentreDaoObject.addJobPostDao(request.body)
                            if (addJobPostDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.oopsErrorMessage
                                resolve(response)
                            } else {



                                obj.uid = addJobPostDao.data.uid,
                                    obj.post_id = addJobPostDao.data._id,
                                    obj.post_type = "jobPost",
                                    obj.user_name = getOneProfileDao.data.full_name,
                                    obj.is_active = 1

                                var addJobPostSubscriptionDao = await jobCentreDaoObject.addJobPostSubscriptionDao(obj)
                                if (addJobPostSubscriptionDao.error) {
                                    response.error = true
                                    response.statusCode = STRINGS.errorStatusCode
                                    response.message = STRINGS.oopsErrorMessage
                                    resolve(response)
                                } else {
                                    // console.log(addJobPostSubscriptionDao)
                                    response.error = false
                                    response.statusCode = STRINGS.successStatusCode
                                    response.message = STRINGS.SuccessString
                                    response.data = addJobPostDao.data
                                    resolve(response)
                                }

                            }
                        }
                    }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.getAllJobListService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                request.body.is_active = 1
                request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                var pageNumber = request.body.pageNumber
                var getBlockedUsers=await this.getBlockedUsers(request.body)

                var getTotalJobListDao = await jobCentreDaoObject.getTotalJobListDao(request.body,getBlockedUsers)
                console.log("=========>",getTotalJobListDao)
                if (getTotalJobListDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else if (getTotalJobListDao.result > 0) {
                    var lenght = getTotalJobListDao.result
                    var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, 10)
                    console.log("=========>pagination",paginationDetails)
                    var getAllJobListDao = await jobCentreDaoObject.getAllJobListDao(request.body,getBlockedUsers)
                    if (getAllJobListDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        response.totalPages = paginationDetails.totalPages
                        response.data = getAllJobListDao.result
                        resolve(response)
                    }
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.totalPages = 0
                    response.data = []
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.getOneJobPostService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var getOneJobPostDao = await jobCentreDaoObject.getOneJobPostDao(request.body)
                if (getOneJobPostDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = getOneJobPostDao.result
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.addJobDraftService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var getOneJobDraftDao = await jobCentreDaoObject.getOneJobDraftDao(request.body)
                // console.log("getOneJobDraftDao",getOneJobDraftDao)
                if (getOneJobDraftDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else if (getOneJobDraftDao.result) {
                    var obj = request.body
                    var id = getOneJobDraftDao.result._id
                    var updateJobDraftDao = await jobCentreDaoObject.updateJobDraftDao(obj, id)
                    if (updateJobDraftDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        // response.data = addJobPostDao.data
                        resolve(response)
                    }
                } else {
                    var getOneProfileDao = await jobCentreDaoObject.getOneProfileDao(request.body)
                    if (getOneProfileDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        request.body.is_active = 1
                        request.body.posted_by = getOneProfileDao.data.full_name ? getOneProfileDao.data.full_name : ""
                        var addJobPostDao = await jobCentreDaoObject.addJobDraftDao(request.body)
                        if (addJobPostDao.error) {
                            response.error = true
                            response.statusCode = STRINGS.errorStatusCode
                            response.message = STRINGS.oopsErrorMessage
                            resolve(response)
                        } else {
                            response.error = false
                            response.statusCode = STRINGS.successStatusCode
                            response.message = STRINGS.SuccessString
                            // response.data = addJobPostDao.data
                            resolve(response)
                        }
                    }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.getOneJobDraftService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var getOneJobDraftDao = await jobCentreDaoObject.getOneJobDraftDao(request.body)
                if (getOneJobDraftDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = getOneJobDraftDao.result
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.getJobFairListService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                request.body.is_active = 1
                // request.body.pageNumber = request.body.pageNumber.length == 0 ? 0 : request.body.pageNumber
                // var pageNumber = request.body.pageNumber
                var getBlockedUsers=await this.getBlockedUsers(request.body)

                var getTotalJobFairListDao = await jobCentreDaoObject.getTotalJobFairListDao(request.body,getBlockedUsers)
                console.log("getTotalJobFairListDao",getTotalJobFairListDao)
                if (getTotalJobFairListDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else if (getTotalJobFairListDao.result > 0) {
                    var lenght = getTotalJobFairListDao.result
                    // var paginationDetails = await this.getPaginationDetailsWithSize(lenght, pageNumber, 10)

                    var getJobFairListDao = await jobCentreDaoObject.getJobFairListDao(request.body,getBlockedUsers)
                    if (getJobFairListDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.oopsErrorMessage
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        // response.totalPages = paginationDetails.totalPages
                        response.data = getJobFairListDao.result
                        resolve(response)
                    }
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.totalPages = 0
                    response.data = []
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.createJobPaymentService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {

                // console.log("lowernumeric",random(16,'lowernumeric'))
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                // This is your test secret API key.
                const stripe = require('stripe')('sk_test_51KgyDSLzt7ZdMwoGGI2nblwNLgyv8Z2CqpmSDKt23YAN23ibAQmDFvakalmT59VkenRuPEoCoqVoD4gzRtAk62MU00I047igDt');
                var getOneSubscriptionDetailDao = await jobCentreDaoObject.getOneSubscriptionDetailDao(request.body)
                if (getOneSubscriptionDetailDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.commanErrorString
                    resolve(response)
                } else {
                    var price = getOneSubscriptionDetailDao.result.subscription_fee
                    const storeItems = {
                        priceInCents: price * 100,
                        name: "ONE JOB POST"
                    }

                    const YOUR_DOMAIN = 'http://mykapitbahay.com/job-centre/';
                    const session = await stripe.checkout.sessions.create({
                        payment_method_types: ['card'],
                        line_items: [{
                            price_data: {
                                currency: 'CAD',
                                product_data: {
                                    name: storeItems.name,
                                    description: "Job Post"
                                },
                                unit_amount_decimal: storeItems.priceInCents
                            },
                            quantity: 1,
                        }],
                        metadata: {
                            post_id: request.body.post_id,
                            type: "job_centre",
                            payment_amount: `${price}`
                        },
                        mode: 'payment',
                        client_reference_id: request.body.uid,
                        success_url: `${YOUR_DOMAIN}?success=true`,
                        cancel_url: `${YOUR_DOMAIN}?canceled=true`,
                    });

                    // res.redirect(303, session.url);
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = session.url
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


    this.webhookService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {


                const stripe = require('stripe')('sk_test_51KgyDSLzt7ZdMwoGGI2nblwNLgyv8Z2CqpmSDKt23YAN23ibAQmDFvakalmT59VkenRuPEoCoqVoD4gzRtAk62MU00I047igDt');

                const payload = request.body
                const sig = request.headers['stripe-signature'];
                const endpointSecret = 'whsec_qXohpQFTRBgdHe3ReApF8k2YuLFPQJhR';
                
                // console.log("========>headers",request.headers)
                // console.log("========>body",request.body)
                // console.log("========>rawbody",request.rawBody)
                // console.log("========>dtasig",sig)

                // let event;

                // try {
                //     event = stripe.webhooks.constructEvent(payload, sig, endpointSecret);
                // } catch (err) {
                //     console.log(err)
                //     response.error = true
                //     response.statusCode = STRINGS.errorStatusCode
                //     response.message = STRINGS.commanErrorString
                //     return resolve(response)
                // }
                // console.log("==========>event",payload.type)
                // console.log("==========>event",payload.data.object)

                // Handle the checkout.session.completed event
                if (payload.type === 'checkout.session.completed') {
                    const session = payload.data.object;
                    var obj = {};
                    console.log("session", session)
                    obj.uid = session.client_reference_id
                    obj.post_id = session.metadata.post_id
                    obj.post_type = session.metadata.type
                    obj.payment_ref_id = session.id
                    obj.amount_total = session.metadata.payment_amount
                    obj.payment_status = session.payment_status
                    obj.livemode = session.livemode
                    obj.status = session.status
                    obj.payment_method_types = session.payment_method_types
                    obj.is_active = 1
                    if (session.payment_status === 'paid' && session.status === 'complete') {

                        if (session.metadata.type == 'job_centre') {
                            var updatePostStatusDao = await jobCentreDaoObject.updatePostStatusDao(obj)
                            if (updatePostStatusDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.commanErrorString
                                return resolve(response)
                            } else {
                                var clearJobDraftDao = await jobCentreDaoObject.clearJobDraftDao(obj)
                                if (clearJobDraftDao.error) {
                                    response.error = true
                                    response.statusCode = STRINGS.errorStatusCode
                                    response.message = STRINGS.commanErrorString
                                    return resolve(response)
                                }
                            }
                        } else if (session.metadata.type == 'pinoy_preneur') {
                            let object = {}

                            var start_time = new Date()
                            var date = new Date()
                            var endtime;
                            let validity = parseInt(session.metadata.subscription_validity)

                            if (session.metadata.subscription_validity_type == "hours") {
                                object.subscription_validity = validity
                                object.subscription_validity_type = "hours"
                                object.start_time = start_time
                                endtime = date.setHours(date.getHours() + validity)
                                object.end_time = endtime
                            } else if (session.metadata.subscription_validity_type == "day") {
                                object.subscription_validity = validity
                                object.subscription_validity_type = "day"
                                object.start_time = start_time
                                endtime = date.setDate(date.getDate() + validity)
                                object.end_time = endtime
                            } else if (session.metadata.subscription_validity_type == "month") {
                                object.subscription_validity = validity
                                object.subscription_validity_type = "month"
                                object.start_time = start_time
                                endtime = date.setMonth(date.getMonth() + validity)
                                object.end_time = endtime
                                // console.log("object", object)
                            } else if (session.metadata.subscription_validity_type == "year") {
                                object.subscription_validity = validity
                                object.subscription_validity_type = "year"
                                object.start_time = start_time
                                endtime = date.setFullYear(date.getFullYear() + validity)
                                object.end_time = endtime
                            }
                            object.uid = session.client_reference_id,
                                object.post_id = session.metadata.post_id,
                                object.post_type = "businessDirectory",
                                object.user_name = session.metadata.full_name,
                                object.is_active = 1
                            var addJobPostSubscriptionDao = await PinoyPreneursDaoObject.addJobPostSubscriptionDao(object)
                            if (addJobPostSubscriptionDao.error) {
                                response.error = true
                                response.statusCode = STRINGS.errorStatusCode
                                response.message = STRINGS.oopsErrorMessage
                                resolve(response)
                            } else {
                                let obj1 = {
                                    PinoyPreneur_id: session.metadata.post_id
                                }
                                let data = {
                                    end_time: object.end_time
                                }
                                var updatePinoyPreneurDao = await PinoyPreneursDaoObject.updatePinoyPreneurDao(obj1, data)
                                if (updatePinoyPreneurDao.error) {
                                    response.error = true
                                    response.statusCode = STRINGS.errorStatusCode
                                    response.message = STRINGS.commanErrorString
                                    return resolve(response)
                                } else {
                                    response.error = false
                                    response.statusCode = STRINGS.successStatusCode
                                    response.message = STRINGS.SuccessString
                                    return resolve(response)
                                }
                            }
                        }
                    }
                    var savePaymentDao = await jobCentreDaoObject.savePaymentDao(obj)
                    if (savePaymentDao.error) {
                        response.error = true
                        response.statusCode = STRINGS.errorStatusCode
                        response.message = STRINGS.commanErrorString
                        resolve(response)
                    } else {
                        response.error = false
                        response.statusCode = STRINGS.successStatusCode
                        response.message = STRINGS.SuccessString
                        resolve(response)
                    }
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }



    this.editOneJobPostService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {

                var obj = Object.assign({}, request.body)
                delete obj["post_id"]
                console.log(request.body)
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'
                var editOneJobPostDao = await jobCentreDaoObject.editOneJobPostDao(request.body, obj)
                if (editOneJobPostDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = editOneJobPostDao.result
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }

    this.getOneJobFairService = async (request) => {
        const response = {}
        return new Promise(async function (resolve) {
            try {
                // request.body.uid = '4c19d0cd-aa55-4751-a43a-efc9ef6e63c8'


                var getOneJobFairDao = await jobCentreDaoObject.getOneJobFairDao(request.body)
                if (getOneJobFairDao.error) {
                    response.error = true
                    response.statusCode = STRINGS.errorStatusCode
                    response.message = STRINGS.oopsErrorMessage
                    resolve(response)
                } else {
                    response.error = false
                    response.statusCode = STRINGS.successStatusCode
                    response.message = STRINGS.SuccessString
                    response.data = getOneJobFairDao.result
                    resolve(response)
                }
            } catch (e) {
                console.log(e)
                response.error = true
                response.statusCode = STRINGS.errorStatusCode
                response.message = STRINGS.oopsErrorMessage
                resolve(response)
            }
        })
    }


}